#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# banners.cgi for admin/banners                                               #
# v0.9.9.3.4                                                                  #
# Javascript banner rotation removed by Carter v0.9.4                         #
# Option on/off for banners by SimonJ 0.9.9.3                                 #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified by SimonJ for v0.9.9.3                                       #
# Modified: 12 Apr, 14 June 2006 by my2cents                                  #
# Modified: 12 May, 13 Aug 2006 by Jos ("bantychick")                         #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

if ( $action eq "addbanner" ) { addbanner(); }
elsif ( $action eq "addbanner2" ) { addbanner2(); }
elsif ( $action eq "editbanner" ) { editbanner(); }
elsif ( $action eq "editbanner2" ) { editbanner2(); }
elsif ( $action eq "deletebanner" ) { deletebanner(); }

elsif ( $action eq "editinactive" ) { editinactive(); }
elsif ( $action eq "editinactive2" ) { editinactive2(); }
elsif ( $action eq "makeinactive" ) { makeinactive(); }
elsif ( $action eq "makeactive" ) { makeactive(); }
elsif ( $action eq "deleteinactive" ) { deleteinactive(); }
# end SimonJ

else { viewbanner(); }

################
sub viewbanner {
################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB,"<$datadir/banners/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);

	open (INORGDB,"<$datadir/banners/inactive.txt");
	hold(INORGDB);
	@INODB=<INORGDB>;
	release(INORGDB);
	close (INORGDB);

	$navbar = "$btn{'014'} $nav{'061'} $btn{'014'} $banner{'015'}";
	print_top();

	print qq~<table width='100%' cellspacing="1" cellpadding="3" border='1'>
<tr>
<td colspan="3" align="left" class="forumwindow3">
<a href="$pageurl/admin/banners.cgi?action=addbanner">$banner{'002'}</a></td>
</tr>
<tr>
<td align="center" class="forumwindow1"><b>$banner{'012'}</b></td>
<td align="center" class="forumwindow1"><b>$banner{'018'}</b></td>
<td align="center" class="forumwindow1"><b>$banner{'017'}</b></td>
</tr>
~;

	$bancount = 0;
	foreach $rec (@ODB){
		chomp($rec);
		($banurl,$iban,$iw,$ih,$alt,$hits)=split(/\|/,$rec);
		if ($hits eq "") {$hits = 0;}
		$siw = ($iw/2); $sih = ($ih/2);

		print qq~<tr>
<td align="center" width="20%" class="forumwindow1"><a
 href="$pageurl/admin/banners.cgi?action=editbanner&amp;bancount=$bancount">$banner{'013'}</a> - <a
 href="$pageurl/admin/banners.cgi?action=makeinactive&amp;bancount=$bancount">$banner{'019'}</a> - <a
 href="$pageurl/admin/banners.cgi?action=deletebanner&amp;bancount=$bancount">$banner{'014'}</a></td>
<td align="center" width="70%" class="forumwindow1"><a
 href="$banurl" target="_blank" class="bannerlink"><img
 src="$iban" width="$siw" height="$sih" alt="$alt" border="0"></a></td>
<td align="center" width="15%" class="forumwindow1">$hits</td>
</tr>
~;

		$bancount++;
	}
	$bancount2 = 0;

	foreach $rec (@INODB){
		chomp($rec);
		($banurl,$iban,$iw,$ih,$alt,$hits)=split(/\|/,$rec);
		if ($hits eq "") {$hits = 0;}
		$siw = ($iw/2); $sih = ($ih/2);

		print qq~<tr>
<td align="center" width="20%" class="forumwindow5"><a
 href="$pageurl/admin/banners.cgi?action=editinactive&amp;bancount2=$bancount2">$banner{'013'}</a> - <a
 href="$pageurl/admin/banners.cgi?action=makeactive&amp;bancount2=$bancount2">$banner{'020'}</a> - <a
 href="$pageurl/admin/banners.cgi?action=deleteinactive&amp;bancount2=$bancount2">$banner{'014'}</a></td>
<td align="center" width="70%" class="forumwindow5"><a
 href="$banurl" target="_blank" class="bannerlink"><img
 src="$iban" width="$siw" height="$sih" alt="$alt" border="0"></a></td>
<td align="center" width="15%" class="forumwindow5">$hits</td>
</tr>
~;
		$bancount2++;
	}

	print qq~<tr>
<td colspan="3" align="left" class="forumwindow3"><a
 href="$pageurl/admin/banners.cgi?action=addbanner">$banner{'002'}</a></td>
</tr>
</table>
<br>
~;

	print_bottom();
	exit;

}

############### 
sub addbanner {
###############

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }
	 
	$navbar = "$btn{'014'} $nav{'061'} $btn{'014'} $banner{'002'}"; 
	print_top(); 
 
	print qq~<font face='Arial'><b><i>$banner{'002'}</i></b></font> 
<form action="$pageurl/admin/banners.cgi?action=addbanner2" method="post"> 
<table border='1'> 
<tr>
<td><font size='2'>$banner{'003'}</font></td>
<td><input type="text" class="textinput" name="nbanurl"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'004'}</font></td>
<td><input type="text" class="textinput" name="niban"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'005'}</font></td>
<td><input type="text" class="textinput" name="niw"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'006'}</font></td>
<td><input type="text" class="textinput" name="nih"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'007'}</font></td>
<td><input type="text" class="textinput" name="nalt"></td>
</tr> 
</table>
<input type="submit" class="button" value="$banner{'002'}"></form>~; 
 
	print_bottom();
	exit; 
} 

################
sub addbanner2 {
################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); } 
		
	open (DATABASE1,">>$datadir/banners/data.txt");
	hold(DATABASE1);
	print DATABASE1 "$input{'nbanurl'}|$input{'niban'}|$input{'niw'}|$input{'nih'}|$input{'nalt'}|0\n";
	release(DATABASE1);
	close (DATABASE1);

	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}

################
sub editbanner {
################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'061'} $btn{'014'} $banner{'010'}"; 
	print_top(); 

	$bancount = $info{'bancount'};

	open (ORGDB,"<$datadir/banners/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);
	
	$thisban = @ODB[$bancount];
	($banurl,$iban,$iw,$ih,$alt,$hits)=split(/\|/,$thisban);

	print qq~<font face='Arial'><b><i>$banner{'010'}</i></b></font> 
<form action="$pageurl/admin/banners.cgi?action=editbanner2" method="post">
<input type='hidden' name='bancount' value="$bancount">
<table border='1'> ~;

	print qq~<tr>
<td><font size='2'>$banner{'003'}</font></td>
<td><input type="text" class="textinput" name="nbanurl" value="$banurl"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'004'}</font></td>
<td><input type="text" class="textinput" name="niban" value="$iban"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'005'}</font></td>
<td><input type="text" class="textinput" name="niw" value="$iw"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'006'}</font></td>
<td><input type="text" class="textinput" name="nih" value="$ih"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'007'}</font></td>
<td><input type="text" class="textinput" name="nalt" value="$alt"></td>
</tr>
<tr>
<td><font size='2'>$banner{'017'}</font></td>
<td><input type='hidden' name='hits' value="$hits">$hits</td>
</tr> 
</table>
<input type="submit" class="button" value="$banner{'010'}"></form>~; 
 
	print_bottom();
	exit; 

}

#################
sub editbanner2 {
#################

	$bancount = $input{'bancount'};

	open (ORGDB,"<$datadir/banners/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);

	$input{'hits'} =~ s/[\n\r]//g;

	@ODB[$bancount] = "$input{'nbanurl'}|$input{'niban'}|$input{'niw'}|$input{'nih'}|$input{'nalt'}|$input{'hits'}\n"; # SimonJ changed to this
	open(DATABASE,">$datadir/banners/data.txt");
	hold(DATABASE);
	print DATABASE @ODB; # SimonJ
	release(DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}

##################
sub deletebanner {
##################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$bancount = $info{'bancount'};
	
	open (ODB,"<$datadir/banners/data.txt");
	hold(ODB);
	@ODB=<ODB>;
	release(ODB);
	close (ODB);

	@ODB[$bancount] = "";

	open (DATABASE,">$datadir/banners/data.txt");
	hold(DATABASE);
	print DATABASE @ODB;
	release(DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;

}

##################
sub makeinactive {
##################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }
	
	$bancount = $info{'bancount'};
	
	open (ODB,"<$datadir/banners/data.txt");
	hold(ODB);
	@ODB=<ODB>;
	release(ODB);
	close (ODB);
	
	$inactive = @ODB[$bancount];
	
	@ODB[$bancount] = "";
	
	open (DATABASE,">$datadir/banners/data.txt");
	hold(DATABASE);
	print DATABASE @ODB;
	release(DATABASE);
	close (DATABASE);
	
	open (DATABASE,">>$datadir/banners/inactive.txt");
	hold(DATABASE);
	print DATABASE $inactive;
	release(DATABASE);
	close (DATABASE);
	
	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}

##################
sub makeactive {
##################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }
	
	$bancount = $info{'bancount2'};
	
	open (INODB,"<$datadir/banners/inactive.txt");
	hold(INODB);
	@INODB=<INODB>;
	release(INODB);
	close (INODB);
	
	$active = @INODB[$bancount];
	
	@INODB[$bancount] = "";
	
	open (DATABASE,">$datadir/banners/inactive.txt");
	hold(DATABASE);
	print DATABASE @INODB;
	release(DATABASE);
	close (DATABASE);
	
	open (DATABASE1,">>$datadir/banners/data.txt");
	hold(DATABASE1);
	print DATABASE1 $active;
	release(DATABASE1);
	close (DATABASE1);
	
	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}
##################
sub deleteinactive {
##################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }
	
	$bancount = $info{'bancount2'};
	
	open (INDB,"<$datadir/banners/inactive.txt");
	hold(INDB);
	@INDB=<INDB>;
	release(INDB);
	close (INDB);
	
	@INDB[$bancount] = "";
	
	open (DATABASE,">$datadir/banners/inactive.txt");
	hold(DATABASE);
	print DATABASE @INDB;
	release(DATABASE);
	close (DATABASE);
	
	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}

################
sub editinactive {
################

	check_access("editbanner"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $nav{'061'} $btn{'014'} $banner{'010'}"; 
	print_top(); 
	$bancount = $info{'bancount2'};
	
	print qq~<font face='Arial'><b><i>$banner{'010'}</i></b></font> 
<form action="$pageurl/admin/banners.cgi?action=editinactive2" method="post">
<input type='hidden' name='bancount2' value="$bancount">
~;
	
	open (ORGDB,"<$datadir/banners/inactive.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);
	
	$thisban = @ODB[$bancount];
	($banurl,$iban,$iw,$ih,$alt,$hits)=split(/\|/,$thisban);
	
	print qq~<table border='1'>~;

	print qq~<tr>
<td><font size='2'>$banner{'003'}</font></td>
<td><input type="text" class="textinput" name="nbanurl" value="$banurl"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'004'}</font></td>
<td><input type="text" class="textinput" name="niban" value="$iban"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'005'}</font></td>
<td><input type="text" class="textinput" name="niw" value="$iw"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'006'}</font></td>
<td><input type="text" class="textinput" name="nih" value="$ih"></td>
</tr> 
<tr>
<td><font size='2'>$banner{'007'}</font></td>
<td><input type="text" class="textinput" name="nalt" value="$alt"></td>
</tr>
<tr>
<td><font size='2'>$banner{'017'}</font></td>
<td><input type='hidden' name='hits' value="$hits">$hits</td>
</tr> 
</table>
<input type="submit" class="button" value="$banner{'010'}"></form>
~; 
 
	print_bottom();
	exit; 
}

###################
sub editinactive2 {
###################
	
	$bancount = $input{'bancount2'};
	
	open (ORGDB,"<$datadir/banners/inactive.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);

	$input{'hits'} =~ s/[\n\r]//g; # added for newline added next line - Jos

	@ODB[$bancount] = "$input{'nbanurl'}|$input{'niban'}|$input{'niw'}|$input{'nih'}|$input{'nalt'}|$input{'hits'}\n"; # SimonJ changed to this
	
	open(DATABASE,">$datadir/banners/inactive.txt");
	hold(DATABASE);
	print DATABASE @ODB;
	release(DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/banners.cgi\n\n"; 
	exit;
}

1;