#!/usr/bin/perl -w

$^W = 0;

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# galupload.cgi                                                               #
# v0.9.9.3.4                                                                  #
# For the Gallery-APP program                                                 #
# Original Written by M. Carter Brown and offered as a Gift to                #
# the Beta Development crew for WebAPP v0.9.9.3 in Winter of 1995             #
# WebAPP Integration and Move to admin folder by: SimonJ                      #
# Security Update by: Jos Brown (www.bantychick.com)                          #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 14 Nov 2005 by SimonJ                                       #
# Modified: by Jos Nov 15, Dec 19 2005 by Jos                                 #
# Modified: 12 Apr 2006 by my2cents                                           #
###############################################################################
###############################################################################

# eval {;
BEGIN { # BEGIN, so use lib is not processed before compile time
require "../config.pl"; # main prog config
require "$sourcedir/subs.pl"; # main prog subs
}

use lib "$sourcedir";
use Image::Size;

readthislang();
$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);
loadcookie();
loaduser();

# variables specific to image uploading
$userimgs = "$imagesurl/memberpics/$username";
$userimgsdir = "$imagesdir/memberpics/$username";

@good_extensions = ('gif', 'jpg', 'jpeg', 'png', 'GIF', 'JPG', 'JPEG', 'PNG');
@bad_extensions = ();

# maximum file size allowed (in kilobytes)
# if set to 0 or left blank (or commented out), the file size will NOT be checked
$max_size = 275;

# start 

use CGI; 
$max_num_files = 1; 
$tempimgsdir 		||= $ENV{'DOCUMENT_ROOT'};
undef @bad_extensions if @good_extensions;
for(my $a = 1; $a <= $max_num_files; $a++) {
	my $req = new CGI; 
	if($req->param("FILE$a")) {
		my $file = $req->param("FILE$a");
		my $filename = $file; 
		$filename =~ s/^.*(\\|\/)//;
		$filename =~ s/ +/\_/g;
		$filename =~ s/[\#\&]//g;
		my $proceed_type = 0;
		if(@good_extensions) {
			foreach(@good_extensions) {
				my $ext = $_;
				$ext =~ s/\.//g;
				if($filename =~ /\.$ext$/) {
					$proceed_type = 1;
					last;
				}
			}
			unless($proceed_type) {
				push(@was_not_good_type, $filename);
			}
		}
		elsif(@bad_extensions) {
			$proceed_type = 1;
			foreach(@bad_extensions) {
				my $ext = $_;
				$ext =~ s/\.//g;
				if($filename =~ /\.$ext$/) {
					$proceed_type = 0;
					last;
				}
			}
			unless($proceed_type) {
			push(@was_a_bad_type, $filename);
			}
		}
###
		elsif ($filename =~ /\..*\./) { # prevent doubled file extensions
			$proceed_type = 0;
			push(@did_not_save, $filename);
		}
###
		else {
			$proceed_type = 1;
		}

		if($proceed_type) {
			# bm mod
			unless (-e("$userimgsdir")) {
				mkdir("$userimgsdir",0777);
				chmod(0777,"$userimgsdir");
			}
			if (-e("$userimgsdir/$filename")) { # same name exists in temp directory!
				push(@file_exists, $filename);
			}
			else {
				if(open(OUTFILE, ">$userimgsdir/$filename")) {
					while (my $bytesread = read($file, my $buffer, 1024)) {
						print OUTFILE $buffer; 
					} 
					close (OUTFILE);
					push(@file_did_save, $filename);
				}
				else {
					push(@did_not_save, $filename);
				}
			}

			$imagename = "$userimgsdir/$filename"; # added for using image::size
			($x, $y) = imgsize($imagename);
			# if no width or height or if text:
			if ((!$x || !$y) || (-T "$userimgsdir/$filename")) {
				unlink("$userimgsdir/$filename");
				push(@did_not_save, $filename);
				undef @file_did_save;
			} else {
				if($max_size) {
					if((-s "$userimgsdir/$filename") > ($max_size * 1024)) {
						push(@was_too_big, $filename);
						undef @file_did_save; # bm mod
						unlink("$userimgsdir/$filename");
					}
				}
			}
		}
		
		getlanguage(); 
		loadcookie();
		loaduser();
		if ($lang_support eq "1") { mod_langsupp(); }
		
 		print "Pragma: no-cache\n";
		$returnlink = "<a href=\"javascript:history.go(-1)\">$class_upl{'018'}</a>";
		print "Content-type: text/html\n\n";
		print qq~
		<HEAD>
			<TITLE>$class_upl{'010'}</TITLE>
		</HEAD>
		<BODY>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
		<td align="left" valign="top">
		<font size="3">
		<B>$class_upl{'010'}</B></font>
		<HR WIDTH="100%" noshade></td></tr><tr><td><font size="2">
		~;
		if(@file_did_save) {
			print "<B>$class_upl{'011'}\n"; 
			print join(":&nbsp;", @file_did_save); 
			print "<BR><BR>\n";
			print "<center><a href=\"$userimgs/$filename\" target=\"_blank\"><img src=\"$userimgs/$filename\" height=\"150\" border=\"0\" alt=\"\"></a>";
			print "<br><a href=\"javascript:window.close()\">$msg{'603'}</a></center>"
		}
		if(@was_not_good_type) {print "<B>$class_upl{'012'}<BR><BR>\n"; print join("<BR>", @was_not_good_type); print "<BR><BR>$returnlink\n"}
		if(@was_a_bad_type) {print "<B>$class_upl{'013'}<BR><BR>\n"; print join("<BR>", @was_a_bad_type); print "<BR><BR>$returnlink\n"}
		if(@was_too_big) {print "<B>$class_upl{'014'}<BR><BR>$returnlink\n"}
		if(@file_exists) {print "<B>$class_upl{'015'}<BR><BR>$returnlink\n"}
		if(@did_not_save) {print "<B>$class_upl{'016'}<BR><BR>\n"; print join("<BR>", @did_not_save);print "<BR><BR>$returnlink\n";
		if(!@file_did_save) {print "<BR><BR><FONT COLOR=\"RED\"><B>$class_upl{'017'}</B></FONT>"}
		}
		print "</font></td></tr></table></body></html>";
	}
	else { # not uploading?
	
		print "Content-type: text/html\n\n"; 
		print qq~
		<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

		<html>
		<head>
		<title>$pagetitle $class_upl{'001'}</title> 
		<link rel="stylesheet" href="$themesurl/$usertheme/style.css" type="text/css"> 
			<script language="javascript">
			function xferME() {
				self.opener.document.creator.adimg.value = document.uploader.FILE1.value;
			}
			</script>
		</head>

		<body>
		
		<table border="0" cellpadding="10" cellspacing="0" width="100%">
		<tr>
			<td align="left" valign="top">
			<font size="2">
			$class_upl{'002'}
			<p>
			$class_upl{'003'}
			<BR><OL>
			<b>$class_upl{'004'}</b>
			<LI>$class_upl{'005'}
			<LI>$class_upl{'006'}
			<LI>$class_upl{'007'}
			</OL>
			<FORM METHOD="POST" ACTION="$sourceurl/gallery.pl?action=galuploadpicture" ENCTYPE="multipart/form-data" name="uploader">
			<input type="hidden" name="action" value="upload">
			$class_upl{'009'}: <INPUT TYPE="FILE" NAME="FILE1" size="40" onchange="javascript:xferME()">
			<p>
			<input type="submit" class="button" value="$class_upl{'008'} $class_upl{'009'}">
		</FORM>
			</font></td>
		</tr>
		</table>
		</body>
		</html>
		~;
		exit;
	}
}

##################
sub readthislang {
##################

	$class_user{'001'} = "Classifieds"; # navbar
	$class_user{'002'} = "Submit an Ad"; # navbar
	$class_user{'003'} = "Choose a category to list all Ads within it."; # info on main category page
	$class_user{'004'} = "Place an Ad"; # link text
	$class_user{'005'} = "ads in this section"; # info text (no longer used)
	$class_user{'006'} = "Submitted by"; 
	$class_user{'007'} = "Name"; # used in several places; should remain capitalized
	$class_user{'008'} = "E-Mail"; # used in several places; should remain capitalized
	$class_user{'009'} = "Category"; # used in several places; should remain singular and capitalized
	$class_user{'010'} = "$btn{'014'}"; # set equivalent to your $btn{'014'} in the main site language file (decoration)
	$class_user{'011'} = "Success!"; # info text
	$class_user{'012'} = "Your ad has been saved."; # admin sees this msg
	$class_user{'013'} = "Your ad has been saved, however it still needs to be verified by the site Administrator. You will be notified once it has been approved."; # members see this msg
	$class_user{'014'} = qq~You may <a href="$classurl/index.cgi?action=postads">place</a> another ad, or <a href="$classurl/index.cgi">view</a> the latest ads.~;
	$class_user{'015'} = "Place Ad"; # button
	$class_user{'016'} = "Reset"; # button
	$class_user{'017'} = "Font Colour";
	$class_user{'018'} = "Bold";
	$class_user{'019'} = "Italic";
	$class_user{'020'} = "Underline";
	$class_user{'021'} = "Center";
	$class_user{'022'} = "Insert hyperlink";
	$class_user{'023'} = "Insert e-mail";
	$class_user{'024'} = "Insert list";
	$class_user{'025'} = "Insert smilie";
	$class_user{'026'} = "Black";
	$class_user{'027'} = "Red";
	$class_user{'028'} = "Yellow";
	$class_user{'029'} = "Pink";
	$class_user{'030'} = "Green";
	$class_user{'031'} = "Orange";
	$class_user{'032'} = "Purple";
	$class_user{'033'} = "Blue";
	$class_user{'034'} = "Beige";
	$class_user{'035'} = "Brown";
	$class_user{'036'} = "Teal";
	$class_user{'037'} = "Navy";
	$class_user{'038'} = "Maroon";
	$class_user{'039'} = "Lime";
	$class_user{'040'} = "<B>This is an auto-generated message.</B><P>The following ad from";
	$class_user{'041'} = "is awaiting approval";
	$class_user{'042'} = "January";
	$class_user{'043'} = "February";
	$class_user{'044'} = "March";
	$class_user{'045'} = "April";
	$class_user{'046'} = "May";
	$class_user{'047'} = "June";
	$class_user{'048'} = "July";
	$class_user{'049'} = "August";
	$class_user{'050'} = "September";
	$class_user{'051'} = "October";
	$class_user{'052'} = "November";
	$class_user{'053'} = "December";
	$class_user{'054'} = "Expires";
	$class_user{'055'} = "has been modified";
	$class_user{'056'} = "UBBC Tags:";
	$class_user{'057'} = "Bold Text";
	$class_user{'058'} = "Italicized Text";
	$class_user{'059'} = "Underlined Text";
	$class_user{'060'} = "Center Text";
	$class_user{'061'} = "Add Link";
	$class_user{'062'} = "Add Image";
	$class_user{'063'} = "Add E-Mail";
	$class_user{'064'} = "Your name and email address will automatically be included in the ad."; 
	$class_user{'066'} = "Make List";
	$class_user{'067'} = "Subscript";
	$class_user{'068'} = "Superscript";
	$class_user{'069'} = "Strikethrough";
	$class_user{'070'} = "Preformatted Text";
	$class_user{'071'} = "Align Left";
	$class_user{'072'} = "Align Right";
	$class_user{'065'} = "Smilies:";
	$class_user{'073'} = "bones";
	$class_user{'074'} = "confused";
	$class_user{'075'} = "cool";
	$class_user{'076'} = "cry";
	$class_user{'077'} = "eek";
	$class_user{'078'} = "evil";
	$class_user{'079'} = "frown";
	$class_user{'080'} = "grin";
	$class_user{'081'} = "bounce";
	$class_user{'082'} = "lol";
	$class_user{'083'} = "mad";
	$class_user{'084'} = "nonsense";
	$class_user{'085'} = "oops";
	$class_user{'086'} = "rolleyes";
	$class_user{'087'} = "smile";
	$class_user{'088'} = "tongue";
	$class_user{'089'} = "wink";
	$class_user{'090'} = "ninja";
	$class_user{'091'} = "optional";
	$class_user{'092'} = "Price:";
	$class_user{'093'} = "Ad modified on"; 
	$class_user{'094'} = "Phone #:";
	$class_user{'095'} = "Image:";
	$class_user{'096'} = "Provide the full URL, eg: http://www.yoursite.com/pathto/graphic.gif";
	$class_user{'097'} = "Click here to upload";
	$class_user{'098'} = "Send an instant message to";
	$class_user{'099'} = "Modify this ad";
	$class_user{'100'} = "Delete this ad";
	$class_user{'101'} = qq~In order to view or place an ad, you must be a registered user. <a href="$pageurl/index.cgi?action=register">Membership is free!</a>~;
	$class_user{'102'} = "this ad has expired";
	$class_user{'103'} = "ads in this section<BR>(expired ads are not listed)";
	$class_user{'104'} = "view(s)";
	$class_user{'105'} = "Ad duration (days):";
	$class_user{'106'} = "Total Matches:";
	$class_user{'107'} = "Search again:";
	$class_user{'108'} = "Search Ads";
	$class_user{'109'} = "No matches found.";
	$class_user{'110'} = "Search results for";
	$class_user{'111'} = "this ad includes a picture";
	$class_user{'112'} = "not specified";

	# Admin Section ##################################################################
	$class_admin{'001'} = "Classifieds Admin";  # navbar
	$class_admin{'002'} = "Categories";
	$class_admin{'003'} = "No ads pending.";
	$class_admin{'004'} = "Publish"; # button
	$class_admin{'005'} = "Delete"; # button
	$class_admin{'006'} = "Modify"; # button
	$class_admin{'007'} = "The following ads are waiting to be published:";
	$class_admin{'008'} = "Title";
	$class_admin{'009'} = "Ad";
	$class_admin{'010'} = "Pages";
	$class_admin{'011'} = "Verify Ads";
	$class_admin{'012'} = "Edit Ad";
	$class_admin{'013'} = "Classifieds Admin";
	$class_admin{'014'} = "New Ads (publish/remove)"; # link text
	$class_admin{'015'} = "Ad Maintenance (edit/move/remove)"; # link text
	$class_admin{'016'} = "Category Maintenance (rename/create/remove)"; # link text
	$class_admin{'017'} = "Welcome! This is the section for administrating the classifieds area.";
	$class_admin{'018'} = "Date";
	$class_admin{'019'} = "ID";
	$class_admin{'020'} = "Add";
	$class_admin{'021'} = "Short Name"; # used when adding a new category
	$class_admin{'022'} = "Description"; # used when adding a new category
	$class_admin{'023'} = "Graphic"; # used when adding a new category
	$class_admin{'024'} = "Auto-generate instant message notifying Admin of ads awaiting approval?";
	$class_admin{'025'} = "Update Config"; # button
	$class_admin{'026'} = "Ad submitted on"; 
	$class_admin{'027'} = "Your ad has been published in our classifieds section. If you have any questions, please reply to this message."; 
	$class_admin{'028'} = "Your ad was <b>not</b> published in our classifieds section, as it was found to be inappropriate. If you have any questions, please reply to this message."; 
	$class_admin{'029'} = "Auto-generate instant message notifying a Member that their ad was either approved or not approved?";
	$class_admin{'030'} = "Number of ads to list per page (default is 10)";
	$class_admin{'031'} = "&#171;&#171; Back to the Classifieds";
	$class_admin{'032'} = "Number of characters allowed per ad (default is 450)";
	$class_admin{'033'} = "Remaining";
	$class_admin{'034'} = "Allow Guests to view ads?";
	$class_admin{'035'} = "Allow images in the ads?";
	$class_admin{'036'} = "Allow uploading of images to your server? (if off, images will be linked from user's server)";
	$class_admin{'037'} = "&#183; click on the ad title to edit it";
	$class_admin{'038'} = "view image on local server";
	$class_admin{'039'} = "view the remote image";
	$class_admin{'040'} = "original expiry date:"; # symbol used to indicate your currency
	$class_admin{'041'} = "n/a"; # used if no price is assigned to ad
	$class_admin{'042'} = "Used to name the database file.<BR>Do not include any special characters such as \/ \- \* \$ \| \^ \# \+ \= \< \> \[ \] \{ \} \( \) or spaces.";
	$class_admin{'043'} = "ad(s) are awaiting approval";
	$class_admin{'044'} = "Update your v0.1 category database files to v2.0";
	$class_admin{'045'} = "Your category database files have been updated to version 2.0.";
	$class_admin{'046'} = "List expired ads? (if yes, ads are listed but not linked; if no, ads aren't listed but remain in database)";
	$class_admin{'047'} = "Allow \"smilies\" in the ads?";
	$class_admin{'048'} = "Allow UBBC codes in the ads?";
	$class_admin{'049'} = "Default currency used in ads";
	$class_admin{'050'} = "Expiry increments for ads (in days, separated by commas). For example: <b>7,14,21,28</b>";
	$class_admin{'051'} = "Click here to jump to the ad verification area.";
	$class_admin{'052'} = "requested expiry in";
	$class_admin{'053'} = "days";
	$class_admin{'054'} = "An image was not supplied for this ad.";
	$class_admin{'055'} = "Click here to view the modified ad.";
	$class_admin{'056'} = "Images are not allowed in the ads.";
	$class_admin{'057'} = "Automated Features";
	$class_admin{'058'} = "Ad Images";
	$class_admin{'059'} = "Ad Format";
	$class_admin{'060'} = "Width of embedded image (default 100)";

	# Error Messages ##################################################################
	$class_error{'001'} = "Cannot open file";
	$class_error{'002'} = "Cannot write file";
	$class_error{'003'} = "Please enter a title!";
	$class_error{'004'} = "You must supply an ad!";
	$class_error{'005'} = "You are not authorized for this action!"; 
	$class_error{'006'} = "Software Error!";
	$class_error{'007'} = "Execution of";
	$class_error{'008'} = "has been aborted due a compilation error:";
	$class_error{'009'} = "If this problem persits, please contact the webmaster and inform them about date and time you've recieved this error.";
	$class_error{'010'} = "Invalid Input!";
	$class_error{'011'} = "This category has ads in it! You should first move/remove the ads before deleting the category.";
	$class_error{'012'} = "All fields are required when entering a category!";
	$class_error{'013'} = "Cannot find uploaded graphic!";

	# Uploader-Specific Messages ##################################################################
	$class_upl{'001'} = "$class_user{'010'} $class_user{'001'} $class_user{'010'} file upload"; # html title for upload page
	$class_upl{'002'} = "Please use the following form to upload a graphic for your ad.<BR>Note: <U>the file size must be less than $max_size kb</U>.";
	$class_upl{'003'} = "If you encounter any unexplained errors during this process, notify the Admin via instant message.";
	$class_upl{'004'} = "Steps:";
	$class_upl{'005'} = "Use the <b>Browse...</b> button to select the image from your computer";
	$class_upl{'006'} = "Once the image is selected, click on the <b>Upload File</b> button (very important!)";
	$class_upl{'007'} = "Once the upload is complete, close this window";
	$class_upl{'008'} = "Upload";
	$class_upl{'009'} = "File";
	$class_upl{'010'} = "Upload Results";
	$class_upl{'011'} = "The following file was saved:";
	$class_upl{'012'} = "The file was not stored as its extension does not match any of the valid extensions specified in the program:";
	$class_upl{'013'} = "The file was not stored as its extension is on the list of extensions not permitted for uploading:";
	$class_upl{'014'} = "Your file was not saved as it exceeds the maximum file size of $max_size kb.";
	$class_upl{'015'} = "Your file could not be saved as there is already a file awaiting approval which has the same name. Please rename your file and try again.";
	$class_upl{'016'} = "Your file could not be saved as there was an error during the storing process.  Please notify the Admin of this error.";
	$class_upl{'017'} = "NOTE: ask the Admin to check to ensure that the directory they specified for image storage is correct.";
	$class_upl{'018'} = "&#171;&#171; return to the upload page to try again";

}

1;