#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# help.cgi from admin/help                                                    #
# v0.9.9.3.4                                                                  #
# Use of Line Numbers for Edit Index by: Jos Brown (www.bantychick.com)       #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos Brown ("bantychick") for 0.9.9.3                #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

if ($action eq "addhlp") { addhlp(); }
elsif ($action eq "addhlp2") { addhlp2(); }
elsif ($action eq "edithlp") { edithlp(); }
elsif ($action eq "edithlp2") { edithlp2(); }
elsif ($action eq "deletehlp") { deletehlp(); }
else { viewhelp(); }

##############
sub viewhelp {
##############

	check_access("editfaq"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB,"<$datadir/help/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);

	$navbar = "$btn{'014'} $mnu{'040'} $btn{'014'} $help{'015'}";
	print_top();

	print qq~<font face='Arial' size='2'><b><i>$help{'011'}</i></b></font>
<table width='100%' border='1'>
<tr>
<td class="titletext">$help{'012'}</td>
<td class="titletext">$help{'003'}</td>
<td class="titletext">$help{'004'}</td>
</tr>
~;

	for ($c=0; $c < @ODB; $c++) {
		chomp($ODB[$c]);
		($helpq,$helpa)=split(/\|/,$ODB[$c]);

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/help.cgi?action=edithlp&amp;question=$c">$help{'013'}</a> - <a
 href="$pageurl/admin/help.cgi?action=deletehlp&amp;question=$c">$help{'014'}</a></font></td>
<td><font size="2">$helpq</font></td>
<td><font size="2">$helpa</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/help.cgi?action=addhlp">$help{'002'}</a></p>
~;

	print_bottom();
	exit;

}

############
sub addhlp {
############

	check_access("editfaq"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $mnu{'040'} $btn{'014'} $help{'002'}";
	print_top();

	print qq~<font face='Arial'><b><i>$help{'002'}</i></b></font>
<form action='$pageurl/admin/help.cgi?action=addhlp2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$help{'003'}</font></td>
<td><input type='text' name='nhelpq'></td>
</tr>
<tr>
<td><font size='2'>$help{'004'}</font></td>
<td><textarea name="nhelpa" cols="40" rows="10"></textarea></td>
</tr>
</table>
<input type="submit" class="button" value="$help{'002'}">
</form>~;

	print_bottom();
	exit;

}

#############
sub addhlp2 {
#############

	check_access("editfaq"); if ($access_granted ne "1") { error("$err{'011'}"); }

	if ($input{'nhelpq'} eq "") {error("$err{'034'}");}
	if ($input{'nhelpa'} eq "") {error("$err{'035'}");}

	$input{'nhelpa'} =~ s~[\n]~<BR>~g; 
	$input{'nhelpa'} =~ s~[\r]~~g; 

	open (DATABASE1,">>$datadir/help/data.txt");
	hold(DATABASE1);
	print DATABASE1 "$input{'nhelpq'}|$input{'nhelpa'}\n";
	release(DATABASE1);
	close (DATABASE1);

	print "Location: $pageurl/admin/help.cgi\n\n"; 
	exit;

}

#############
sub edithlp {
#############

	check_access("editfaq"); if ($access_granted ne "1") { error("$err{'011'}"); }

	$navbar = "$btn{'014'} $mnu{'040'} $btn{'014'} $help{'010'}";
	print_top();

	open(FILE, "<$datadir/help/data.txt");
	hold(FILE);
	chomp(@datas = <FILE>);
	release(FILE);
	close(FILE);

		for ($c=0; $c < @datas; $c++) {
		if ($info{'question'} eq "$c") {
			chomp($datas[$c]);
			($helpq,$helpa)=split(/\|/,$datas[$c]);
			$helpa =~ s~<BR>~\n~g;

			print qq~<font face='Arial'><b><i>$help{'010'}</i></b></font>
<form action='$pageurl/admin/help.cgi?action=edithlp2' method='post'>
<input type='hidden' name='helpq' value='$c'>
<table border='1'>
<tr>
<td><font size='2'>$help{'003'}</font></td>
<td><textarea name="nhelpq" cols="40" rows="2">$helpq</textarea></td>
</tr>
<tr>
<td><font size='2'>$help{'004'}</font></td>
<td><textarea name="nhelpa" cols="40" rows="10">$helpa</textarea></td>
</tr>
</table>
<input type="submit" class="button" value="$help{'010'}">
</form>
~;

			last;
		}
		else { next; }

	}

	print_bottom();
	exit;

}

##############
sub edithlp2 {
##############

	open (ORGDB,"<$datadir/help/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);

	open (DATABASE,">$datadir/help/data.txt");
	hold(DATABASE);

	for ($c=0; $c < @ODB; $c++) {
		if ($c eq $input{'helpq'}) {
			chomp($ODB[$c]);
			($helpq,$helpa)=split(/\|/,$ODB[$c]);

			$input{'nhelpa'} =~ s~[\n]~<BR>~g; 
			$input{'nhelpa'} =~ s~[\r]~~g;

			print DATABASE "$input{'nhelpq'}|$input{'nhelpa'}\n";
		} else {
			print DATABASE "$ODB[$c]";
		}
	}
	release(DATABASE);	
	close (DATABASE);

	print "Location: $pageurl/admin/help.cgi\n\n"; 
	exit;

}

###############
sub deletehlp {
###############

	check_access("editfaq"); if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB,"<$datadir/help/data.txt");
	hold(ORGDB);
	@ODB=<ORGDB>;
	release(ORGDB);
	close (ORGDB);
 
	open (DATABASE,">$datadir/help/data.txt");
	hold(DATABASE);

	for ($c=0; $c < @ODB; $c++) {
		if ($c eq $info{'question'}) {
			print DATABASE "";
		} else {
			print DATABASE "$ODB[$c]";
		}
	}
	release(DATABASE);	
	close (DATABASE);

	print "Location: $pageurl/admin/help.cgi\n\n"; 
	exit;

}

1;