#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# logs.cgi from admin/logs                                                    #
# v0.9.9.3.4                                                                  #
# Originally held only recommend log.                                         #
# Other Logging Subs Integrated by: Jos Brown (www.bantychick.com)            #
# View Sent Articles, View Stats Log, and Data Error Viewer by: Jos           #
# Ban Log by: On (www.mlapp.org)                                              #
# XSS vulnerability patch by: Jos                                             #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified - 2005 by Jos ("bantychick") for 0.9.9.3                     #
# Modified: Apr 3, 11 May, 12 May, 13 Aug 2006 by Jos                         #
# Modified: 4/12/2006 by my2cents                                             #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

require "$sourcedir/entities.pl";

if ($action eq "deview") { &de_view; }
elsif ($action eq "banlog") { &banlog; }
elsif ($action eq "viewstats") { &viewstats; }
elsif ($action eq "viewsent") { &viewsent; }
else { viewlog(); }

#############
sub viewlog {
#############
# for recommend log

	$navbar = "$btn{'014'} $nav{'042'} $btn{'014'} $nav{'053'}";
	print_top();


	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	open (ORGDB1,"<$datadir/recommend.log");
	hold (ORGDB1);
	@ODB1=<ORGDB1>;
	release (ORGDB1);
	close (ORGDB1);

	print qq~<font face='Arial' size='2'><i>$msg{'365'}</i></font>
<table width='100%' border='1'>
<tr>
<td class="titletext">$msg{'214'}</td>
<td class="titletext">$msg{'360'}</td>
<td class="titletext">$msg{'361'}</td>
<td class="titletext">$msg{'362'}</td>
<td class="titletext">$msg{'363'}</td>
<td class="titletext">$msg{'364'}</td>
</tr>
~;

	foreach $rec1 (@ODB1){
		chomp($rec1);
		($dater,$refererr,$senderr,$senderemailr,$recipr,$recipemailr)=split(/\|/,$rec1);
		print qq~<tr>
<td><font size="2">$dater</font></td>
<td><font size="2">$refererr</font></td>
<td><font size="2">$senderr</font></td>
<td><font size="2">$senderemailr</font></td>
<td><font size="2">$recipr</font></td>
<td><font size="2">$recipemailr</font></td>
</tr>
~;
	}

	print qq~</table>~;

	print_bottom();
	exit;
}

#############
sub de_view {
#############
# sub by Jos Brown ("bantychick")
# for viewing data error log

	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	my @deview = chomp_database("$logdir/data_error.log");
	my $shownum;

	if ($info{'shownum'}) {
		$shownum = $info{'shownum'};
	} else {
		$shownum = @deview;
	}

	@deview = reverse(@deview);

	# start making the page 
	$navbar = "$btn{'014'} $err{'044'} Log";
	print_top();

	print qq~<table cellpadding="2" cellspacing="0" border="1">
<tr class="titletext">
<td style="font-size: 8pt;">$msg{'214'}:</td>
<td style="font-size: 8pt;">$msg{'006'}</td>
<td style="font-size: 8pt;">$msg{'225'}:</td>
<td style="font-size: 8pt;">$err{'046'}</td>
<td style="font-size: 8pt;">$err{'047'}</td>
</tr>
~;

	#fill up the table! 
	for ($c = 0; $c < @deview && $c < $shownum; $c++) {
		my ($dedate, $deuser, $deip, $depage, $defrom) = split(/\|/,$deview[$c]);

		display_date($dedate); $dedate = $user_display_date;
		$depage =~ s/&#124;/\|/g;
		$defrom =~ s/&#124;/\|/g; # for use of make_entities
		$depage = make_entities($depage);
		$defrom = make_entities($defrom);

		print qq~<tr>
<td style="font-size: 8pt;">$dedate</td>
<td style="font-size: 8pt;">~;
		if ($deuser ne "Guest") {
			print qq~<a href="$pageurl/$cgi?action=viewprofile&username=$deuser"
 title="Click to $nav{'017'}">$deuser</a>~;
		} else {
			print qq~$deuser~;
		}

		print qq~</td>
<td style="font-size: 8pt;"><a href="http://www.whois.sc/$deip" target="_blank"
 title="Click for WhoIs">$deip</a></td>
<td style="font-size: 8pt;">$depage</td>
<td style="font-size: 8pt;">$defrom</td>
</tr>
~;

	}

	print qq~<tr>
<td colspan="5" align="center">$mnu{'053'}: <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=20">20</a> <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=50">50</a> <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=100">100</a> <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=100">All</a></td>
</tr>
</table>
~;

	&print_bottom;
	exit;
}

###############
sub viewstats {
###############
# sub by Jos Brown ("bantychick")
# for viewing statistics log file in log format

	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	if ($info{'statsfile'}) {
		if ($info{'statsfile'} eq "bak") {
			$statsfile = "$logdir/stats_bak.dat";
		}
		elsif ($info{'statsfile'} eq "old") {
			$statsfile = "$logdir/stats_old.dat";
		}
		else {
			$statsfile = "$logdir/stats.dat";
		}
	} else {
		$statsfile = "$logdir/stats.dat";
	}

	open (STATLOG,"<$statsfile");
	holdr (STATLOG);
	chomp(@statdb = <STATLOG>);
	close (STATLOG);

	($startdate) = (split(/\|/, $statdb[1]))[0];

	#start making the page 
	$navbar = "$btn{'014'} $msg{'720'} $btn{'014'} $startdate $msg{'719'} $logdate";
	print_top();

	print qq~<table cellpadding="2" cellspacing="0" border="1">
<tr class="titletext">
<td class="textsmall"><br><a
 href="$pageurl/admin/logs.cgi?action=viewstats&shownum=50">$msg{'214'}</a>:</td>
<td class="textsmall" style="white-space:nowrap"><a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=1">$msg{'006'}</a><br><a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=2">$msg{'111'}</a>:</td>
<td class="textsmall">$mnu{'054'}:<a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=3">$msg{'717'}</a> ? <a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=4">$msg{'718'}</a><br><a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=5">$msg{'360'}</a>:</td>
<td class="textsmall"><a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=6">$msg{'072'}/$msg{'073'}</a>:<br><a
 href="$pageurl/admin/logs.cgi?action=viewstats&sort=7">$msg{'412'}:</a></td>
</tr>
~;

	if ($info{'shownum'}) {
		$shownum = $info{'shownum'};
	} else {
		$shownum = @statdb;
	}

	if ($info{'sort'}) { # if sort field set
		for (0..$#statdb) {
			@fields = split(/\|/, $statdb[$_]);
			for $i (0..$#fields) {
				$data[$_][$i] = $fields[$i];
			}
		}
		if ($info{'sort'} == 1) {
			@data = sort { $a->[8] cmp $b->[8] } @data; # username
		}
		elsif ($info{'sort'} == 2) {
			@data = sort { $a->[7] <=> $b->[7] } @data; # IP
		}
		elsif ($info{'sort'} == 3) {
			@data = sort { $a->[5] cmp $b->[5] } @data; # visited page
		}
		elsif ($info{'sort'} == 4) {
			@data = sort { $a->[6] cmp $b->[6] } @data; # visited query
		}
		elsif ($info{'sort'} == 5) {
			@data = sort { $a->[3] cmp $b->[3] } @data; # referrer
		}
		elsif ($info{'sort'} == 6) {
			@data = sort { $a->[2] cmp $b->[2] } @data; # browser/os
		}
		elsif ($info{'sort'} == 7) {
			@data = sort { $a->[4] cmp $b->[4] } @data; # language
		}
		for (@data) {
			my $sortedrow = join ("|", @$_);
			push (@statslist, $sortedrow);
		}
	} else { # if no sorting
		@statslist = reverse(@statdb);
	}

	for ($c = 0; $c < @statslist && $c < $shownum; $c++) {
		($datetime, $vishost, $browtype, $refpage, $browlang, $script, $querystr, $visip, $visname) = split(/\|/,$statslist[$c]);
		if (!defined $browlang) { $browlang = ""; }
		if (!defined $script) { $script = ""; }
		if (!defined $querystr) { $querystr = ""; }
		if (!defined $visip) { $visip = ""; }
		if (!defined $visname) { $visname = "Guest"; } # these for old stats

		my ($logday, $logtime) = split(/ /, $datetime);
		my ($dayno, $logmonth, $yearno) = split(/-/, $logday);
		my @logmonths = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
		my @indicies = grep $logmonths[$_] eq $logmonth, 0..$#logmonths;
		if (@indicies) {
			$monthno = $indicies[0] + 1;
			if ($monthno < 10) { $monthno = "0$monthno"; }
		} else { $monthno = 0; }
		my ($hrs, $mns, $scs) =  split(/:/, $logtime);
		if (!defined $scs) { $scs = "00"; }

		$datetime = "$monthno/$dayno/$yearno \- $hrs:$mns:$scs";
		display_date($datetime); $datetime = $user_display_date;

		$script =~ s/&#124;/\|/g;
		$querystr =~ s/&#124;/\|/g; # for use of make_entities
		$refpage =~ s/&#124;/\|/g;
		$script = make_entities($script);
		$querystr = make_entities($querystr);
		$refpage = make_entities($refpage);

		print qq~<tr>
<td class="textsmall">$datetime</td>
<td class="textsmall">~;

		if ($visname ne "Guest") {
			print qq~<a
 href="$pageurl/index.cgi?action=viewprofile&username=$visname">$visname</a>~;
		} else {
			print qq~$visname~;
		}

		if ($querystr) { $querystr = "?$querystr"; } else { $querystr = ""; }

		print qq~<br><a href="http://www.whois.sc/$visip" target="_blank"
 title="Host: $vishost \~ click for WhoIs">$visip</a></td>
<td class="textsmall">$mnu{'054'}: <a href="$script$querystr">$script$querystr</a><br>
<br>
$msg{'182'}$refpage</td>
<td class="textsmall">$browtype<br>$browlang</td>
</tr>
~;

	}

	print qq~<tr>
<td colspan="4" align="center">$mnu{'053'}: <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=50">50</a> <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=100">100</a> <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=500">500</a> <a
 href="$scripturl/admin/logs.cgi?action=viewstats">$msg{'432'}</a> &nbsp; <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=50">$msg{'721'}</a> &nbsp; <a
 href="$scripturl/admin/logs.cgi?action=viewstats&statsfile=bak&shownum=50">$msg{'722'}</a> &nbsp; <a
 href="$scripturl/admin/logs.cgi?action=viewstats&statsfile=old&shownum=50">$msg{'723'}</a></td>
</tr>
</table>
~;

	&print_bottom;
	exit;

}

############
sub banlog {
############
# sub by On

	#only admin may view the banslog! 
	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	#open the banslog file 
	open (BANLOG,"<$datadir/banned/ban_log.dat");
	@BANDB=<BANLOG>;
	close (BANLOG);

	#start making the page 
	$navbar = "$btn{'014'} Ban Log";
	print_top();

	print qq~
<p><a href=$scripturl/$cgi?action=admin&op=editbanip>$mnu{'025'}</a></p>
<table width='100%' border='1'>
<tr>
<td class="titletext"><font size="1">Date</font></td>
<td class="titletext"><font size="1">PID</font></td>
<td class="titletext"><font size="1">Address</font></td>
<td class="titletext"><font size="1">Port</font></td>
<td class="titletext"><font size="1">Script Name</font></td>
<td class="titletext"><font size="1">Query</font></td>
<td class="titletext"><font size="1">Protocol</font></td>
<td class="titletext"><font size="1">Referer</font></td>
<td class="titletext"><font size="1">Language</font></td>
</tr>
~;

	#fill up the table! 
	foreach $rec (@BANDB){
		chomp($rec);
		($bdate,$bpid,$badboy1,$badboy2,$badboy3,$baddress,$bhost,$bport,$bconnection,$bscript,$bquery,$bprotocol,$brefer,$bscname,$blanguage) = split(/\|/,$rec);
		print qq~<tr>
<td><font size="1">$bdate </td>
<td><font size="1">$bpid </font></td>
<td><font size="1">$baddress </font></td>
<td><font size="1">$bport </font></td>
<td><font size="1">$bscript </font></td>
<td><font size="1">$bquery </font></td>
<td><font size="1">$bprotocol </font></td>
<td><font size="1">$brefer </font></td>
<td><font size="1">$blanguage </font></td>
</tr>
~;
	}

}

##############
sub viewsent {
##############
# sub by Jos Brown ("bantychick")
# for viewing articles sent by users

	check_access("editip");
	if ($access_granted ne "1") { error("$err{'011'}"); }

	my @sentlog = chomp_database("$datadir/sendarticle.log");
	my $shownum;

	if ($info{'shownum'}) {
		$shownum = $info{'shownum'};
	} else {
		$shownum = @sentlog;
	}

	$navbar = "$btn{'014'} $mnu{'041'} Log";
	print_top();

	print qq~<table cellpadding="2" cellspacing="0" border="1">
<tr class="titletext">
<td class="textsmall">$msg{'214'}</td>
<td class="textsmall">$msg{'361'}</td>
<td class="textsmall">$msg{'211'}</td>
<td class="textsmall">$msg{'361'} $msg{'111'}</td>
<td class="textsmall">$msg{'362'}</td>
<td class="textsmall">$msg{'364'}</td>
</tr>
~;

	for ($c = 0; $c < @sentlog && $c < $shownum; $c++) {
		my ($sentdate, $fromip, $sentby, $mailfrom, $newsid, $mailto, $sentbyusername) = split(/\|/,$sentlog[$c]);

		display_date($sentdate); $sentdate = $user_display_date;
		$sentby = make_entities($sentby);

		print qq~<tr>
<td class="textsmall">$sentdate</td>
<td class="textsmall"><a href="$pageurl/$cgi?action=viewprofile&username=$sentbyusername"
 target="_blank" title="View Profile">$sentby</a></td>
<td class="textsmall"><a href="$pageurl/$cgi?action=viewnews&id=$newsid"
 target="_blank" title="View Article">$newsid</a></td>
<td class="textsmall"><a href="http://www.whois.sc/$deip" target="_blank"
 title="Click for WhoIs">$fromip</a></td>
<td class="textsmall">$mailfrom</td>
<td class="textsmall">$mailto</td>
</tr>
~;

	}

	print qq~</table>~;

	&print_bottom;
	exit;
}

1;