#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# menuman.cgi                                                                 #
# v0.9.9.3.4                                                                  #
# From the Menu Manager Mod Written by Ted Loomos - 2002                      #
# Introduced to WebAPP core code by: Aron Shiewitz (www.2xlnt.com) in 2005    #
# Reworked To Current Methods for v0.9.9.3 by: Jos Brown (www.bantychick.com) #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
# Check_access Conversion by: Jos Brown (www.bantychick.com)                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Aron Shiewitz                                       #
# Modified: 2005 by Jos Brown                                                 #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};

if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

use vars qw($anonuser $username @months @days @pairs %nav $op);

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie();
loaduser();
logips();
&ban;
logvisitors();
&getver;

check_access(); if ($access_granted ne "1") { error("$err{'011'}"); }

if ($action) {
	if ($action eq "View") { &viewmenu; } 
	elsif (($action eq "Add") || ($action eq "Edit")) { &editmenuitem; } 
	elsif ($action eq "Save") { &savemenuitem; }
	elsif (($action eq "Up") || ($action eq "Down")) { &reordermenu; }
}
elsif ($input{'save'}) {
		&parse_multiple;
		&savemenuitem;
} else {
	&viewmenu;
}

exit;

############
sub navbar {
############

	print qq~<a href="menuman.cgi?action=View&menu=mainmenu">$nav{'038'}</a> &#124; <a
 href="menuman.cgi?action=View&menu=memberpanel">$mmm{'002'}</a> &#124; <a
 href="menuman.cgi?action=View&menu=topmenu">$mmm{'021'}</a> &#124; <a
 href="menuman.cgi?action=View&menu=menubar">$mmm{'020'}</a><br>
<br>
~;

}

##############
sub viewmenu {
##############

	if (-e "$langdir/menu/$userlang") {require "$langdir/menu/$userlang";}
	elsif (-e "$langdir/menu/$language") {require "$langdir/menu/$language";}
	else {require "$langdir/menu/english.lng";}

	my $menu = $info{'menu'} || "mainmenu";

	my $navphrase = '';
	if ($menu eq "mainmenu") { $navphrase = $nav{'038'}; }
	if ($menu eq "memberpanel") { $navphrase = $mmm{'002'}; }
	if ($menu eq "topmenu") { $navphrase = $mmm{'021'}; }
	if ($menu eq "menubar") { $navphrase = $mmm{'020'}; }

	$navbar = " $btn{'014'} <a href=\"menuman.cgi\">$mmm{'001'}</a> $btn{'014'} $navphrase";
	&print_top;
	&navbar;

	my @menuitems = chomp_database("$datadir/menuman/$menu.dat");

	print qq~<font face="Arial" size="2"><i>$mmm{'023'}: $navphrase</i></font><br>
<table width="100%" border="1">
<tr>
<td  class="titletext" width="80"><b>$msg{'354'}</b></td>
<td class="titletext"><b>$msg{'207'}</b></td>
<td class="titletext"><b>$mmm{'003'}</b></td>
<td class="titletext"><b>$mmm{'004'}</b></td>
</tr>
~;

	foreach my $rec (@menuitems){
		my ($mmid, $url, $title, $access, $target, $icon) = split(/\|/,$rec);

		if ($title =~ m/^\$/) {
			$title = "$title (". (eval "$title") .")"
		}

		$access =~ s/-admin-/$msg{'430'}/g;
		$access =~ s/-member-/$msg{'431'}/g;
		$access =~ s/-public-/$mmm{'018'}/g;
		$access =~ s/-$anonuser-/$msg{'276'}/g;
		$access =~ s/-($root|$boardmoderator)-/$1 . "s"/eg;
		$access =~ s/-(\w+)-/$1/g; # ranks and statuses

		print qq~<tr>
<td  width="80"><font size="2"><a
 href="menuman.cgi?menu=$menu&amp;id=$mmid&amp;action=Edit"><img
 src="$imagesurl/menuman/edit.gif" border="0" alt="$btn{'030'}" title="$btn{'030'}"></a>&nbsp;<a
 href="menuman.cgi?menu=$menu&amp;id=$mmid&amp;action=Up"><img
 src="$imagesurl/menuman/move_up.gif" border="0" alt="$mmm{'005'}" title="$mmm{'005'}"></a>&nbsp;<a
 href="menuman.cgi?menu=$menu&amp;id=$mmid&amp;action=Down"><img
 src="$imagesurl/menuman/move_down.gif" border="0" alt="$mmm{'006'}" title="$mmm{'006'}"></a>&nbsp;<a
 href="menuman.cgi?menu=$menu&amp;id=$mmid&amp;action=Save&amp;op=Delete"><img
 src="$imagesurl/menuman/delete.gif" border="0" alt="$btn{'011'}" title="$btn{'011'}"></a></font></td>
<td><font size="2">$title</font></td>
<td><font size="2">$url&nbsp;</font></td>
<td><font size="2">$access</font></td>
</tr>
~;
	}

	print qq~</table>
<p><font face="Arial" size="2"><a href="menuman.cgi?menu=$menu&amp;action=Add">$mmm{'007'}</a></font></p>
~;

	print_bottom();
	exit;

}

##################
sub editmenuitem {
##################

	if (-e "$langdir/menu/$userlang") {require "$langdir/menu/$userlang";}
	elsif (-e "$langdir/menu/$language") {require "$langdir/menu/$language";}
	else {require "$langdir/menu/english.lng";}

	my $menu = $info{'menu'};

	my $navphrase = '';
	if ($menu eq "mainmenu") { $navphrase = $nav{'038'}; }
	if ($menu eq "memberpanel") { $navphrase = $mmm{'002'}; }
	if ($menu eq "topmenu") { $navphrase = $mmm{'021'}; }
	if ($menu eq "menubar") { $navphrase = $mmm{'020'}; }

	my $actionphrase = '';
	if ($action eq "Add") { $actionphrase = $mmm{'007'}; }
	if ($action eq "Edit") { $actionphrase = $mmm{'008'}; }

	$navbar = " $btn{'014'} <a href=\"menuman.cgi\">$mmm{'001'}</a> $btn{'014'} <a href=\"menuman.cgi?action=View&menu=$menu\">$navphrase</a> $btn{'014'} $actionphrase";
	&print_top;

	my (@menuitems, $mmid, $url, $title, $access, $target, $icon);

	if ($action eq "Edit") {
		@menuitems = chomp_database("$datadir/menuman/$menu.dat");

		MENUITEM: foreach $rec (@menuitems){
			($mmid, $url, $title, $access, $target, $icon) = split(/\|/,$rec);
			if ($mmid == $info{id}) {
				last MENUITEM;
			}
		}
	} else {
		$mmid = "";
		$url    = "";
		$title  = "";
		$access = "";
		$target = "";
		$icon   = "\$themesurl/\$usertheme/images/dot.gif";
	}

	my $accessSelections = "";

	if (!$access) { $access = "-public-" } # set a default to eliminate blanks

	my $sel;

	if ($access =~ /-admin-/) {$sel="selected"} else {$sel=""}
	$accessSelections .= "<option value='-admin-' $sel>$msg{'430'}</option>\n";
	if ($access =~ /-member-/) {$sel="selected"} else {$sel=""}
	$accessSelections .=  "<option value='-member-' $sel>$msg{'431'}</option>\n";
	if ($access =~ /-$anonuser-/) {$sel="selected"} else {$sel=""}
	$accessSelections .=  "<option value='-$anonuser-' $sel>$msg{'276'}</option>\n";
	if ($access =~ /-public-/) {$sel="selected"} else {$sel=""}
	$accessSelections .=  "<option value='-public-' $sel>$mmm{'018'}</option>\n";

	open (MEMBERRANK,"<$memberdir/membergroups.dat") || error("$err{'016'} $memberdir/membermembergroups.dat");
	hold(MEMBERRANK);
	while (<MEMBERRANK>) {
		chomp($_);
		if ($access =~ /-$_-/) {$sel="selected"} else {$sel=""}
		my $word = $_;
		$word =~ s/($root|$boardmoderator)/$1 . "s"/eg;
		$accessSelections .= "<option value='-$_-' $sel>$word</option>\n";
	}
	close (MEMBERRANK);

	open (MEMBERSTATUS,"<$memberdir/memberstatus.dat") || error("$err{'016'} $memberdir/memberstatus.dat");
	hold(MEMBERSTATUS);
	while (<MEMBERSTATUS>) {
		chomp($_);
		if ($access =~ /-$_-/) {$sel="selected"} else {$sel=""}
		$accessSelections .= "<option value='-$_-' $sel>$_</option>\n";
	}
	close (MEMBERSTATUS);

	my $targetSelections = "<option value=''>$mmm{'016'}</option>";
	if ($target eq "_blank") {$sel="selected"} else {$sel=""}
	$targetSelections .= "<option value='_blank' $sel>$mmm{'017'}</option>";

	print qq~<table class="menubackcolor" cellspacing="0" cellpadding="3" width="100%" border="0">
<tr>
<td valign="top" width="100%"><font face="Arial"><i>$actionphrase</i><br></font>
<form action=menuman.cgi method=POST>
<input type="hidden" name="save" value="Save">
<input type="hidden" name="op" value="$action">
<input type="hidden" name="id" value="$mmid">
<input type="hidden" name="menu" value="$menu">
<table border="1">
<tr>
<td><font size="2">$msg{'207'}</font></td>
<td><input type="text" class="textinput" name="title" value="$title" size="20"></td>
<td><font size="2">$mmm{'009'}</font></td>
</tr>
<tr>
<td><font size="2">$mmm{'003'}</font></td>
<td><input type="text" class="textinput" name="url" value="$url" size="40"></td>
<td><font size="2">$mmm{'010'}</font></td>
</tr>
<tr>
<td><font size="2">$mmm{'012'}</font></td>
<td><select name="target">$targetSelections</select></td>
<td><font size="2">$mmm{'013'}</font></td>
</tr>
~;

	if (($menu ne "menubar") && ($menu ne "topmenu")) {
		print qq~<tr>
<td><font size="2">$mmm{'014'}</font></td>
<td><input type="text" class="textinput" name="icon" value="$icon" size="40"></td>
<td><font size="2">$mmm{'015'}</font></td>
</tr>
~;
	}

	print qq~<tr>
<td><font size="2">$mmm{'004'}</font></td>
<td><select multiple name="multiple-access" size="12">$accessSelections</select></td>
<td><font size="2">$mmm{'011'}</font></td>
</tr>
</table>
<input type=submit value="$actionphrase" class="button">
</form>
</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

##################
sub savemenuitem {
##################

	my $menu = $input{'menu'} || $info{'menu'};
	my @menuitems = chomp_database("$datadir/menuman/$menu.dat");

	if (!$op) { $op = $input{'op'}; }
	if (!$input{icon}) { $input{icon} = ""; }

	my $mmid;

	open (MENUFILE,">$datadir/menuman/$menu.dat") || error("$err{'016'} $datadir/menuman/$menu.dat");
	foreach my $rec (@menuitems) {
		($mmid) = (split(/\|/,$rec))[0];
		if ($op eq "Edit") {
			if ($mmid == $input{'id'}) {
				print MENUFILE "$mmid\|$input{url}\|$input{title}\|$newaccess\|$input{target}\|$input{icon}\n";
			} else {
				print MENUFILE "$rec\n";
			}
		}
		elsif ($op eq "Delete") {
			if ($mmid != $info{'id'}) {
				print MENUFILE "$rec\n";
			}
		} else {
			print MENUFILE "$rec\n";
		}
	}
	if ($op eq "Add") {
		$mmid++;
		print MENUFILE "$mmid\|$input{url}\|$input{title}\|$newaccess\|$input{target}\|$input{icon}\n";
	}
	close (MENUFILE);

	print "Location: $pageurl/admin/menuman.cgi?action=View&menu=$menu\n\n";

}

#################
sub reordermenu {
#################

	my $menu = $input{'menu'} || $info{'menu'};

	my @menuitems = read_database("$datadir/menuman/$menu.dat");

	my ($fid, $ndx, $tondx, $furl, $ftitle, $faccess, $ftarget, $ficon);
	my ($tid, $turl, $ttitle, $taccess, $ttarget, $ticon);

	MENUITEM: for ($ndx=0; $ndx < @menuitems; $ndx++) {
		($fid) = (split(/\|/,$menuitems[$ndx]))[0];
		if ($fid == $info{id}) {
			last MENUITEM;
		}
	}

	my $swap = 0;
	if ($action eq "Up" && $ndx != 0) {
		$tondx = $ndx - 1;
		$swap = 1;
	} elsif ($action eq "Down" && $ndx != $#menuitems) {
		$tondx = $ndx + 1;
		$swap = 1;
	}

	if ($swap) {
		chomp($menuitems[$ndx]);
		chomp($menuitems[$tondx]);
		($fid, $furl, $ftitle, $faccess, $ftarget, $ficon) = split(/\|/,$menuitems[$ndx]);
		($tid, $turl, $ttitle, $taccess, $ttarget, $ticon) = split(/\|/,$menuitems[$tondx]);

		$menuitems[$ndx]   = "$fid\|$turl\|$ttitle\|$taccess\|$ttarget\|$ticon\n";
		$menuitems[$tondx] = "$tid\|$furl\|$ftitle\|$faccess\|$ftarget\|$ficon\n";
	}

	open (MENUFILE,">$datadir/menuman/$menu.dat") || error("$err{'016'} $datadir/menuman/$menu.dat");
	hold(MENUFILE);
	foreach my $rec(@menuitems) {
		print MENUFILE $rec;
	}
	close(MENUFILE);

	print "Location: $pageurl/admin/menuman.cgi?action=View&menu=$menu\n\n";

}

####################
sub parse_multiple {
####################
# process select multiple

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if ($name =~ /^multiple-/) {
			$name =~ s/multiple-//;
			push (@{$selectlist{$name}}, $value);
		}
	}
	$newaccess = join(',',@{$selectlist{access}});

}

1;