#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# prodata.cgi from admin/prodata                                              #
# v0.9.9.3.4                                                                  #
# Profile Data Adminstration System by: Kat for WebAPP v0.9.9.3               #
# Language Tags by: Jos Brown (www.bantychick.com)                            #
# Sort Routines for ages, professions, countries by: Jos Brown                #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
# Check_access Conversion by: Jos Brown                                       #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

check_access(); if ($access_granted ne "1") { error("$err{'011'}"); }

if ( $action eq "viewages" ) { viewages(); }
elsif ( $action eq "addages" ) { addages(); }
elsif ( $action eq "addages2" ) { addages2(); }
elsif ( $action eq "deleteages" ) { deleteages(); }
elsif ( $action eq "viewgen" ) { viewgen(); }
elsif ( $action eq "addgen" ) { addgen(); }
elsif ( $action eq "addgen2" ) { addgen2(); }
elsif ( $action eq "deletegen" ) { deletegen(); }
elsif ( $action eq "viewmarstat" ) { viewmarstat(); }
elsif ( $action eq "addmarstat" ) { addmarstat(); }
elsif ( $action eq "addmarstat2" ) { addmarstat2(); }
elsif ( $action eq "deletemarstat" ) { deletemarstat(); }
elsif ( $action eq "viewprofession" ) { viewprofession(); }
elsif ( $action eq "addprofession" ) { addprofession(); }
elsif ( $action eq "addprofession2" ) { addprofession2(); }
elsif ( $action eq "deleteprofession" ) { deleteprofession(); }
elsif ( $action eq "viewstates" ) { viewstates(); }
elsif ( $action eq "addstates" ) { addstates(); }
elsif ( $action eq "addstates2" ) { addstates2(); }
elsif ( $action eq "deletestates" ) { deletestates(); }
else { viewfiles(); }

################
sub viewfiles {
################

	$navbar = "$btn{'014'} $msg{'698'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'699'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext"> $help{'013'}</td>
</tr>
<tr>
<td><font size='2'> <a href="$pageurl/admin/prodata.cgi?action=viewages">$msg{'700'}</a></font></td>
</tr>
<tr>
<td><font size='2'> <a href="$pageurl/admin/prodata.cgi?action=viewgen">$msg{'701'}</a></font></td>
</tr>
<tr>
<td><font size='2'> <a href="$pageurl/admin/prodata.cgi?action=viewmarstat">$msg{'702'}</a></font></td>
</tr>
<tr>
<td><font size='2'> <a href="$pageurl/admin/prodata.cgi?action=viewprofession">$msg{'703'}</a></font></td>
</tr>
<tr>
<td><font size='2'> <a href="$pageurl/admin/prodata.cgi?action=viewstates">$msg{'704'}</a></font></td>
</tr>
<tr>
</table>
<br>
<br>
~;

# make sure all files end with newline - Jos:
opendir (PRODATA, "$memberdir/prodata");
@pdfiles = readdir(PRODATA);
closedir (PRODATA);
shift(@pdfiles); # STRIP OFF THE "."
shift(@pdfiles); # STRIP OFF THE ".."

foreach $pdfile(@pdfiles) {
	my $addnewline = 0;
	open (PDFILE, "$memberdir/prodata/$pdfile");
	holdr (PDFILE);
	seek PDFILE, -1,2;
	read PDFILE, $b, 1;
	if ($b ne "\n") {
		$addnewline = 1;
	}
	close (PDFILE);

	if ($addnewline) {
		open (PDFILE, ">>$memberdir/prodata/$pdfile");
		hold (PDFILE);
		print PDFILE "\n"; # add newline if there isn't one - Jos
		close (PDFILE);
	}
}

	print_bottom();
	exit;

}

################
sub viewages {
################

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'700'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'705'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'700'}</td>
</tr>
~;

	open (ORGDB,"<$memberdir/prodata/ages.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);

		my ($ages) = (split(/\|/,$rec))[0];

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/prodata.cgi?action=deleteages&amp;ages=$ages">$nav{'097'}</a></font></td>
<td><font size="2">~;

		if (!$ages) {
			print qq~$msg{'708'}~;
		} else {
			print qq~$ages~;
		}

		print qq~</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/prodata.cgi?action=addages">$msg{'706'}</a></p>
<p><a href="$pageurl/admin/prodata.cgi">$msg{'707'}</a></p>
<br>
<br>
~;

	print_bottom();
	exit;
}

##############
sub addages {
##############

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'700'}";
	print_top();

	print qq~<br>
<form action='$pageurl/admin/prodata.cgi?action=addages2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'651'} (1-150)</font></td>
<td><input type="text" class="textinput" name="nages"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'027'}"></form>
~;

	print_bottom();
	exit;

}

###############
sub addages2 {
###############

	# sorting - Jos:
	open (ORGDB,"<$memberdir/prodata/ages.dat");
	hold (ORGDB);
	my @ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	my (@fields, @data, @sortedlist);
	my $nages = "$input{'nages'}|$input{'nages'}|1|$input{'nages'}\n";
	push (@ODB, $nages);

	for (0..$#ODB) {
		@fields = split(/\|/, $ODB[$_]);
		for $i (0..$#fields) {
			$data[$_][$i] = $fields[$i];
		}
	}
	@data = sort { $a->[0] <=> $b->[0] } @data;
	for (@data) {
		$sortedrow = join ("|", @$_);
		push (@sortedlist, $sortedrow);
	}
	@ODB = @sortedlist;
# end sorting

	open (DATABASE1,">$memberdir/prodata/ages.dat");
	hold (DATABASE1);
	print DATABASE1 @ODB;
	release (DATABASE1);
	close (DATABASE1);

	print "Location: $pageurl/admin/prodata.cgi?action=viewages\n\n";

}

#################
sub deleteages {
#################

	# deal with empty record for when user chooses to keep private - Jos:
	if (!$info{'ages'}) {
		$info{'ages'} = "";
	}

	open (ORGDB,"<$memberdir/prodata/ages.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$memberdir/prodata/ages.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);

		my ($ages, $status) = (split(/\|/,$rec))[0,2];

		# deal with empty record for when user chooses to keep private - Jos:
		if (!$ages) {
			$ages = "";
		}

		if ($ages eq $info{'ages'}) {
			print DATABASE "";
		} else {
			print DATABASE "$ages|$ages|$status|$ages\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/prodata.cgi?action=viewages\n\n";

}

################
sub viewgen {
################

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'701'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'709'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'701'}</td>
</tr>
~;

	open (ORGDB,"<$memberdir/prodata/gen.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);

		my ($gen) = (split(/\|/,$rec))[0];

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/prodata.cgi?action=deletegen&amp;gen=$gen">$nav{'097'}</a></font></td>
<td><font size="2">~;

		if (!$gen) {
			print qq~$msg{'708'}~;
		} else {
			print qq~$gen~;
		}

		print qq~</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/prodata.cgi?action=addgen">$msg{'706'}</a></p>
<p><a href="$pageurl/admin/prodata.cgi">$msg{'707'}</a></p>
<br>
<br>
~;

	print_bottom();
	exit;

}

##############
sub addgen {
##############

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'701'}";
	print_top();

	print qq~<br>
<form action='$pageurl/admin/prodata.cgi?action=addgen2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'650'}</font></td>
<td><input type="text" class="textinput" name="ngen"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'027'}"></form>
~;

	print_bottom();
	exit;

}

###############
sub addgen2 {
###############

	open (DATABASE1,">>$memberdir/prodata/gen.dat");
	hold (DATABASE1);
	print DATABASE1 "$input{'ngen'}|$input{'ngen'}|1|$input{'ngen'}\n";
	release (DATABASE1);
	close (DATABASE1);
	print "Location: $pageurl/admin/prodata.cgi?action=viewgen\n\n";

}

#################
sub deletegen {
#################

	# deal with empty record for when user chooses to keep private - Jos:
	if (!$info{'gen'}) {
		$info{'gen'} = "";
	}

	open (ORGDB,"<$memberdir/prodata/gen.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$memberdir/prodata/gen.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);

		my ($gen, $status) = (split(/\|/,$rec))[0,2];

		# deal with empty record for when user chooses to keep private - Jos:
		if (!$gen) {
			$gen = "";
		}

		if ($gen eq $info{'gen'}) {
			print DATABASE "";
		} else {
			print DATABASE "$gen|$gen|$status|$gen\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/prodata.cgi?action=viewgen\n\n";

}

################
sub viewmarstat {
################

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'702'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'710'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'702'}</td>
</tr>
~;

	open (ORGDB,"<$memberdir/prodata/marstat.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB) {
		chomp($rec);
		my ($marstat) = (split(/\|/,$rec))[0];

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/prodata.cgi?action=deletemarstat&amp;marstat=$marstat">$nav{'097'}</a></font></td>
<td><font size="2">~;

		if (!$marstat) {
			print qq~$msg{'708'}~;
		} else {
			print qq~$marstat~;
		}

		print qq~</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/prodata.cgi?action=addmarstat">$msg{'706'}</a></p>
<p><a href="$pageurl/admin/prodata.cgi">$msg{'707'}</a></p>
<br>
<br>
~;

	print_bottom();
	exit;

}

##############
sub addmarstat {
##############

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'702'}";
	print_top();

	print qq~<br>
<form action='$pageurl/admin/prodata.cgi?action=addmarstat2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'351'}</font></td>
<td><input type="text" class="textinput" name="nmarstat"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'027'}"></form>~;

	print_bottom();
	exit;

}

###############
sub addmarstat2 {
###############

	open (DATABASE1,">>$memberdir/prodata/marstat.dat");
	hold (DATABASE1);
	print DATABASE1 "$input{'nmarstat'}|$input{'nmarstat'}|1|$input{'nmarstat'}\n";
	release (DATABASE1);
	close (DATABASE1);
	print "Location: $pageurl/admin/prodata.cgi?action=viewmarstat\n\n";
}

#################
sub deletemarstat {
#################

	# deal with empty record for when user chooses to keep private - Jos:
	if (!$info{'marstat'}) {
		$info{'marstat'} = "";
	}

	open (ORGDB,"<$memberdir/prodata/marstat.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$memberdir/prodata/marstat.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);

		my ($marstat, $status) = (split(/\|/,$rec))[0,2];

		# deal with empty record for when user chooses to keep private - Jos:
		if (!$marstat) {
			$marstat = "";
		}

		if ($marstat eq $info{'marstat'}) {
			print DATABASE "";
		} else {
			print DATABASE "$marstat|$marstat|1|$marstat\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/prodata.cgi?action=viewmarstat\n\n";

}

################
sub viewprofession {
################

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'703'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'711'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'703'}</td>
</tr>
~;

	open (ORGDB,"<$memberdir/prodata/profession.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);

		my ($profession) = (split(/\|/,$rec))[0];

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/prodata.cgi?action=deleteprofession&amp;profession=$profession">$nav{'097'}</a></font></td>
<td><font size="2">~;

		if (!$profession) {
			print qq~$msg{'708'}~;
		} else {
			print qq~$profession~;
		}

		print qq~</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/prodata.cgi?action=addprofession">$msg{'706'}</a></p>
<p><a href="$pageurl/admin/prodata.cgi">$msg{'707'}</a></p>
<br>
<br>
~;

	print_bottom();
	exit;

}

##############
sub addprofession {
##############

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'703'}";
	print_top();

	print qq~<br>
<form action='$pageurl/admin/prodata.cgi?action=addprofession2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'653'}</font></td>
<td><input type="text" class="textinput" name="nprofession"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'027'}"></form>
~;

	print_bottom();
	exit;

}

###############
sub addprofession2 {
###############

	# add sorting - Jos:
	open (ORGDB,"<$memberdir/prodata/profession.dat");
	hold (ORGDB);
	my @ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	my $nprofession = "$input{'nprofession'}|$input{'nprofession'}|1|$input{'nprofession'}\n";
	push (@ODB, $nprofession);
	@ODB = sort(@ODB);
	if ($ODB[$#ODB] =~ /^\|/) { # if the last sorted line begins with empty field
		@ODB = ($ODB[$#ODB], @ODB[0..$#ODB-1]); # put it first - Jos
	}
	# end sorting

	open (DATABASE1,">$memberdir/prodata/profession.dat");
	hold (DATABASE1);
	print DATABASE1 @ODB;
	release (DATABASE1);
	close (DATABASE1);

	print "Location: $pageurl/admin/prodata.cgi?action=viewprofession\n\n";

}

#################
sub deleteprofession {
#################

	# deal with empty record for when user chooses to keep private - Jos:
	if (!$info{'profession'}) {
		$info{'profession'} = "";
	}

	open (ORGDB,"<$memberdir/prodata/profession.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$memberdir/prodata/profession.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);

		my ($profession, $status) = (split(/\|/,$rec))[0,2];

		# deal with empty record for when user chooses to keep private - Jos:
		if (!$profession) {
			$profession = "";
		}

		if ($profession eq $info{'profession'}) {
			print DATABASE "";
		} else {
			print DATABASE "$profession|$profession|1|$profession\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/prodata.cgi?action=viewprofession\n\n";

}

################
sub viewstates {
################

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'704'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'712'}</i></font>
<table width='50%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'704'}</td>
</tr>
~;

	open (ORGDB,"<$memberdir/prodata/states.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);

		my ($states) = (split(/\|/,$rec))[0];

		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/prodata.cgi?action=deletestates&amp;states=$states">$nav{'097'}</a></font></td>
<td><font size="2">~;

		if (!$states) {
			print qq~$msg{'708'}~;
		} else {
			print qq~$states~;
		}

		print qq~</font></td>
</tr>
~;
	}

	print qq~</table>
<p><a href="$pageurl/admin/prodata.cgi?action=addstates">$msg{'706'}</a></p>
<p><a href="$pageurl/admin/prodata.cgi">$msg{'707'}</a></p>
<br>
<br>
~;

	print_bottom();
	exit;

}

##############
sub addstates {
##############

	$navbar = "$btn{'014'} <a href=\"$pageurl/admin/prodata.cgi\">$msg{'698'}</a> $btn{'014'} $msg{'704'}";
	print_top();

	print qq~<br>
<form action='$pageurl/admin/prodata.cgi?action=addstates2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'652'}</font></td>
<td><input type="text" class="textinput" name="nstates"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'027'}"></form>
~;

	print_bottom();
	exit;

}

###############
sub addstates2 {
###############

	# sorting - Jos:
	open (ORGDB,"<$memberdir/prodata/states.dat");
	hold (ORGDB);
	my @ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	my $nstates = "$input{'nstates'}|$input{'nstates'}|1|$input{'nstates'}\n";
	push (@ODB, $nstates);

	@ODB = sort(@ODB);
	if ($ODB[$#ODB] =~ /^\|/) { # if the last sorted line begins with empty field
		@ODB = ($ODB[$#ODB], @ODB[0..$#ODB-1]); # put it first - Jos
	}
	# end sorting

	open (DATABASE1,">$memberdir/prodata/states.dat");
	hold (DATABASE1);
	print DATABASE1 @ODB;
	release (DATABASE1);
	close (DATABASE1);
	print "Location: $pageurl/admin/prodata.cgi?action=viewstates\n\n";

}

#################
sub deletestates {
#################

	# deal with empty record for when user chooses to keep private - Jos:
	if (!$info{'states'}) {
		$info{'states'} = "";
	}

	open (ORGDB,"<$memberdir/prodata/states.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$memberdir/prodata/states.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);

		my ($states, $status) = (split(/\|/,$rec))[0,2];

		if (!$states) {
			$states = "";
		}

		if ($states eq $info{'states'}) {
			print DATABASE "";
		} else {
			print DATABASE "$states|$states|$status|$states\n";
		}
	}

	release (DATABASE);
	close (DATABASE);

	print "Location: $pageurl/admin/prodata.cgi?action=viewstates\n\n";

}

1;