#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# showhtml.cgi                                                                #
# v0.9.9.3.4                                                                  #
# Original by Ted Loomos ShowHTML Mod v0.0.6 01/06/2003                       #
# WebAPP core code integration by: Ted Cambron, 2004                          #
# (From Protocol file from his Dirty Sand Box application                     #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
# Check_access Conversion by: Jos Brown (www.bantychick.com)                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified 11/24/04 by Ted Cambron                                      #
# Modified 2005 by Jos Brown ("bantychick") for 0.9.9.3                       #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

$| = 1;
use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";
##--------------------------------------------------------------
## If you are not using standard folder locations, the following
## lines may need to be changed to match your installation
##--------------------------------------------------------------
	$showHTMLDatafile = "$datadir/showhtml/links.dat";
	$defaultHTMLDir   = "$basedir/pages";
	$defaultProtocol  = "http";
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

# getcgi();
&parse_form;
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

check_access(); if ($access_granted ne "1") { error("$err{'011'}"); }

$action = $info{action};
$op 	= $info{op};
$id	= $info{id};

if ($action eq "View") {
	viewLinks();
} elsif ($action eq "Add" || $action eq "Edit") {
	editLinkItem();
} elsif ($action eq "Save") {
	saveLinkItem();
}


viewLinks();

exit;

###############
sub viewLinks {
###############

	$navbar = "$btn{'014'} $mnu{'046'}";
	print_top();

	open (LINKFILE,"<$showHTMLDatafile") || error("$err{'016'} $showHTMLDatafile");
	@links=<LINKFILE>;
	close (LINKFILE);

	print qq~
	<font face='Arial' size='2'>
	<i>ShowHTML Links</i>
	<table width='100%' border='1'>
	<tr>
	  <td class="titletext">Action</td>
	  <td class="titletext">ID</td>
	  <td class="titletext">Type</td>
	  <td class="titletext">Protocol</td>
	  <td class="titletext">Source</td>
	  <td class="titletext">Title</td>
	</tr>
	~;

	foreach $rec (@links){
		chomp($rec);
		($lid,$type,$source,$protocol,$height,$width,$scrolling,$path,$title)=split(/\|/,$rec);

		print qq~
			<tr>
			  <td>
			      <font size="2">
			      <a href="showhtml.cgi?id=$lid&action=Edit">$nav{'096'}</a> -
			      <a href="showhtml.cgi?id=$lid&action=Save&op=Delete">$nav{'097'}</a>
			      </font></td>
			  <td><font size="2">$lid</font></td>
			  <td><font size="2">$type</font></td>
			  <td><font size="2">$protocol</font></td>
			  <td><font size="2">$source</font></td>
			  <td><font size="2">$title<br></font></td>
			</tr>
		~;
	}

	print qq~
		</table>
		<p><a href="showhtml.cgi\?action=Add">Add Link</a></p>
		</font>
	~;

	print_bottom();
	exit;
}

##################
sub editLinkItem {
##################

	$navbar = "$btn{'014'} $mnu{'046'}";
	print_top();

	if ($action eq "Edit") {
		open (LINKFILE,"<$showHTMLDatafile") || error("$err{'016'} $showHTMLDatafile");
		@links = <LINKFILE>;
		close (LINKFILE);

		LINKITEM: foreach $rec (@links){
			chomp($rec);
			($lid,$type,$source,$protocol,$height,$width,$scrolling,$path,$title)=split(/\|/,$rec);
			if ($lid eq $info{id}) {
				last LINKITEM;
			}
		}
	} else {
		$lid       = "";
		$type      = "";
		$source    = "";
		$protocol  = "";
		$height    = "";
		$width     = "";
		$scrolling = "";
		$path      = "";
		$title     = "";
	}

	%typehash = (
		filename => "Static HTML File",
		url      => "URL"
	);
	%protocolhash = (
		http	=> "http://",
		https	=> "https://"
	);
	%scrollinghash = (
		auto	=> "Automatic",
		yes		=> "Yes",
		no		=> "No"
	);

	$typesel = "";
	while(($key,$value) = each(%typehash)) {
		if ($key eq $type) {$sel="selected"} else {$sel=""}
		$typesel .= "<option value=\"$key\" $sel>$value</option>";
	}

	$protocolsel = "";
	while(($key,$value) = each(%protocolhash)) {
		if ($key eq $protocol) {$sel="selected"} else {$sel=""}
		$protocolsel .= "<option value=\"$key\" $sel>$value</option>";
	}
	if (!$protocol) {$protocolsel .= "<option value=\"\" selected>Default</option>";}

	$scrollingsel = "";
	while(($key,$value) = each(%scrollinghash)) {
		if ($key eq $scrolling) {$sel="selected"} else {$sel=""}
		$scrollingsel .= "<option value=\"$key\" $sel>$value</option>";
	}
	if (!$scrolling) {$scrollingsel .= "<option value=\"\" selected>Default</option>";}


	print qq~<i>$action Link</i><br>
	    <FORM action=showhtml.cgi method=post>
	    <input type="hidden" name="action" value="Save">
	    <input type="hidden" name="op" value="$action">
	    <input type="hidden" name="id" value="$id">
	     <TABLE width="100%" cellpadding="3" cellspacing="0" border="1" class="menubackcolor">
	       <TR>
				<TD><font size="2">ID</font></TD>
				<TD><INPUT name="id" value="$lid" size="15"></TD>
				<TD><font size="2">Indentifying keyword for use in the URL link pointing to this page. For example, if ID=example then you would use $pageurl/$cgi?action=showhtml&id=example</font></TD></TR>
			<TR>
				<TD><font size="2">Type</font></TD>
				<TD><SELECT name="type">$typesel</select></TD>
				<TD><font size="2">Static for local pages.<br>URL for remote pages to load dynamically in an iframe.</font></TD></TR>
			<TR>
				<TD><font size="2">Protocol</font></TD>
				<TD><SELECT name="protocol">$protocolsel</select></TD>
				<TD><font size="2">Tacks on to the front of the Source.<br>$defaultProtocol is the default setting.</font></TD></TR>
			<TR>
				<TD><font size="2">Source</font></TD>
				<TD><INPUT name="source" value="$source" size="40"></TD>
				<TD><font size="2">For Static Type, the file name.<br>For URL Type, the URL with NO Protocol (Use only the part after the http://).</font></TD></TR>
			<TR>
				<TD><font size="2">Height</font></TD>
				<TD><INPUT name="height" value="$height" size="5"></TD>
				<TD><font size="2">Only for Type = URL.<br>Leave blank to use default CSS setting.</font></TD></TR>
			<TR>
				<TD><font size="2">Width</font></TD>
				<TD><INPUT name="width" value="$width" size="5"></TD>
				<TD><font size="2">Only for Type = URL.<br>Leave blank to use default CSS setting.</font></TD></TR>
			<TR>
				<TD><font size="2">Scrollbars</font></TD>
				<TD><SELECT name="scrolling">$scrollingsel</select></TD>
				<TD><font size="2">Only for Type = URL.<br>Leave blank to use default CSS setting.</font></TD></TR>
			<TR>
				<TD><font size="2">Path</font></TD>
				<TD><INPUT name="path" value="$path" size="40"></TD>
				<TD><font size="2">Only for Type = Static File.<br>For standard HTML pages, the full server path with no trailing slash. Leave blank to use  $defaultHTMLDir. For local CGI script pages, the URL path (http://www.example.com). CGI pages require LWP::Simple Perl module on the server.</font></TD></TR>
			<TR>
				<TD><font size="2">Title</font></TD>
				<TD><INPUT name="title" value="$title" size="40"></TD>
				<TD><font size="2">Title of the Page - displays on Nav Bar.</font></TD></TR>
			<TR>
				<TD colspan="3" align="center"><INPUT type=submit value="$action Link" class="button"></TD></TR>
		  </TABLE>
		 </FORM></FONT>
		</TD>
	   </TR>
	</TABLE>
	~;

	print_bottom();
	exit;

}

##################
sub saveLinkItem {
##################

	open (LINKFILE,"<$showHTMLDatafile") || error("$err{'016'} $showHTMLDatafile");
	@links = <LINKFILE>;
	close (LINKFILE);

	open (LINKFILE,">$showHTMLDatafile") || error("$err{'016'} $showHTMLDatafile");
	foreach $rec (@links){
		chomp($rec);
		($lid,$type,$source,$protocol,$height,$width,$scrolling,$path,$title)=split(/\|/,$rec);
		if ($op eq "Edit" || $op eq "Delete") {
			if ($lid eq $id) {
				if ($op eq "Edit") {
					print LINKFILE "$id|$info{type}|$info{source}|$info{protocol}|$info{height}|$info{width}|$info{scrolling}|$info{path}|$info{title}\n";
				}
			} else {
				print LINKFILE "$rec\n";
			}
		} else {
			print LINKFILE "$rec\n";
		}
	}
	if ($op eq "Add") {
		print LINKFILE "$id|$info{type}|$info{source}|$info{protocol}|$info{height}|$info{width}|$info{scrolling}|$info{path}|$info{title}\n";
	}
	close (LINKFILE);
}

# Code to get the data from GET & POST
################
sub parse_form {
################

	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	if (length($buffer) < 5) {
		$buffer = $ENV{QUERY_STRING};
	}
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);

		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if ($name =~ /^multiple-/) {
			$name =~ s/multiple-//;
			push (@{$info{$name}}, $value);
		} else {
			$info{$name} = $value;
		}
	}
}

1;