#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# themes.cgi from admin/themes                                                #
# v0.9.9.3.4                                                                  #
# CSS style sheet compatibility update by: my2cents (classicchat.net)         #
# Check_access Conversion by: Jos Brown (www.bantychick.com)                  #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 12 Apr 2006 by my2cents                                           #
# Modified: 12 May, 13 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

$| = 1;

use CGI::Carp qw(fatalsToBrowser);

$scriptname = "WebAPP";

eval {
	require "../config.pl";
	require "$sourcedir/subs.pl";

	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};
if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
Execution of <b>$scriptname</b> has been aborted due to a compilation error:<br>
<pre>$@</pre>
<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

check_access(); if ($access_granted ne "1") { error("$err{'011'}"); }

if ( $action eq "addtheme" ) { addtheme(); }
elsif ( $action eq "addtheme2" ) { addtheme2(); }
elsif ( $action eq "editrecord" ) { editrecord(); }
elsif ( $action eq "editrecord2" ) { editrecord2(); }
elsif ( $action eq "deletetheme" ) { deletetheme(); }
else { viewthemes(); }

################
sub viewthemes {
################

	$navbar = "$btn{'014'} $mnu{'004'} $btn{'014'} $msg{'370'}";
	print_top();

	print qq~<font face='Arial' size='2'><i>$msg{'370'}</i></font>
<table width='100%' border='1'>
<tr>
<td class="titletext">$msg{'354'}</td>
<td class="titletext">$msg{'368'}</td>
<td class="titletext">$msg{'356'}</td>
<td class="titletext">$msg{'351'}</td>
</tr>
~;

	open (ORGDB,"<$themesdir/themes.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	foreach $rec (@ODB){
		chomp($rec);
		($themes,$dir,$status)=split(/\|/,$rec);
		print qq~<tr>
<td><font size="2"><a href="$pageurl/admin/themes.cgi?action=editrecord&amp;themes=$themes&amp;dir=$dir&amp;status=$status">$nav{'096'}</a> - <a href="$pageurl/admin/themes.cgi?action=deletetheme&amp;themes=$themes&amp;dir=$dir&amp;status=$status">$nav{'097'}</a></font></td><td><font size="2">$themes</font></td><td><font size="2">$dir</font></td><td><font size="2">$status</font></td></tr>~;
}
print qq~</table>
<p><a href="$pageurl/admin/themes.cgi?action=addtheme">$nav{'098'}</a></p>
<br>
<br>
$msg{'191'}~;

	print_bottom();
	exit;
}

################
sub editrecord {
################

	$navbar = "$btn{'014'} $mnu{'004'} $btn{'014'} $btn{'038'}";
	print_top();

	print qq~<font face='Arial'><i>$msg{'369'}</i></font><br>
<form action='$pageurl/admin/themes.cgi?action=editrecord2' method='post'>
<input type='hidden' name='themes' value='$info{'themes'}'>
<input type='hidden' name='dir' value='$info{'dir'}'>
<input type='hidden' name='status' value='$info{'status'}'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'368'}</font></td>
<td><input type="text" class="textinput" name="nthemes" value="$info{'themes'}"></td>
</tr>
<tr>
<td><font size='2'>$msg{'356'}</font></td>
<td><input type="text" class="textinput" name="ndir" value="$info{'dir'}"></td>
</tr>
<tr>
<td><font size='2'>$msg{'351'}</font></td>
<td><input type="text" class="textinput" name="nstatus" value="$info{'status'}"></td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'038'}"></form>~;

	print_bottom();
	exit;
}

#################
sub editrecord2 {
#################

	open (ORGDB,"<$themesdir/themes.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$themesdir/themes.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);
		($themes,$dir,$status)=split(/\|/,$rec);
		if ($themes eq $input{'themes'} && $dir eq $input{'dir'} && $status eq $input{'status'}){
			print DATABASE "$input{'nthemes'}|$input{'ndir'}|$input{'nstatus'}\n";
		} else {
			print DATABASE "$themes|$dir|$status\n";
		}
	}
	release (DATABASE);	
	close (DATABASE);

	print "Location: $pageurl/admin/themes.cgi\n\n";
}

##############
sub addtheme {
##############

	$navbar = "$btn{'014'} $mnu{'004'} $btn{'014'} $btn{'037'}";
	print_top();

	print qq~<font face='Arial'><i>$msg{'367'}</i><font><br>
<form action='$pageurl/admin/themes.cgi?action=addtheme2' method='post'>
<table border='1'>
<tr>
<td><font size='2'>$msg{'368'}</font></td>
<td><input type="text" class="textinput" name="nthemes"></td>
<td>$msg{'550'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'356'}</font></td>
<td><input type="text" class="textinput" name="ndir"></td>
<td>$msg{'551'}</td>
</tr>
<tr>
<td><font size='2'>$msg{'351'}</font></td>
<td><input type="text" class="textinput" name="nstatus"></td>
<td>$msg{'552'}</td>
</tr>
</table>
<input type="submit" class="button" value="$btn{'037'}"></form>
~;

	print_bottom();
	exit;
}

###############
sub addtheme2 {
###############

	open (DATABASE1,">>$themesdir/themes.dat");
	hold (DATABASE1);
	print DATABASE1 "$input{'nthemes'}|$input{'ndir'}|$input{'nstatus'}\n";
	release (DATABASE1);
	close (DATABASE1);
	print "Location: $pageurl/admin/themes.cgi\n\n";
}

#################
sub deletetheme {
#################

	open (ORGDB,"<$themesdir/themes.dat");
	hold (ORGDB);
	@ODB=<ORGDB>;
	release (ORGDB);
	close (ORGDB);

	open (DATABASE,">$themesdir/themes.dat");
	hold (DATABASE);
	foreach $rec (@ODB){
		chomp($rec);
		($themes,$dir,$status)=split(/\|/,$rec);
		if ($themes eq $info{'themes'} && $dir eq $info{'dir'} && $status eq $info{'status'}){
			print DATABASE "";
		} else {
			print DATABASE "$themes|$dir|$status\n";
		}
	}

	release (DATABASE);	
	close (DATABASE);

	print "Location: $pageurl/admin/themes.cgi\n\n";
}

1;