#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# upload.cgi from admin/upload                                                #
# v0.9.9.3.4                                                                  #
# 2002, by WebAPP/Floyd/Carter for WebAPP (www.web-app.org)                   #
# Based on the following sources:                                             #
# PSUpload Library V3.0                                                       #
# 2000, Perl Services/Jim Melanson www.perlservices.net                       #
# 1999, Mark Knickelbain                                                      #
# Security Fix by: On (www.mlapp.org) and Jos Brown (www.bantychick.com)      #
# Image Name Characters Encoding by: Jos Brown                                #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos ("bantychick")                                  #
# Modified: 7 Aug 2006 by Jos                                                 #
###############################################################################
###############################################################################

BEGIN { require "../config.pl"; } # BEGIN, so use lib is not processed before compile time

use lib "$sourcedir";
use Image::Size;

# Needs to be the DIR.. i.e. - /home/webapp/www/
$Data = $uploaddir;

# If you want to allow other image file types, enter them here
@jpg_extensions = ('gif', 'jpg', 'jpeg', 'GIF', 'JPG', 'JPEG', 'png', 'PNG');

@bad_extensions = ('vbs', 'exe', 'bat', 'com', 'VBS', 'EXE', 'BAT', 'COM');

##########################################################
#	Set the maximum size of each file that is permitted.
##########################################################
if (@jpg_extensions) {
	$max_size = $maxuploadsize;
}
else {
	$max_size = $maxuploadsize;
}


#############################################################################
#	DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING
#############################################################################

$max_num_files = "1";

$auto_rename = 1;
 #   This variable tells the program whether or not to over-write or reject like
 #   named files. Therefore, if you upload a file with a name that already exists
 #   on the server, set this value for the appropriate following results:
 #		   0 => Overwrite the existing file
 #		   1 => Leave existing file in place, serialize the name of the new
 #				new file (i.e. some_book.doc, some_book1.doc, some_book2.doc, etc)
 #		   2 => Reject the new file. Leaves the original file in place and rejects
 #				the new file so that it is not saved.


use CGI;
$max_num_files ||= 1;
$upload_dir ||= $ENV{'DOCUMENT_ROOT'};
undef @bad_extensions if @jpg_extensions;

for(my $a = 1; $a <= $max_num_files; $a++) {
	my $req = new CGI;
	if($req->param("FILE$a")) {
		my $file = $req->param("FILE$a");
		my $filename = $file;
		$filename =~ s/^.*(\\|\/)//; # cut off the last slash and everything preceding
		#For IE
		$filename =~ s/ +/\_/g;
		#For Opera
		$filename =~ s/\"//g;

		# fix for characters in image names - Jos
		if ($filename =~ /\W/) {
			require "$sourcedir/entities.pl";
			$filename = high_ascii("$filename");
		}
		my $proceed_type = 0;

		$filetoremember = $filename;

##################################################
# Starting to check files
##################################################

		if(@jpg_extensions) {
			foreach(@jpg_extensions) {
				my $ext = $_;
				$ext =~ s/\.//g;
				if($filename =~ /\.$ext$/) {
					$proceed_type = 1;
					last;
				}
			}
			unless($proceed_type) {
				push(@was_not_good_type, $filename);
			}
		}

#######################################
# If it's a BAD extension.. like exe...
#######################################

		elsif(@bad_extensions) {
			$proceed_type = 1;
			foreach(@bad_extensions) {
				my $ext = $_;
				$ext =~ s/\.//g;
				if($filename =~ /\.$ext$/) {
					$proceed_type = 0;
					last;
				}
			}
			unless($proceed_type) {
				push(@was_a_bad_type, $filename);
			}
		}

####################
# the Catch all....
####################

		else {
			$proceed_type = 1;
		}


###################

		if(($auto_rename == 2) && (-e "$Data/$filename")) {
			$proceed_type = 0;
			push(@rejected, $filename);
		}
		if ($filename =~ /\..*\./) { # prevent doubled file extensions
			$proceed_type = 0;
			push(@rejected, $filename);
		}

		if($proceed_type) {
			if((-e "$Data/$filename") && ($auto_rename == 1)) {
				my $pick_new_name = 1;
				my $fore_num = 1;
				$filename =~ /^(.+)\.([^\.]+)$/;
				my $front = $1;
				my $ext = $2;
				while($pick_new_name) {
					my $test_name = $front . $fore_num . '.' . $ext;
					unless(-e "$Data/$test_name") {
						$pick_new_name = 0;
						$filename = $test_name;
					}
					$fore_num++;
				}
			}
			elsif((-e "$Data/$filename") && ($auto_rename == 2)) {
				next;
			}
			if(open(OUTFILE, ">$Data/$filename")) {
				binmode(OUTFILE); # Abywn's fix for Windows
				$filetoremember = $filename;
				while (my $bytesread = read($file, my $buffer, 1024)) {
					print OUTFILE $buffer;
				}
				close (OUTFILE);

				$imagename = "$Data/$filename"; # added for using Smage::Size
				($x, $y) = imgsize($imagename);
				# if no width or height or if text - modified with/of On's fix for binary test
				if ((!$x || !$y) || (-T "$Data/$filename")) {
					unlink("$Data/$filename");
				} else {
					if($max_size) {
						if((-s "$Data/$filename") > ($max_size * 1024)) {
						# use the following line instead of the above line if you want to limit image width or height
						#						if(((-s "$Data/$filename") > ($max_size * 1024)) || ($x > 800 || $y > 600)) {
							push(@was_too_big, $filename);
							unlink("$Data/$filename");
						} else {
							push(@file_did_save, $filename);
						}
					} else {
						push(@file_did_save, $filename);
					}
				}
			} else { # if file wouldn't open
				push(@did_not_save, $filename);
			}
		} # end if proceed
	} # end if request

	if(@file_did_save) {
		chomp(@file_did_save);
		print "Location: $pageurl/$cgi?action=uploadsuccess&yourfile=$filetoremember\n\n";
		exit;
	} else {
		print "Location: $pageurl/$cgi?action=uploadfail&yourfile=$filetoremember\n\n";
		exit;
	}
}

1;