###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# entities.pl                                                                 #
# v0.9.9.3.4                                                                  #
# Character Formatting subroutines originally for logs                        #
# Also for articles, XML, image uploads, and other functions                  #
# Original by Jos Brown (www.bantychick.com) in 2005 and 2006                 #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 25 May, 7 Aug 2006 by Jos                                         #
###############################################################################
###############################################################################

###################
sub make_entities {
###################
# from HTML::Entities 

	%entity2char = (
	# Some normal chars that have special meaning in SGML context
	amp    => '&',  # ampersand
	'gt'    => '>',  # greater than
	'lt'    => '<',  # less than
	quot   => '"',  # double quote
	apos   => "'",  # single quote

	# PUBLIC ISO 8879-1986//ENTITIES Added Latin 1//EN//HTML
	AElig	=> '',  # capital AE diphthong (ligature)
	Aacute	=> '',  # capital A, acute accent
	Acirc	=> '',  # capital A, circumflex accent
	Agrave	=> '',  # capital A, grave accent
	Aring	=> '',  # capital A, ring
	Atilde	=> '',  # capital A, tilde
	Auml	=> '',  # capital A, dieresis or umlaut mark
	Ccedil	=> '',  # capital C, cedilla
	ETH	=> '',  # capital Eth, Icelandic
	Eacute	=> '',  # capital E, acute accent
	Ecirc	=> '',  # capital E, circumflex accent
	Egrave	=> '',  # capital E, grave accent
	Euml	=> '',  # capital E, dieresis or umlaut mark
	Iacute	=> '',  # capital I, acute accent
	Icirc	=> '',  # capital I, circumflex accent
	Igrave	=> '',  # capital I, grave accent
	Iuml	=> '',  # capital I, dieresis or umlaut mark
	Ntilde	=> '',  # capital N, tilde
	Oacute	=> '',  # capital O, acute accent
	Ocirc	=> '',  # capital O, circumflex accent
	Ograve	=> '',  # capital O, grave accent
	Oslash	=> '',  # capital O, slash
	Otilde	=> '',  # capital O, tilde
	Ouml	=> '',  # capital O, dieresis or umlaut mark
	THORN	=> '',  # capital THORN, Icelandic
	Uacute	=> '',  # capital U, acute accent
	Ucirc	=> '',  # capital U, circumflex accent
	Ugrave	=> '',  # capital U, grave accent
	Uuml	=> '',  # capital U, dieresis or umlaut mark
	Yacute	=> '',  # capital Y, acute accent
	aacute	=> '',  # small a, acute accent
	acirc	=> '',  # small a, circumflex accent
	aelig	=> '',  # small ae diphthong (ligature)
	agrave	=> '',  # small a, grave accent
	aring	=> '',  # small a, ring
	atilde	=> '',  # small a, tilde
	auml	=> '',  # small a, dieresis or umlaut mark
	ccedil	=> '',  # small c, cedilla
	eacute	=> '',  # small e, acute accent
	ecirc	=> '',  # small e, circumflex accent
	egrave	=> '',  # small e, grave accent
	eth	=> '',  # small eth, Icelandic
	euml	=> '',  # small e, dieresis or umlaut mark
	iacute	=> '',  # small i, acute accent
	icirc	=> '',  # small i, circumflex accent
	igrave	=> '',  # small i, grave accent
	iuml	=> '',  # small i, dieresis or umlaut mark
	ntilde	=> '',  # small n, tilde
	oacute	=> '',  # small o, acute accent
	ocirc	=> '',  # small o, circumflex accent
	ograve	=> '',  # small o, grave accent
	oslash	=> '',  # small o, slash
	otilde	=> '',  # small o, tilde
	ouml	=> '',  # small o, dieresis or umlaut mark
	szlig	=> '',  # small sharp s, German (sz ligature)
	thorn	=> '',  # small thorn, Icelandic
	uacute	=> '',  # small u, acute accent
	ucirc	=> '',  # small u, circumflex accent
	ugrave	=> '',  # small u, grave accent
	uuml	=> '',  # small u, dieresis or umlaut mark
	yacute	=> '',  # small y, acute accent
	yuml	=> '',  # small y, dieresis or umlaut mark

	# Some extra Latin 1 chars that are listed in the HTML3.2 draft (21-May-96)
	copy   => '',  # copyright sign
	reg    => '',  # registered sign
	nbsp   => "\240", # non breaking space

	# Additional ISO-8859/1 entities listed in rfc1866 (section 14)
	iexcl  => '',
	cent   => '',
	pound  => '',
	curren => '',
	yen    => '',
	brvbar => '',
	sect   => '',
	uml    => '',
	ordf   => '',
	laquo  => '',
	'not'   => '',    # not is a keyword in perl
	shy    => '',
	macr   => '',
	deg    => '',
	plusmn => '',
	sup1   => '',
	sup2   => '',
	sup3   => '',
	acute  => '',
	micro  => '',
	para   => '',
	middot => '',
	cedil  => '',
	ordm   => '',
	raquo  => '',
	frac14 => '',
	frac12 => '',
	frac34 => '',
	iquest => '',
	'times' => '',    # times is a keyword in perl
	divide => '',

	( $] > 5.007 ? (
	OElig    => chr(338),
	oelig    => chr(339),
	Scaron   => chr(352),
	scaron   => chr(353),
	Yuml     => chr(376),
	fnof     => chr(402),
	circ     => chr(710),
	tilde    => chr(732),
	Alpha    => chr(913),
	Beta     => chr(914),
	Gamma    => chr(915),
	Delta    => chr(916),
	Epsilon  => chr(917),
	Zeta     => chr(918),
	Eta      => chr(919),
	Theta    => chr(920),
	Iota     => chr(921),
	Kappa    => chr(922),
	Lambda   => chr(923),
	Mu       => chr(924),
	Nu       => chr(925),
	Xi       => chr(926),
	Omicron  => chr(927),
	Pi       => chr(928),
	Rho      => chr(929),
	Sigma    => chr(931),
	Tau      => chr(932),
	Upsilon  => chr(933),
	Phi      => chr(934),
	Chi      => chr(935),
	Psi      => chr(936),
	Omega    => chr(937),
	alpha    => chr(945),
	beta     => chr(946),
	gamma    => chr(947),
	delta    => chr(948),
	epsilon  => chr(949),
	zeta     => chr(950),
	eta      => chr(951),
	theta    => chr(952),
	iota     => chr(953),
	kappa    => chr(954),
	lambda   => chr(955),
	mu       => chr(956),
	nu       => chr(957),
	xi       => chr(958),
	omicron  => chr(959),
	pi       => chr(960),
	rho      => chr(961),
	sigmaf   => chr(962),
	sigma    => chr(963),
	tau      => chr(964),
	upsilon  => chr(965),
	phi      => chr(966),
	chi      => chr(967),
	psi      => chr(968),
	omega    => chr(969),
	thetasym => chr(977),
	upsih    => chr(978),
	piv      => chr(982),
	ensp     => chr(8194),
	emsp     => chr(8195),
	thinsp   => chr(8201),
	zwnj     => chr(8204),
	zwj      => chr(8205),
	lrm      => chr(8206),
	rlm      => chr(8207),
	ndash    => chr(8211),
	mdash    => chr(8212),
	lsquo    => chr(8216),
	rsquo    => chr(8217),
	sbquo    => chr(8218),
	ldquo    => chr(8220),
	rdquo    => chr(8221),
	bdquo    => chr(8222),
	dagger   => chr(8224),
	Dagger   => chr(8225),
	bull     => chr(8226),
	hellip   => chr(8230),
	permil   => chr(8240),
	prime    => chr(8242),
	Prime    => chr(8243),
	lsaquo   => chr(8249),
	rsaquo   => chr(8250),
	oline    => chr(8254),
	frasl    => chr(8260),
	euro     => chr(8364),
	image    => chr(8465),
	weierp   => chr(8472),
	real     => chr(8476),
	trade    => chr(8482),
	alefsym  => chr(8501),
	larr     => chr(8592),
	uarr     => chr(8593),
	rarr     => chr(8594),
	darr     => chr(8595),
	harr     => chr(8596),
	crarr    => chr(8629),
	lArr     => chr(8656),
	uArr     => chr(8657),
	rArr     => chr(8658),
	dArr     => chr(8659),
	hArr     => chr(8660),
	forall   => chr(8704),
	part     => chr(8706),
	exist    => chr(8707),
	empty    => chr(8709),
	nabla    => chr(8711),
	isin     => chr(8712),
	notin    => chr(8713),
	ni       => chr(8715),
	prod     => chr(8719),
	sum      => chr(8721),
	minus    => chr(8722),
	lowast   => chr(8727),
	radic    => chr(8730),
	prop     => chr(8733),
	infin    => chr(8734),
	ang      => chr(8736),
	'and'     => chr(8743),
	'or'      => chr(8744),
	cap      => chr(8745),
	cup      => chr(8746),
	'int'     => chr(8747),
	there4   => chr(8756),
	sim      => chr(8764),
	cong     => chr(8773),
	asymp    => chr(8776),
	'ne'      => chr(8800),
	equiv    => chr(8801),
	'le'      => chr(8804),
	'ge'      => chr(8805),
	'sub'     => chr(8834),
	sup      => chr(8835),
	nsub     => chr(8836),
	sube     => chr(8838),
	supe     => chr(8839),
	oplus    => chr(8853),
	otimes   => chr(8855),
	perp     => chr(8869),
	sdot     => chr(8901),
	lceil    => chr(8968),
	rceil    => chr(8969),
	lfloor   => chr(8970),
	rfloor   => chr(8971),
	lang     => chr(9001),
	rang     => chr(9002),
	loz      => chr(9674),
	spades   => chr(9824),
	clubs    => chr(9827),
	hearts   => chr(9829),
	diams    => chr(9830),
	) : ())
	);


# Make the opposite mapping
	while (my($entity, $char) = each(%entity2char)) {
		$char2entity{$char} = "&$entity;";
	}
	delete $char2entity{"'"};  # only one-way decoding

# Fill in missing entities
	for (0 .. 255) {
		next if exists $char2entity{chr($_)};
		$char2entity{chr($_)} = "&#$_;";
	}

	my %subst;  # compiled encoding regexps

	my $ref;
	if (defined wantarray) {
		my $x = $_[0];
		$ref = \$x;     # copy
	} else {
		$ref = \$_[0];  # modify in-place
	}
	if (defined $_[1] and length $_[1]) {
		unless (exists $subst{$_[1]}) {
			# Because we can't compile regex we fake it with a cached sub
			my $code = "sub {\$_[0] =~ s/([$_[1]])/\$char2entity{\$1} || numeric_entity(\$1)/ge; }";
			$subst{$_[1]} = eval $code;
			CORE::die( $@ . " while trying to turn range: \"$_[1]\"\n "
			. "into code: $code\n "
			) if $@;
		}
		&{$subst{$_[1]}}($$ref);
	} else {
		# Encode control chars, high bit chars and '<', '&', '>', '"'
		$$ref =~ s/([^\n\r\t !\#\$%\'-;=?-~])/$char2entity{$1} || numeric_entity($1)/ge;
	}
	$$ref;

}

####################
sub numeric_entity {
####################
# from HTML::Entities

    sprintf "&#x%X;", ord($_[0]);

}

###############
sub xml_ready {
###############
# to complement upgraded xml sub by Jos
# note: xml defines only entities &lt; &gt; &apos; &quot; &amp;
# for &nbsp; - use character reference (&#160;)

	$message =~ s/<pipe>/&#124;/g;

	my %entity = (
      nbsp   => "&#160;",
      iexcl  => "&#161;",
      cent   => "&#162;",
      pound  => "&#163;",
      curren => "&#164;",
      yen    => "&#165;",
      brvbar => "&#166;",
      sect   => "&#167;",
      uml    => "&#168;",
      copy   => "&#169;",
      ordf   => "&#170;",
      laquo  => "&#171;",
      not    => "&#172;",
      shy    => "&#173;",
      reg    => "&#174;",
      macr   => "&#175;",
      deg    => "&#176;",
      plusmn => "&#177;",
      sup2   => "&#178;",
      sup3   => "&#179;",
      acute  => "&#180;",
      micro  => "&#181;",
      para   => "&#182;",
      middot => "&#183;",
      cedil  => "&#184;",
      sup1   => "&#185;",
      ordm   => "&#186;",
      raquo  => "&#187;",
      frac14 => "&#188;",
      frac12 => "&#189;",
      frac34 => "&#190;",
      iquest => "&#191;",
      Agrave => "&#192;",
      Aacute => "&#193;",
      Acirc  => "&#194;",
      Atilde => "&#195;",
      Auml   => "&#196;",
      Aring  => "&#197;",
      AElig  => "&#198;",
      Ccedil => "&#199;",
      Egrave => "&#200;",
      Eacute => "&#201;",
      Ecirc  => "&#202;",
      Euml   => "&#203;",
      Igrave => "&#204;",
      Iacute => "&#205;",
      Icirc  => "&#206;",
      Iuml   => "&#207;",
      ETH    => "&#208;",
      Ntilde => "&#209;",
      Ograve => "&#210;",
      Oacute => "&#211;",
      Ocirc  => "&#212;",
      Otilde => "&#213;",
      Ouml   => "&#214;",
      times  => "&#215;",
      Oslash => "&#216;",
      Ugrave => "&#217;",
      Uacute => "&#218;",
      Ucirc  => "&#219;",
      Uuml   => "&#220;",
      Yacute => "&#221;",
      THORN  => "&#222;",
      szlig  => "&#223;",
      agrave => "&#224;",
      aacute => "&#225;",
      acirc  => "&#226;",
      atilde => "&#227;",
      auml   => "&#228;",
      aring  => "&#229;",
      aelig  => "&#230;",
      ccedil => "&#231;",
      egrave => "&#232;",
      eacute => "&#233;",
      ecirc  => "&#234;",
      euml   => "&#235;",
      igrave => "&#236;",
      iacute => "&#237;",
      icirc  => "&#238;",
      iuml   => "&#239;",
      eth    => "&#240;",
      ntilde => "&#241;",
      ograve => "&#242;",
      oacute => "&#243;",
      ocirc  => "&#244;",
      otilde => "&#245;",
      ouml   => "&#246;",
      divide => "&#247;",
      oslash => "&#248;",
      ugrave => "&#249;",
      uacute => "&#250;",
      ucirc  => "&#251;",
      uuml   => "&#252;",
      yacute => "&#253;",
      thorn  => "&#254;",
      yuml   => "&#255;",
      );

	my $entities = join('|', keys %entity);

	$message =~ s/&(?!(#[0-9]+|#x[0-9a-fA-F]+|\w+);)/&amp;/g;
	$message =~ s/&($entities);/$entity{$1}/g;

	$message =~ s/</&lt;/g;
	$message =~ s/>/&gt;/g;
	$message =~ s/'/&#39;/g;

}

#####################
sub unmake_entities {
#####################
# for encoding to validate HTML and XML when windows-1252 and \x chars are entered
# from Perl module HTML::Entities sub decode_entities_old

    my $array;
    if (defined wantarray) {
	$array = [@_]; # copy
    } else {
	$array = \@_;  # modify in-place
    }
    my $c;
    for (@$array) {
	s/(&\#(\d+);?)/$2 < 256 ? chr($2) : $1/eg;
	s/(&\#[xX]([0-9a-fA-F]+);?)/$c = hex($2); $c < 256 ? chr($c) : $1/eg;
	s/(&(\w+);?)/$entity2char{$2} || $1/eg;
    }
    wantarray ? @$array : $array->[0];
}

################
sub high_ascii {
################
# to convert image names when they have unordinary characters

	my ($message) = @_;
	my %HighASCII = (
		"\xc0" => 'A',    # A`
		"\xe0" => 'a',    # a`
		"\xc1" => 'A',    # A'
		"\xe1" => 'a',    # a'
		"\xc2" => 'A',    # A^
		"\xe2" => 'a',    # a^
		"\xc4" => 'Ae',   # A:
		"\xe4" => 'ae',   # a:
		"\xc3" => 'A',    # A~
		"\xe3" => 'a',    # a~
		"\xc8" => 'E',    # E`
		"\xe8" => 'e',    # e`
		"\xc9" => 'E',    # E'
		"\xe9" => 'e',    # e'
		"\xca" => 'E',    # E^
		"\xea" => 'e',    # e^
		"\xcb" => 'Ee',   # E:
		"\xeb" => 'ee',   # e:
		"\xcc" => 'I',    # I`
		"\xec" => 'i',    # i`
		"\xcd" => 'I',    # I'
		"\xed" => 'i',    # i'
		"\xce" => 'I',    # I^
		"\xee" => 'i',    # i^
		"\xcf" => 'Ie',   # I:
		"\xef" => 'ie',   # i:
		"\xd2" => 'O',    # O`
		"\xf2" => 'o',    # o`
		"\xd3" => 'O',    # O'
		"\xf3" => 'o',    # o'
		"\xd4" => 'O',    # O^
		"\xf4" => 'o',    # o^
		"\xd6" => 'Oe',   # O:
		"\xf6" => 'oe',   # o:
		"\xd5" => 'O',    # O~
		"\xf5" => 'o',    # o~
		"\xd8" => 'Oe',   # O/
		"\xf8" => 'oe',   # o/
		"\xd9" => 'U',    # U`
		"\xf9" => 'u',    # u`
		"\xda" => 'U',    # U'
		"\xfa" => 'u',    # u'
		"\xdb" => 'U',    # U^
		"\xfb" => 'u',    # u^
		"\xdc" => 'Ue',   # U:
		"\xfc" => 'ue',   # u:
		"\xc7" => 'C',    # ,C
		"\xe7" => 'c',    # ,c
		"\xd1" => 'N',    # N~
		"\xf1" => 'n',    # n~
		"\xdf" => 'ss',
	);
	my $HighASCIIRE = join '|', keys %HighASCII;
	$message =~ s/($HighASCIIRE)/$HighASCII{$1}/g;

	return $message;

}

###############
sub sanitise  {
###############
# to validate xml when windows-1252 \x chars are entered in articles
# (see the Perl XML Project FAQ, perl-xml.sourceforge.net)

  my $string = shift;

  $string =~ tr/\x91\x92\x93\x94\x96\x97/''""\-\-/;
  $string =~ s/\x85/.../sg;
  $string =~ tr/[\x80-\x9F]//d;

  return($string);

}

##############
sub waescape {
##############
# saves original post doing this: $message = waescape($input{'message'});
# for articles - runs after make_entities
# from WebAPP sub htmlescape minus a few lines

	my $text = shift;

	$text =~ s/  / \&nbsp;/g;
	$text =~ s/\t/&nbsp;&nbsp;&nbsp;/g;
	$text =~ s/\cM//g;
	$text =~ s/\n/<br>/g;
	$text =~ s/\|/<pipe>/g;

	return $text;

}

if (-e "$user_lib/entities.pl") {require "$user_lib/entities.pl"}

1;