###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# menuman.pl                                                                  #
# v0.9.9.3.4                                                                  #
# Based on the WebApp Menu Manager Mod written by Ted Loomos in 2002          #
# Top Menu, Admin Panel Support, Button Images by: John Drury, 2004           #
# Core Code Introduction by: Aron Shiewitz (www.2xlnt.com) for 0.9.9.3        #
# Conversion to Current WebAPP Methods by: Jos Brown (www.bantychick.com)     #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 18 May, 26 May, 5 Aug, 8 Aug 2006 by Jos                          #
# Modified: 5 Aug 2006 by sburg                                               #
###############################################################################
###############################################################################

# save - people probably already have this in their themes:
# $mm_dataDir = "$datadir/menuman";

###############
sub show_menu {
###############
# sub by Jos to combine subs show_menubar and show_topmenu

	my ($menu) = @_;

	my @menuitems = chomp_database("$datadir/menuman/$menu.dat");

	MENUITEM: foreach my $entry(@menuitems) {

		my ($url, $title, $access, $target, $icon) = (split(/\|/,$entry))[1..5];

		$title = eval "\"$title\"";
		$url   = eval "\"$url\"";
		$icon  = eval "\"$icon\"";

		if (!defined $access) { $access = ''; }
		if (!defined $target) { $target = ''; }

		if ($menu ne $username) {

			if ($url eq "memberlist") {
				if ($hidememlist eq "1") {
					$access = "-$root-";
				} else {
					$access = "-member-";
				}
			}
			elsif ($url eq "postnews") {
				if ($enable_userarticles ne "1") {
					$access = "-$root-";
				} else {
					$access = "-member-";
				}
			}

			unless ((($access =~ /-member-/) && ($username ne $anonuser))
			|| ($access =~ /-public-|-$username-|-$userstatus-|-$userrank-/)) {
				next MENUITEM
			}
		}

		menuitem($url, $title, $target, $icon);
	}

}

##################
sub show_menubar {
##################

 	my ($menu) = @_;
	my $class = "nav";
	menubar($menu, $class);

}



##################
sub show_topmenu {
##################

 	my ($menu) = @_;
	my $class = "topnav";
	menubar($menu, $class);

}

#############
sub menubar {
#############

	my ($menu, $class) = @_;

	my @menuitems = chomp_database("$datadir/menuman/$menu.dat");

	my $numitems = 0;
	my $menubar = '';

	MENUITEM: foreach my $entry (@menuitems) {

		my ($url, $title, $access, $target) = (split(/\|/,$entry))[1..4];

		$title = eval "\"$title\"";
		$url   = eval "\"$url\"";

		if (!defined $access) { $access = ''; }
		if ($target) { $target = " target=\"$target\""; } else { $target = ''; }

		unless ((($access =~ /-member-/) && ($username ne $anonuser))
			|| ($access =~ /-public-|-$username-|-$userstatus-|-$userrank-/)) { 
			next MENUITEM
		}
		$numitems++;

		if ($url) {
			if ($url =~ /^https?:\/\//i) {
				$menubar .= qq~<td align="center" width="!!width!!%"><a
 href="$url"
 class="$class"$target>$title</a></td>
~;
			} else {
				$menubar .= qq~<td align="center" width="!!width!!%"><a
 href="$pageurl/$cgi?action=$url"
 class="$class"$target>$title</a></td>
~;
			}
		} else {
				$menubar .= qq~<td align="center" width="!!width!!%"><a
 href="$pageurl/$cgi"
 class="$class">$title</a></td>
~;
		}
	}

	if (!$numitems) { $numitems = 1; } # prevent divide by zero on empty menus
	my $width = int(100/$numitems);
	$menubar =~ s/!!width!!/$width/g;

	print $menubar;

}

if (-e "$user_lib/menuman.pl") {require "$user_lib/menuman.pl"}

1;