###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# palm.pl            	                                                      #
# v0.9.9.3.4                                                                  #
# File by: Jos Brown (www.bantychick.com), Apr 2006                           #
# Based on palm.cgi                                                           #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: April 25, 11 May, 12 May 2006 by Jos ("bantychick")               #
###############################################################################
###############################################################################

##########
sub palm {
##########

	if (-e "$langdir/palm/$userlang") { require "$langdir/palm/$userlang"; }
	elsif (-e "$langdir/palm/$language") { require "$langdir/palm/$language"; }
	else { require "$langdir/palm/english.lng"; }

	print "Content-type: text/html\n\n";

	if (!defined $info{'id'}) { $info{'id'} = ''; }
	if ($info{'id'} =~ /\D/) { palmerror("$msg{'630'}"); }

	my $slogan = "$plm{'001'}";

	print qq~<html>
<head>
<title>$pagetitle</title>
</head>
<body>
<h3 style="color: #000070">$pagetitle</h3>
<p>$slogan</p>
<b>$plm{'002'}:</b><br>
<br>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
~;

	my @catlinks = ();

	open(FILE, "$topicsdir/cats.dat") || palmerror("$err{'001'} $topicsdir/cats.dat");
	holdr(FILE);
	chomp(my @cats = <FILE>);
	close(FILE);

	foreach (@cats) {
		my @item = split(/\|/, $_);
		push(@catlinks, $item[1]);
	}

	if (!$info{'id'}) {

		my %data = ();

		foreach my $curcat (@catlinks) {
			if (-e("$topicsdir/$curcat.cat")) {

				open(FILE, "$topicsdir/$curcat.cat");
				hold(FILE);
				chomp(my @articles = <FILE>);
				close(FILE);

				for ($a = 0; $a < @articles && $a <= $maxnews; $a++) {
					my ($id, $subject, $postdate) = (split(/\|/, $articles[$a]))[0,1,5];

					my $post = qq~<tr>
<td><a href="$scripturl/$cgi?action=palm&id=$id">$subject</a></td>
</tr>
~;
					my ($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/\/| - |:/, $postdate);
					$chkyear = (2000+$chkyear);
					my $sortedentry = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec"; 
					$data{$sortedentry} = $post;
				}
			}
		}

		my @num = sort {$b <=> $a } keys %data;
		$j = 0;
		while ($j < $maxnews) {
			print "$data{$num[$j]}";
			$j++;
		}

		print qq~<tr>
<td><br>
-----------------------<br>
$plm{'006'}</td>
</tr>
~;
	} else {
		foreach my $curcat (@catlinks) {
			if (-e("$topicsdir/$curcat.cat")) {

				open(FILE, "$topicsdir/$curcat.cat");
				hold(FILE);
				chomp(@articles = <FILE>);
				close(FILE);

				for ($a = 0; $a < @articles; $a++) {
					($id) = (split(/\|/, $articles[$a]))[0];
					if ($info{'id'} eq $id) {
						foreach (@cats) {
							@item = split(/\|/, $_);
							if ($curcat eq "$item[1]") { $curcatname = "$item[0]"; }
						}
					}
				}
			}
		}

		open(FILE, "<$topicsdir/articles/$info{'id'}.txt") || palmerror("$err{'001'} $topicsdir/articles/$info{'id'}.txt");
		hold(FILE);
		chomp(my @datas = <FILE>);
		close(FILE);

		@item = split (/\|/, $datas[0]);

		$message = $item[5];
		if ($enable_ubbc) { doubbctopic(); }
		if ($enable_smile) { dosmilies(); }

		print qq~<tr>
<td>$item[0]</td>
</tr>
<tr>
<td>$curcatname: $item[4] $plm{'003'}: $item[1]</td>
</tr>
<tr>
<td><br>
$message</td>
</tr>
~;

		if (@datas > 1) {
			print qq~<tr>
<td><br>
-----------------------<br>
<br>
$msg{'158'}<br>
<br></td>
</tr>
~;
			for ($a = 1; $a < @datas; $a++) {
				my @item = split(/\|/, $datas[$a]);

				if (@item) {
					$message = $item[5];
					if ($enable_ubbc) { doubbc(); }
					if ($enable_smile) { dosmilies(); }
		 			$message = censor_it($message);
					$item[0] = censor_it($item[0]);

					print qq~<tr>
<td>$item[0]</td>
</tr>
<tr>
<td>$item[4] $plm{'003'}: $item[1]</td>
</tr>
<tr>
<td><br>
$message</td>
</tr>
~;

				}
			}
		}
		print qq~<tr>
<td><br>
-----------------------<br>
$plm{'006'}<br>
<br>
&nbsp;[$plm{'004'}] &#124; [<a href="$scripturl/$cgi?action=palm">$plm{'005'}</a>]</td>
</tr>
~;
	}

	print qq~</table>
~;

	&foot; # exits

}

##########
sub foot {
##########

	print qq~<br>
<br>
<a href="$scripturl/$cgi">$pagetitle $plm{'007'}</a><br>
<br>
</body>
</html>
~;

	exit;
}

###############
sub palmerror {
###############

	my ($error) = @_;

	# remove server path from non-admins:
	if ($userrank ne $root) { $error =~ s/\/[^\.]*\///ig }

	print qq~<html>
<p>
<b>$error</b><br>
</html>
~;

	exit;
}

if (-e "$user_lib/palm.pl") {require "$user_lib/palm.pl"}

1; # return true