###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# showhtml.pl                                                                 #
# v0.9.9.3.4                                                                  #
# From the ShowHTML Mod by: Ted Loomos v0.0.6 01/06/2003                      #
# Integrated into WebAPP 0.9.9.3 core code by: Jos Brown (www.bantychick.com) #
# Using 2004 Protocol file from Ted Cambron's Dirty Sand Box application      #
# CGI Page Embedding by: Jos Brown                                            #
# CSS update by: my2cents (classicchat.net)                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: Dec 17 2005 by Lander                                             #
# Modified: 13 Apr 2006 by my2cents                                           #
# Modified: 17 May 2006 by Jos                                                #
# Modified: 5 Aug 2006 by sburg                                               #
###############################################################################
###############################################################################

###############
sub show_html {
###############

	$showHTMLDatafile = "$datadir/showhtml/links.dat";
	$defaultHTMLDir   = "$basedir/pages";
	$defaultProtocol  = "http";

	my $linkID	= $info{'id'};
	my $filename  = $info{'filename'};
	my $url	   = $info{'url'};
	my $title	 = "";
	my $html	  = "File name not defined.";

	if ($linkID) {
		open (DATAFILE,"<$showHTMLDatafile") || &goback("Unable to open $showHTMLDatafile");
		hold (DATAFILE);
		@links = <DATAFILE>;
		close (DATAFILE);

		LINKITEM: foreach $rec (@links) {
			chomp($rec);
			($lid, $type, $source, $protocol, $height, $width, $scrolling, $path, $title) = split(/\|/, $rec);
			if ($lid eq $linkID) {

				if ($type eq "filename") {
					if (!$path) { $path = $defaultHTMLDir; }

					$filename = "$path/$source";
					if ($source !~ /\.cgi|\.pl/) {
						$html = ShowStaticHTMLFile($filename);
					} else {
						use LWP::Simple;
						$html = get($filename);

						$title = $html;
						if ($title =~ /<title.*?>.*<\/title>/igs) {
							$title =~ s/.*<title.*?>//igs;
							$title =~ s/<\/title>.*//igs;
						} else {
							$title = "";
						}
						$html  =~ s/.*<body.*?>//igs;
						$html  =~ s/<\/body>.*//igs;

					} # parse cgi pages like HTML
				} else {
					if (!$protocol) { $protocol = $defaultProtocol; }
					$html = ShowDynamicContent($source, $protocol, $height, $width, $scrolling);
				}

				last LINKITEM;
			}
		}

	}
	elsif ($filename) {
		if ($filename =~ /[\$\|\(\)\[\]\{\}\^\*\<\+\\\/]/) {
			&data_error;
		}
		$noconfig = 1;
		($html, $title) = ShowStaticHTMLFile("$defaultHTMLDir/$filename");
		undef $noconfig;
	} elsif ($url) {
		$html = ShowDynamicContent($url, $defaultProtocol, "", "", "");
	}

	$navbar = "";
	if ($title) { $navbar .= "&nbsp;$btn{'014'}&nbsp; $title"; }
	
	print_top();

	print $html;

	print_bottom();

}

# Show a static HTML file that is located somewhere on the same server as this script.
########################
sub ShowStaticHTMLFile {
########################

	my ($filename) = @_;
	my $html = "";

	if (-e "$filename") {
		open (HTMLFILE, "$filename") || &goback("Unable to open $filename");

		$html = "";
		while (<HTMLFILE>) {
			$html .= $_;
		}
		close HTMLFILE;

		if ($noconfig) { # if file is not loaded through control panel
			$title = $html;
			if ($title =~ /<title.*?>.*<\/title>/igs) {
			$title =~ s/.*<title.*?>//igs;
			$title =~ s/<\/title>.*//igs;
			} else {
				$title = "";
			}
		}

		$html  =~ s/.*<body.*?>//i;
		$html  =~ s/<\/body>.*//i;

	} else {
		if ($userrank ne $root) {
			$filename =~ s/\/[^\.]*\///g;
		}
		$html = "HTML File '$filename' Not Found.";
	}

	if (! $noconfig) { # if file is loaded through control panel
		return $html;
	} else {
		return ($html, $title);
	}

}

# Show a content that is pulled from a URL
########################
sub ShowDynamicContent {
########################

	my ($url, $protocol, $height, $width, $scrolling) = @_;
	my ($html, $query, $key, $val, $fullurl) = "";

	($url,$query) = split(/\?/,$url);
	if ($query) { $query = "?$query"; } else { $query=""; }

	while (($key, $val) = each %info) {
		if ($key ne "url" && $key ne "id" && $val ne "showhtml") {
			if ($query) { $query .= "&"; } else { $query="?"; }
			$query .= "$key=$val";
		}
	}

	$fullurl="$protocol://$url$query";

	if ($height eq "") {
		$height = "400px";
	}
	if ($width eq "") {
		$width = "100%";
	}
	if ($scrolling eq "") {
		$scrolling = "auto";
	}

	$html = "<iframe frameborder=\"0\" scrolling=\"$scrolling\"
style=\"height:$height;width:$width;\"
name=\"cwindow\" src=\"$fullurl\"></iframe>";

	return $html;

}

# Subroutine 'error' prints a simple HTML page for the user when an
# error has occurred.  The subroutine displays the input message for
# the user and goes back so that the user can try again
############
sub goback {
############

	my($parm) = @_;

# Script prints error message and waits for the specified time
# before going back to the data entry screen.The time is
# specified in milliseconds (5000 = 5 sec)

	$navbar = "";
	print_top;

	print qq~<br><br>
<center>
<table align="center" width="400" cellpadding="3" cellspacing="0" border="1"
 style="font-family: verdana; font-size: 2px">
<tr>
<td align="left" class="windowbg"><b>Error</b></td>
</tr>
<tr><td><br><br>
<p><b>Error:</b></p>
<p><b>$parm</b></p>
<p>Please wait for the form to re-load.</p>
<p>If the previous page does not start to load in 10
seconds, press the 'back' button.</p>
<br><br></td>
</tr>
</table>
<br><br>
<script>setTimeout("history.back()",10000)</script>
~;

	print_bottom;
	exit;

}

if (-e "$user_lib/showhtml.pl") { require "$user_lib/showhtml.pl" }

1;