###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# stats.pl                                                                    #
# v0.9.9.3.4                                                                  #
# Stats Caching and Backups by: Jos Brown (www.bantychick.com) in 2005        #
# for WebAPP v0.9.9.3                                                         #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 15 May, 14 Aug 2006 by Jos                                        #
###############################################################################
###############################################################################

###########
sub stats {
###########

	if ($dispstat eq "0" && $username ne "admin") { error("$err{'011'}"); }
	if ($dispstat eq "1" && $username eq "$anonuser") { error("$err{'011'}"); }

	$|++;
	parse_log();

	$navbar = "$btn{'014'} $nav{'006'}";
	print_top();

	print qq~<table border="0" cellpadding="5" cellspacing="0" width="100%">
<tr>
<td valign="top" width="50%">~;	

	topbar();

	print qq~<br>
~;

	site_stats();

	print qq~</td>
<td valign="top" width="50%">~;

	html_browser();

	print qq~<br>
~;
	os_system();

	check_access("editip");
	if ($access_granted eq "1") { 
		print qq~<br>
<div align="right">
$mnu{'050'}: <a href="$scripturl/admin/logs.cgi?action=viewstats&shownum=50">50</a> <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=100">100</a> <a
 href="$scripturl/admin/logs.cgi?action=viewstats&shownum=500">500</a> &nbsp;
<br>
$mnu{'051'}: <a href="$scripturl/admin/logs.cgi?action=deview&shownum=20">20</a> <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=50">50</a> <a
 href="$scripturl/admin/logs.cgi?action=deview&shownum=100">100</a> &nbsp;<br>
</div>
<br>~;
	}

	print qq~</td>
</tr>
</table>
~;

	print_bottom();
	exit;

}

###############
sub parse_log {
###############

	my @lines = read_database("$logdir/stats.dat");

	# convert old log if begins with non-digit
	if ($lines[1] =~ /^\D/) { 
		convert_log(@lines);
		# read again after converting
		@lines = read_database("$logdir/stats.dat"); 
	}

	$total = @lines;

	# get the values to add in from text file:
	if (open(FILE, "$logdir/statadds.dat")) {
		holdr(FILE);
		chomp(@statadds = <FILE>);
		close(FILE);

		foreach $plus(@statadds) {
			($tname, $tvalue) = split(/\|/, $plus);
			$$tname = $tvalue;
		}
	} else { @statadds = (); }

	$total += $tvisits || 0;

	foreach $line (@lines) {
			my ($logdate, $user_agent) = (split(/\|/, $line))[0,2];
			my ($logday) = (split(/ /, $logdate))[0];
			$dayz{$logday} = 1;
			push(@USER_AGENT, $user_agent);
	}

	$total_days = keys %dayz; # what if there were no visits on a day?
	$total_days += $tdays || 0;

	if (!$total_days) { $total_days = 1; } # fix illegal divide by zero
	$hits_per_day = sprintf ("%.2f",($total/$total_days));
	$hits_per_hour = sprintf ("%.2f",($total/$total_days/24));
	$total_agent = @USER_AGENT;
	$total_agent += $tagents || 0;

	if ($top_os == 1) {
		$os{'Windows'} = $Windows || 0;
		$os{'Mac/PPC'} = $MacPPC || 0;
		$os{'Linux'} = $Linux || 0;
		$os{'SunOS'} = $SunOS || 0;
		$os{'BSD'} = $BSD || 0;
		$os{'AIX'} = $AIX || 0;
		$os{'OS/2'} = $OS2 || 0;
		$os{'Irix'} = $Irix || 0;
		$os{'BeOS'} = $BeOS || 0;
		$os{"$msg{'067'}"} = $miscos || 0;

		foreach $user_agent (@USER_AGENT) {
			if ($user_agent =~ /Windows 98|Win98|Windows NT|WinNT|Windows 95|Win95|Win16|Windows 3\.1/i) {
				$os{'Windows'}++;
				next;
			}
			elsif ($user_agent =~ /Mac_PowerPC|Macintosh/i) {
				$os{'Mac/PPC'}++;
				next;
			}
			elsif  ($user_agent =~ /Linux/i) {
				$os{'Linux'}++;
				next;
			}
			elsif  ($user_agent =~ /X11/i) {
				if  ($user_agent =~ /SunOS/i) {
					$os{'SunOS'}++;
					next;
			   	}
		   	elsif  ($user_agent =~ /AIX/i) {
		   		$os{'AIX'}++;
	   			next;
   			}
				elsif  ($user_agent =~ /Amiga/i) {
					$os{'Irix'}++;
					next;
				}
		   	else {
   				$os{'BSD'}++;
	   			next;
		   	}
			}
			elsif  ($user_agent =~ /OS\/2/i) {
				$os{'OS/2'}++;
				next;
			}
			elsif  ($user_agent =~ /BeOS/i) {
				$os{'BeOS'}++;
				next;
			}
			else {
				$os{"$msg{'067'}"}++;
			}
		}
	}
	if ($top_browsers == 1) {
		$se{"$msg{'066'}"} = $searchengines || 0;
		$se{'GoogleBot'} = $GoogleBot || 0;
		$se{'Inktomi'} = $Inktomi || 0;
		$se{'MSNbot'} = $MSNbot || 0;
		$se{'Alexa'} = $Alexa || 0;
		$se{'LookSmart'} = $LookSmart || 0;

		$browser{'Opera'} = $Opera || 0;
		$browser{'Lynx'} = $Lynx || 0;
		$browser{'MSIE'} = $MSIE || 0;
		$browser{'Firefox'} = $Firefox || 0;
		$browser{'Konqueror'} = $Konqueror || 0;
		$browser{'WebTV'} = $WebTV || 0;
		$browser{'Netscape'} = $Netscape || 0;
		$browser{"$msg{'067'}"} = $miscbrow || 0;

		foreach $agent(@USER_AGENT) {
			if ($agent =~ /Googlebot/) { 
				$se{'GoogleBot'}++;
				next; 
			}
			elsif ($agent =~ /Yahoo\!/) { 
				$se{'Inktomi'}++; 
				next; 
			}
			elsif ($agent =~ /msnbot/) { 
				$se{'MSNbot'}++; 
				next; 
			}
			elsif ($agent =~ /ia\_archiver/) { 
				$se{'Alexa'}++; 
				next; 
			}
			elsif ($agent =~ /Nutch/) { 
				$se{'LookSmart'}++; 
				next; 
			}
			elsif ($agent =~ /Opera/i) {
				$browser{'Opera'}++;
				next;
			}
			elsif ($agent =~ /Lynx/i) {
				$browser{"Lynx"}++;
				next;
			}
			elsif ($agent =~ /Konqueror\/(\d)/i || $agent =~ /Konqueror (\d)/i) {
				$browser{"Konqueror"}++;
				next;
			}
			elsif ($agent =~ /MSIE/i) {
				if ($agent =~ /MSIE (\d)/i) {
					$browser{"MSIE"}++;
					next;
				}
				else {
					$se{"$msg{'066'}"}++;
					next;
				}
			}
			elsif ($agent =~ /Mozilla/i) {
				if ($agent =~ /Mozilla(\/| )5/i) {
					if ($agent =~ /Gecko/) { 
						$browser{'Firefox'}++;
						next; 
					} 
					else { 
						$browser{'Mozilla'}++; 
						next; 
					} 
				}
				elsif ($agent =~ /Mozilla(\/| )\d/i) {
					if ($agent =~ /Gecko/) { 
						$browser{'Firefox'}++;
						next; 
					} 
					else { 
						$browser{"Netscape"}++;
						next;
					}
            } 
				else {
					$se{"$msg{'066'}"}++;
					next;
				}
			}
			else {
				$browser{"$msg{'067'}"}++;
			}
		}
	}

	# cache stats if getting too big:
	my $size = (stat("$logdir/stats.dat"))[7];
	if ($size > 1048576) { # 1mb
		open(FILE, ">$logdir/statadds.dat");
		hold(FILE);

		print FILE "tvisits|$total\n";
		print FILE "tagents|$total_agent\n";
		print FILE "tdays|$total_days\n";

		# browsers:
		foreach $brow (sort { $browser{$b} <=> $browser{$a} } keys %browser) {
			if ($brow eq "$msg{'067'}") {
				$browtext = "miscbrow";
			} else {
				$browtext = $brow;
			}
			print FILE "$browtext|$browser{$brow}\n";
		}

		# search engines:
		foreach $sebot (sort { $se{$b} <=> $se{$a} } keys %se) {
			if ($sebot eq "$msg{'066'}") {
				$setext = "searchengines";
			} else {
				$setext = $sebot;
			}
			print FILE "$setext|$se{$sebot}\n";
		}

		# operating systems:
		foreach $os_sys (sort { $os{$b} <=> $os{$a} } keys %os) {
			if ($os_sys eq "$msg{'067'}") {
				$ostext = "miscos";
			} else {
				$ostext = $os_sys;
				$ostext =~ s/\///g;
			}
			print FILE "$ostext|$os{$os_sys}\n";
		}

		close(FILE);

		### write backups: ###
		# save old stats.dat files by dates
		if (-e "$logdir/stats_old.dat") {
			my $modified = (stat("$logdir/stats_old.dat"))[9];
			my ($smin, $shr, $sday, $smon, $syr) = (localtime($modified))[1,2,3,4,5];
			$smon += 1;
			$syr += 1900;
			$smin = "0$smin" unless $smin >= 10;
			$shr  = "0$shr"  unless $shr  >= 10;
			$sday = "0$sday" unless $sday >= 10;
			$smon = "0$smon" unless $smon >= 10; #
			my $statfiledate = "$syr$smon$sday$shr$smin";
			# save old cache by modified date:
			rename("$logdir/stats_old.dat", "$logdir/$statfiledate.dat");
		}
		if (-e "$logdir/stats_bak.dat") {
			# save last cache
			rename ("$logdir/stats_bak.dat", "$logdir/stats_old.dat");
		}
		# cache stats
		rename ("$logdir/stats.dat", "$logdir/stats_bak.dat");
		# start new stats file
		open(DATA, ">$logdir/stats.dat");
		close (DATA);
	}

}

############
sub topbar {
############

	my @memberlist = chomp_database("$memberdir/memberlist.dat");
	my $mcount = @memberlist;

	my $thelatestmember = $memberlist[$#memberlist];

	open(FILE, "$memberdir/$thelatestmember.dat");
	hold(FILE);
	chomp(my @lmsettings = <FILE>);
	release(FILE);
	close(FILE);	

	print qq~<table border="0" cellpadding="0" cellspacing="0" width="100%" class="menutable">
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;$pagename</td>
</tr>
</table>
<table border="0" cellpadding="1" cellspacing="0" width="100%" class="menubordercolor">
<tr>
<td><table border="0" cellpadding="3" cellspacing="0" width="100%" class="menubackcolor">
<tr>
<td width="20" valign="top" class="statstext"><img
 src="$imagesurl/stats/visits.gif" alt="*"></td>
<td class="statstext">$msg{'068'}:</td>
<td class="statstextbold">$total</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/days.gif" alt="*"></td>
<td class="statstext">$msg{'069'}:</td>
<td class="statstextbold">$total_days</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/perday.gif" alt="*"></td>
<td class="statstext">$msg{'070'}:</td>
<td class="statstextbold">$hits_per_day</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/perhour.gif" alt="*"></td>
<td class="statstext">$msg{'071'}:</td>
<td class="statstextbold">$hits_per_hour</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/members.gif" alt="*"></td>
<td class="statstext">$msg{'074'}</td>
<td class="statstextbold">$mcount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/member.gif" alt="*"></td>
<td colspan="2" class="statstext">$msg{'028'} <span class="statstextbold">~;

	if ($username ne "$anonuser") {
		print qq~<a href="$pageurl/$cgi?action=viewprofile&amp;username=$thelatestmember"  class="menu">$lmsettings[1]</a>~;
	} else {
		print qq~$lmsettings[1]~;
	}

	print qq~</span></td></tr>

</table></td>
</tr>
</table>
~;

}

##################
sub html_browser {
##################

	print qq~<table border="0" cellpadding="0" cellspacing="0" width="100%" class="menutable">
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;$msg{'072'}</td>
</tr>
</table>
<table border="0" cellpadding="1" cellspacing="0" width="100%" class="menubordercolor">
<tr>
<td><table border="0" cellpadding="1" cellspacing="0" width="100%" class="menubackcolor">
~;

	# browsers:
	my $flag=0;
	my ($top_pos, $img_width, $percent);

	if (! $total_agent) { $total_agent = 1; }
	foreach $brow (sort { $browser{$b} <=> $browser{$a} } keys %browser) {
		$top_pos = $browser{$brow} if ($flag == 0);
		if (! $top_pos) { $top_pos = 1; } # fix illegal divide by zero
		$img_width = int($browser{$brow}*100/$top_pos);
		$percent = sprintf ("%.2f", ($browser{$brow}/$total_agent*100));
		$brow_pic = $brow;
		$brow_pic =~ tr/A-Z/a-z/;
		if ($brow eq "$msg{'067'}") { $brow_pic = "unknown"; }
		print qq~<tr>
<td class="statstext"><img src="$imagesurl/stats/$brow_pic.gif" alt="*"></td>
<td width="90" class="statstext">$brow</td><td align="center" class="statstextbold">$browser{$brow}</td>
<td align="left" class="statstext">($percent\%)</td>
<td class="statstext" style="white-space: nowrap"><img
 src="$imagesurl/leftbar.gif" width="7" height="14" alt="$percent\%"><img
 src="$imagesurl/mainbar.gif" width="$img_width" height="14" alt="$percent\%"><img
 src="$imagesurl/rightbar.gif" width="7" height="14" alt="$percent\%"></td>
</tr>
~;
		$flag = 1;
	}

	# search engines:
	print qq~<tr>
<td class="statstext">&nbsp;</td>
<td colspan="4" class="statstext"><b><u>$msg{'066'}:</u></b></td>
</tr>
~;

	$flag=0;

	foreach $sebot (sort { $se{$b} <=> $se{$a} } keys %se) {
		$top_pos = $se{$sebot} if ($flag == 0);
		if (! $top_pos) { $top_pos = 1; } # fix illegal divide by zero
		$img_width = int($se{$sebot}*100/$top_pos);
		if (!$total_agent) { $total_agent = 1; } # fix illegal divide by zero
		$percent = sprintf ("%.2f", ($se{$sebot}/$total_agent*100));
		$se_pic = $sebot;
		$se_pic =~ tr/A-Z/a-z/;
		$se_text = $sebot;
		if ($sebot eq "$msg{'066'}") {
			$se_pic = "searchengines";
			$se_text = $msg{'149'};
		}

		print qq~<tr>
<td class="statstext"><img src="$imagesurl/stats/$se_pic.gif" alt="*"></td>
<td width="90" class="statstext">$se_text</td>
<td align="center" class="statstextbold">$se{$sebot}</td>
<td align="left" class="statstext">($percent\%)</td>
<td class="statstext" style="white-space: nowrap"><img
 src="$imagesurl/leftbar.gif" width="7" height="14" alt="$percent\%"><img
 src="$imagesurl/mainbar.gif" width="$img_width" height="14" alt="$percent\%"><img
 src="$imagesurl/rightbar.gif" width="7" height="14" alt="$percent\%"></td>
</tr>
~;
		$flag = 1;
	}

	print qq~</table></td>
</tr>
</table>
~;

}

###############
sub os_system {
###############

	print qq~<table border="0" cellpadding="0" cellspacing="0" width="100%" class="menutable">
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;$msg{'073'}</td>
</tr>
</table>
<table border="0" cellpadding="1" cellspacing="0" width="100%" class="menubordercolor">
<tr>
<td><table border="0" cellpadding="3" cellspacing="0" width="100%" class="menubackcolor">
~;
	my $flag = 0;
	my ($top_pos, $img_width, $percent);

	foreach $os_sys (sort { $os{$b} <=> $os{$a} } keys %os) {
		$top_pos = $os{$os_sys} if ($flag == 0);
		if (! $top_pos) { $top_pos = 1; } # fix illegal divide by zero
		$img_width = int($os{$os_sys}*100/$top_pos);
		$percent = sprintf ("%.2f", ($os{$os_sys}/$total_agent*100));
		$os_pic = $os_sys;
		$os_pic =~ tr/A-Z/a-z/;
		if ($os_pic eq "mac/ppc") { $os_pic = "mac"; }
		if ($os_pic eq "os/2") { $os_pic = "os2"; }
		if ($os_sys eq "$msg{'067'}") { $os_pic = "unknown"; }
		print qq~<tr>
<td class="statstext"><img src="$imagesurl/stats/$os_pic.gif" alt="*"></td>
<td width="90" class="statstext">$os_sys</td><td align="center"
 class="statstextbold">$os{$os_sys}</td>
<td align="left" class="statstext">($percent\%)</td>
<td class="statstext" style="white-space: nowrap"><img
 src="$imagesurl/leftbar.gif" width="7" height="14" alt="$percent\%"><img
 src="$imagesurl/mainbar.gif" width="$img_width" height="14" alt="$percent\%"><img
 src="$imagesurl/rightbar.gif" width="7" height="14" alt="$percent\%"></td>
</tr>
~;
		$flag = 1;
	}

	print qq~</table></td>
</tr>
</table>
~;

}

################
sub site_stats {
################

	undef @catnames;
	undef @catlinks;

	my @topicscat = chomp_database("$topicsdir/cats.dat");
	for ($i = 0; $i < @topicscat; $i++) { $topicscatcount++; }

	foreach (@topicscat) {
		@item = split(/\|/, $_);
		push(@catnames, $item[0]);
		push(@catlinks, $item[1]);
	}

	if (!defined $totala) { $totala = 0; }
	if (!defined $repcount) { $repcount = 0; }

	foreach $curcat (@catlinks) {
		open(FILE, "$topicsdir/$curcat.cat");
		holdr(FILE);
		chomp(@articles = <FILE>);
		release(FILE);
		close(FILE);

		$articlecount = 0;
		for ($a = 0; $a < @articles; $a++) {
			(undef, undef, undef, undef, undef, undef, $areplies) = split(/\|/, $articles[$a]);
			$articlecount++;
			$repcount = $repcount+$areplies;
		}
		$totala = $totala+$articlecount;
		if ($repcount == 0) { $repcount = "0"; }
	}

	open (NEWARTICLES, "$topicsdir/newarticles.dat");
	holdr(NEWARTICLES);
	my @newarticles = <NEWARTICLES>;
	release(NEWARTICLES);
	close(NEWARTICLES);

	if (@newarticles == 0) { $newarticlescount = "0"; }
	for ($i = 0; $i < @newarticles; $i++) { $newarticlescount++; }

	open(FILE, "$boardsdir/cats.txt");
	holdr(FILE);
	chomp(my @categories = <FILE>);
	release(FILE);
	close(FILE);

	$totalm = 0;
	$totalt = 0;

	foreach $curcat (@categories) {
		my @catinfo = chomp_database("$boardsdir/$curcat.cat");

		if ($catinfo[1] ne "") {
			if (!defined $settings[7]) { $settings[7] = ""; }
			if ($settings[7] ne $root && $settings[7] ne $catinfo[1]) { next; }
		}

		$curcatname = "$catinfo[0]";

		foreach $curboard (@catinfo) {
			if ($curboard ne $catinfo[0] && $curboard ne $catinfo[1]) {

				my @messages = chomp_database("$boardsdir/$curboard.txt");

				$tm = @messages;
				$messagecount = 0;
				for ($a = 0; $a < @messages; $a++) {
					(undef, undef, undef, undef, undef, undef, $mreplies, undef, undef, undef, undef, undef) = split(/\|/, $messages[$a]);
					$messagecount++;
					$messagecount = $messagecount+$mreplies;
				}
				$totalm = $totalm+$messagecount;
				$totalt = $totalt+$tm;
			}
		}
	}

	open(LNKCAT, "$linksdir/linkcats.dat");
	holdr(LNKCAT);
	my @lnkcatscount = <LNKCAT>;
	release(LNKCAT);
	close(LNKCAT);

	my $lnkcatscount = 0;
	for ($i = 0; $i < @lnkcatscount; $i++) { $lnkcatscount++; }

	open(LNKCNT, "$linksdir/linkcats.cnt");
	holdr(LNKCNT);
	my $lnkcount = <LNKCNT>;
	release(LNKCNT);
	close(LNKCNT);
	
	open(CNT, "$downloadsdir/downloadcats.cnt") || error("$err{'001'} $downloadsdir/downloadcats.cnt");
	holdr(CNT);
	my $dlcount = <CNT>;
	release(CNT);
	close(CNT);

	print qq~<table border="0" cellpadding="0" cellspacing="0" width="100%" class="menutable">
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;$msg{'149'}</td>
</tr>
</table>
<table border="0" cellpadding="1" cellspacing="0" width="100%" class="menubordercolor">
<tr>
<td><table border="0" cellpadding="3" cellspacing="0" width="100%" class="menubackcolor">
<tr>
<td width="20" valign="top" class="statstext"><img src="$imagesurl/stats/topics.gif" alt="*"></td>
<td width="100%" class="statstext">$msg{'075'} </td>
<td width="50" class="statstextbold">$topicscatcount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/articles.gif" alt="*"></td>
<td class="statstext">$msg{'076'} </td>
<td class="statstextbold">$totala</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/waiting.gif" alt="*"></td>
<td class="statstext">$msg{'077'} </td>
<td class="statstextbold">$newarticlescount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/comments.gif" alt="*"></td>
<td class="statstext">$msg{'078'} </td>
<td class="statstextbold">$repcount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/threads.gif" alt="*"></td>
<td class="statstext">$msg{'079'} </td>
<td class="statstextbold">$totalt</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/forummessages.gif" alt="*"></td>
<td class="statstext">$msg{'080'} </td>
<td class="statstextbold">$totalm</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/linkcats.gif" alt="*"></td>
<td class="statstext">$msg{'081'} </td>
<td class="statstextbold">$lnkcatscount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/links.gif" alt="*"></td>
<td class="statstext">$msg{'082'} </td>
<td class="statstextbold">$lnkcount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/downloads.gif" alt="*"></td>
<td class="statstext">$msg{'170'}: </td>
<td class="statstextbold">$dlcount</td>
</tr>
<tr>
<td valign="top" class="statstext"><img src="$imagesurl/stats/scriptver.gif" alt="*"></td>
<td class="statstext">$msg{'083'} </td>
<td class="statstextbold">$scriptver</td>
</tr>
</table></td>
</tr>
</table>
~;

}

#################
sub convert_log {
#################
# converts old stats systems to 0.9.9.3 format
# works on first visit to stats after upgrade
# by Jos

	my (@lines) = @_;

	open(DATA, ">$logdir/stats.dat");
	hold(DATA);

	foreach $line (@lines) {
		if ($line =~ /^[A-Z]/) {
			if ($line =~ /(.*)( - .* - \".*\" - \".*\")/) {
				my $logdate = $1;
				my $other = $2;
				$logdate =~ s/^\D+ //;
				my ($logday, $logtime) = split(/ /, $logdate);
				my ($dayno, $logmonth, $yearno) = split(/-/, $logday);
				$logmonth = substr($logmonth, 0, 3);
				$yearno = substr($yearno, 2, 2);
				$logday = "$dayno\-$logmonth\-$yearno";
				$other =~ s/" - "/\|/g;
				$other =~ s/ - "/\|/g;
				$other =~ s/^ - //g;
				$other =~ s/"$/\|/g;
				print DATA "$logday $logtime|$other\n";
			} else { next; } # deletes corrupt lines
		}
		elsif ($line =~ /^[\W]/) { # corrects some corrupt lines
			if ($line =~ /(.*)( - .* - \".*\" - \".*\")/) {
				my $logdate = $1;
				my $other = $2;
				$other =~ s/" - "/\|/g;
				$other =~ s/ - "/\|/g;
				$other =~ s/^ - //g;
				$other =~ s/"$/\|/g;
				my $logtime = (split(/ /, $logdate))[-1];
				print DATA "00\-Month\-00 $logtime|$other\n";
			} else { next; }
		}
		 else {
			print DATA "$line";
		}
	}

	close (DATA);
		
}

if (-e "$user_lib/stats.pl") {require "$user_lib/stats.pl"} 

1; # return true