###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# subs_post.pl                                                                #
# v0.9.9.3.4                                                                  #
# Created for WebAPP v0.9.9.3 by: Jos Brown (www.bantychick.com)              #
# (Certain subs moved here from subs.pl since it was getting too big)         #
# XML Upgrade by: Jane and Jos                                                #
# Front News in Text File by: Jos                                             #
# Entities Encoding by: Jos                                                   #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2005 by Jos ("bantychick")                                  #
# Modified: 25 May, 25 June, 7 Aug, 14 Aug 2006 by Jos                        #
###############################################################################
###############################################################################

##################
sub previewstrip {
##################

	my $text = shift;

	$text =~ s/&/&amp;/g;
	$text =~ s/"/&quot;/g;
	$text =~ s/  / \&nbsp;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$text =~ s/\cM//g;
	$text =~ s/\|/<pipe>/g;

	return $text;
}

#########
sub xml {
#########
# rebuilt by Jos
# ideas and starting code from Jane
# custom URLs, more RDF info, print js feed

	require "$sourcedir/entities.pl";

	if (!defined $info{'id'}) { $info{'id'} = ""; }

	&xml_time;

	my $rssdate = $year . "-" . $mon_num . "-" . $mday . "T" . $hour . ":" . $min . ":" . $sec . $timez;

	open(XML, ">$basedir/webapp.xml");
	hold(XML);

	print XML qq~<?xml version="1.0" encoding="ISO-8859-1"?>
<rdf:RDF
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns="http://purl.org/rss/1.0/"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:dcterms="http://purl.org/dc/terms/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:admin="http://webns.net/mvcb/">
  <channel rdf:about="$scripturl/">
    <title>$pagetitle</title>
    <link>$scripturl/$cgi</link>
    <description>$pagetitle - $msg{'727'}</description>
    <dcterms:modified>$rssdate</dcterms:modified>
    <admin:generatorAgent rdf:resource="http://www.web-app.net/" />
    <dc:title>$pagetitle</dc:title>
    <items>
      <rdf:Seq>
      ~;

	if ($info{'id'} eq "") {
		undef @catlinks;

		open(FILE, "$topicsdir/cats.dat") || error("$err{'001'} $topicsdir/cats.dat");
		hold(FILE);
		chomp(@cats = <FILE>);
		close(FILE);

		foreach (@cats) {
			@item = split(/\|/, $_);
			push(@catlinks, $item[1]);
		}

		%data = ();

		foreach $curcat (@catlinks) {
			if (-e("$topicsdir/$curcat.cat")) {
				foreach (@cats) { # get category name for dc:subject
					@item = split(/\|/, $_);
					if ($curcat eq "$item[1]") {
						$curcatname = "$item[0]";
					}
				}

				open(FILE, "$topicsdir/$curcat.cat");
				holdr(FILE);
				chomp(@articles = <FILE>);
				close(FILE);

				for ($a = 0; $a < @articles && $a <= $maxnews; $a++) {
					($id, $subject, $poster, $postdate) = (split(/\|/, $articles[$a]))[0,1,2,5];

					open (FILE, "$topicsdir/articles/$id.txt");
					holdr(FILE);
					chomp($text = <FILE>);
					close(FILE);

					$message = (split(/\|/, $text))[5];

			 		$message = censor_it($message);
			 		$subject = censor_it($subject);
			 		if (length($message) > 255) {
			 			$message =~ s/&lt;img[^&]+&gt;//g;
			 			$message = substr($message, 0, 255);
			 			$message =~ s/(.*)\s.*/$1/;

						if ($message =~ /\[(code|quote|fixed|sup|strike|sub|left|center|right|list|pre|b|i|small|big|u(rl)?)(=[^\]]*)?\]/g) {
							# closes most types of tags:
							my %tags;
							my $count;

							while ($message =~ /\[(code|quote|fixed|sup|strike|sub|left|center|right|list|pre|b|i|small|big|u(rl)?)(=[^\]]*)?\]/g) {
								if (defined($tags{$1})) {
									$tags{$1}++;
								} else {
									$tags{$1} = 1; # Initialize
								}
							}

							foreach $tag (keys(%tags)) {
								$count = 0;
								while ($message =~ m/\[\/$tag\]/g) { # Count closing tags
									$count++;
								}
								for ($c = $count; $c < $tags{$tag}; $c++) {
									$message .= "\[/$tag\]"; # add missing end tags
								}
							}
						}
						$message .= " \.\.\.";
			 		}

					&doubbc;

					# clean up characters from HTML to XML type encoding - Jos:
					$message = unmake_entities($message);
					# clean up \x chars - Jos
					$message = sanitise($message);
					&xml_ready;

					# titles:
					$post = qq~  <rdf:li rdf:resource="$scripturl/$cgi?action=viewnews&amp;id=$id" />
      ~; # do not move
					($chkmonth, $chkday, $chkyear, $chkhour, $chkmin, $chksec) = split(/[\/:]| - /, $postdate);
					# descriptions:
					$rssdate = "20". $chkyear . "-" . $chkmonth . "-" . $chkday . "T" . $chkhour . ":" . $chkmin . ":" . $chksec . $timez;
 					$postitem = qq~<item rdf:about="$scripturl/$cgi?action=viewnews&amp;id=$id">
    <title>$subject</title>
    <link>$scripturl/$cgi?action=viewnews&amp;id=$id</link>
    <description>
      $message
    </description>
    <dc:subject>$curcatname</dc:subject>
    <dc:creator>$poster</dc:creator>
    <dc:date>$rssdate</dc:date>
  </item>
  ~;

					$sortedentry = "$chkyear$chkmonth$chkday$chkhour$chkmin$chksec";

					# for js feed - prints a list of the titles:
					# Make the data Javascript ready:
					$subject =~ s/'/\\'/g;
					$subject =~ s/\//\\\//g;
					$subject =~ s/"/\\"/g;
					$subject =~ s/\@/\\\@/g;
					$postjs = qq~document.write('<a href="$scripturl/$cgi?action=viewnews&amp;id=$id" target="_blank">$subject</a><BR>');~;
					$datajs{$sortedentry} = $postjs; # javascript feed list of titles
					# end js

					$data{$sortedentry} = $post; # titles
					$dataitem{$sortedentry} = $postitem; # descriptions
				}
			}
		}
		@num = sort {$b <=> $a } keys %data; # a sorted array of the date number

		$j = 0;
		while ($j < $maxnews) {
			print XML "$data{$num[$j]}";
			$j++;
		}
	}

	print XML qq~</rdf:Seq>
    </items>
  </channel>
  ~;

	$j = 0;
	while ($j < $maxnews) {
		print XML "$dataitem{$num[$j]}";
		$j++;
	}

	print XML qq~</rdf:RDF>
~;

	close(XML);

	# print js feed:
	open(JSFEED, ">$basedir/jsfeed.js");
	hold(JSFEED);
	$j = 0;
	while ($j < $maxnews) {
		print JSFEED "$datajs{$num[$j]}\n";
		$j++;
	}
	close(JSFEED);

}

# moved to entities.pl
###############
# sub xml_ready {
###############

##############
sub xml_time {
##############
# by Jos

	my @timezones;

	if (open (ZONES,"<$datadir/timezones.dat")) {
		chomp(@timezones = <ZONES>);
		close (ZONES);

		foreach my $zone(@timezones) {
			my @zitem = split(/\|/, $zone);

			if ($zitem[0] eq $timezone) {
				$timez = $zitem[2];
				$timez =~ s/GMT//;
				$timez =~ s/^ /\+/;
				last;
			}
		}
	} else {
		$timez = "+00:00";
	}

}

###############
sub printnews {
###############
# by Jos Brown ("bantychick")
# prints top x number of news to a text file, read by topnews sub in topics.pl
# front page reads from a text file rather than compiling from all the articles
# called from commentnews and postnews2 subs in topics.pl
# and from verifynews2, modifynews3, and movetopic subs in admin.pl
# Needs new "morelink" class in CSS

	my @catlinks = ();
	my @idlist = ();
	my @savelist = ();

	@cats = chomp_database("$topicsdir/cats.dat");

	foreach (@cats) { # the topics categories
		@item = split(/\|/, $_);
		push(@catlinks, $item[1]); # the cat file names
	}

	foreach $curcat (@catlinks) {
		if (-e("$topicsdir/$curcat.cat")) {
			foreach (@cats) {
				@item = split(/\|/, $_);
				if ($curcat eq "$item[1]") {
					$curcatname = "$item[0]";
				}
			}

			@articles = chomp_database("$topicsdir/$curcat.cat");

			for ($a = 0; $a < @articles && $a < $maxnews; $a++) {
				($id, $comments) = (split(/\|/, $articles[$a]))[0,6];
				push(@idlist, join ("\|", $id, $curcat, $curcatname, $comments . "\n"));
			}
		}
	}

	for (0..$#idlist) {
		@sortlines = split(/\|/, $idlist[$_]);
		for $c (0..$#sortlines) {
			$newslist[$_][$c] = $sortlines[$c];
		}
	}

	@newslist = sort	{$b->[0] <=> $a->[0]} @newslist;
	
 	for (@newslist) { 
 		push (@printlines, join ("\|", @$_) . "\n");
 	}

	for ($a = 0; $a < @printlines && $a < $maxnews; $a++) {
		($id, $curcat, $curcatname, $comments) = split(/\|/, $printlines[$a]);
		$comments =~ s/[\n\r]//g;
		if ($comments == 1) {
			$commentscnt = "$comments&nbsp;!!!COMMENT!!!";
		} else {
			$commentscnt = $comments . "&nbsp;!!!COMMENTS!!!";
		}

		$text = chomp_datatext("$topicsdir/articles/$id.txt");

		($subject, $nick, $poster, $email, $postdate, $message) = split(/\|/, $text);

 		$message = censor_it($message);
 		$subject = censor_it($subject);

 		if (length($message) > 255) {
 			$message =~ s/&lt;img[^&]+&gt;//g; # removes html image code
			if ($enable_ubbc) {
 				$message =~ s/\[quote\](.+?)\[\/quote\]/&quot;$1&quot;/isg;
 			}
 			$message = substr($message, 0, 255);
 			$message =~ s/(.*)\s.*/$1/; # trim to last whole word
 			$message =~ s/<[^>]*$/ /; # remove unclosed bracket (are there any?)

			# closes most types of UBBC tags:
			my %tags;
			my $count;
			while ($message =~ /\[(code|img|quote|fixed|sup|strike|sub|left|center|right|list|pre|b|i|small|big|u(rl)?)(=[^\]]*)?\]/g) { # added img tag
				if (defined($tags{$1})) {
					$tags{$1}++;
				} else {
					$tags{$1} = 1; # Initialize
				}
			}
			foreach $tag (keys(%tags)) {
				$count = 0;
				while ($message =~ m/\[\/$tag\]/g) { # Count closing tags
					$count++;
				}
				for ($c = $count; $c < $tags{$tag}; $c++) {
					$message .= "\[/$tag\]"; # add missing end tags
				}
			}
			# end tag closing

			$morelink = " \.\.\. <a href=\"$pageurl/$cgi?action=viewnews&amp;id=$id\" class=\"morelink\"><i>!!!MORE!!!</i></a>";
 		} else {
			$morelink = "";
		}

 		push(@savelist, join ("\|", $id, $subject, $nick, $poster, $email, $postdate, $message, $curcat, $curcatname, $commentscnt, $morelink . "\n"));

	}

	# print top maxnews number of news to a file
	open(TOPNEWS, ">$topicsdir/topnews.txt");
	hold(TOPNEWS);
	print TOPNEWS @savelist;	
	close(TOPNEWS);

}

if (-e "$user_lib/subs_post.pl") {require "$user_lib/subs_post.pl"}

1; # return true