#!/usr/bin/perl

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# install-saveconfig.cgi                                                      #
# Advanced Install Procedure for Updating Existing Sites                      #
# v0.9.9.3.4                                                                  #
# Original for WebAPP v0.9.9.3 by: Jos Brown (www.bantychick.com)             #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# Modified: 7 June, 19 June, 21 June, 25 June 2006 by Jos ("bantychick")      #
# Modified: 30 Aug 2006 by Jos - removed chmod for palm.cgi - no longer used  #
###############################################################################
###############################################################################
# This install.cgi will now read an existing config.dat on a site and use those
# values for the install. It also writes a default first forum post with today's
# date and a banner data file with the four default banners all pre-installed and
# configured to the preferences set in the install for the images folder. It will
# not overwrite the calendar data file, banner data file, or first post file
# unless it is a new installation or unless the config.dat is empty.

use CGI::Carp qw(fatalsToBrowser);

print "Content-type: text/html\n\n";

# $scriptname = "WebAPP (Network Edition) Installer"; # not used
$installscriptname = "WebAPP"; # Change to script name

open (VERSION,"./db/ver.txt") || print "cannot open ./db/ver.txt";
chomp($installversion = <VERSION>);
close(VERSION);

# Version Specific Settings ####################################################
$installupdatename = "Requin";
$installbuildnumber = "001";
################################################################################

&getcgi();

if ($input{'action'} eq "config2") {
	&getconfigpl;
	&setup_config2;
}

if ($input{'action'} eq "config3") {
	&setup_config3;
}

$scriptpath = "";
$hosturl = "";
$rootpath = "";
$givemail =  "";
$smtpfun = "";
$subdir = "";
$cookiestring = "";
$cookienameuid = "";
$cookienamepwd = "";
$cookienamethm = "";
$cookienamelng = "";
$webappurl  = "";

&getinfo();

&getoldinfo;

&setup_config();

############
sub getcgi {
############

	read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $input);
	foreach $pair(@pairs) {

		($name, $value) = split(/=/, $pair);
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$input{$name} = $value;
	}
	@vars = split(/&/, $ENV{QUERY_STRING});
	foreach $var(@vars) {
		($v,$i) = split(/=/, $var);
		$v =~ tr/+/ /;
		$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$i =~ tr/+/ /;
		$i =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$i =~ s/<!--(.|\n)*-->//g;
		$input{$v} = $i;
	}
}

################
sub chmod_file {
################

	$chmodfailed = "0";
	my ($destination, $permissions) = @_;
	unless(chmod(oct($permissions), $destination)) {
		$chmodfailed = "1";
		print qq~<font color="red" size="4"><b>>>> Cannot set permissions on $destination file!</b></font><br>~;
	}
}

##################
sub setup_config {
##################

my $imageurlvar = $imagesurl || "http://$hosturl/images";
my $themesurlvar = $themesurl || "http://$hosturl/themes";

	print qq~<html>
<head>
<title>$installscriptname $installversion - Automated Perl Portal Installer</title>
</head>
<body>
<center><h2><font color="#000070">$installscriptname v$installversion ($installupdatename) Build:$installbuildnumber<br>Automated Perl Portal Installer</font></h2></center>
<p>
<h3><center>Welcome to the $installscriptname v$installversion Installer. This program will ease the Perl installation process and config.pl setup.<br>On most linux servers this information should be <i>almost</i> correct.</center></h3>
<hr>
<br>
<center><h2><font color=red><b>If you do not know your correct path information, please check with your web hosting provider first!</b></h2></font></center>
<hr>
<center><h3>The correct paths should have been generated <b>automatically</b> for you, but please check to see if they are correct!</h3>
<h3>If your images and themes directories are not found at...<br>
<font color="green">$imageurlvar</font>
<br><font color="green">$themesurlvar</font><br>
...these will have to be changed!</h3></center>
<hr>
<center><h3><b><u>Site Setup</u></b></h3></center>
<form action="install-saveconfig.cgi" method="POST">
<input type="hidden" name="action" value="config2">
<table border="0" width="100%" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2"><b><u>General Settings</u></b></td>
</tr>~;

my $pagenamer = $pagename || $hosturl;

print qq~<tr>
<td>Pagename</td>
<td><input type="text" name="pagename" value="$pagenamer" size="30"></td>
</tr>
<tr>
<td>Pageurl (<b>Change the cgi-bin if you have a different directory</b>)</td>
<td><input type="text" name="pageurl" value="$webappurl" size="80"></td>
</tr>
~;

my $pagetitler = $pagetitle || $hosturl;

print qq~<tr>
<td>Pagetitle</td>
<td><input type="text" name="pagetitle" value="$pagetitler" size="30"></td>
</tr>
~;

my $indexname = $cgi || "index.cgi";

print qq~<tr>
<td>Script Filename</td>
<td><input type="text" name="cgi" value="$indexname" size="30"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Cookies</u></b>&nbsp;&nbsp;&nbsp;&nbsp;(<b><u>Note:</u></b> If your Pagename is <b>My Site</b> you should name your Cookies - mysiteuid, mysitepwd, mysitethm & mysitelng.<b>)</b></td>
</tr>
<tr>
<td>Username Cookie</td>
<td><input type="text" name="cookieusername" value="$cookienameuid" size="30"></td>
</tr>
<tr>
<td>Password Cookie</td>
<td><input type="text" name="cookiepassword" value="$cookienamepwd" size="30"></td>
</tr>
<tr>
<td>Theme Cookie</td>
<td><input type="text" name="cookieusertheme" value="$cookienamethm" size="30"></td>
</tr>
<tr>
<td>Language Cookie</td>
<td><input type="text" name="cookieuserlang" value="$cookienamelng" size="30"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>E-Mail Settings</u></b></td>
</tr>
~;

if (!$mailtype) {
	print qq~<tr>
<td>Mailer type</td>
<td><select name="mailtype">
<option selected value="0">sendmail</option>
<option value="1">SMTP</option>
</select></td>
</tr>
~;
} else {
	print qq~<tr>
<td>Mailer type</td>
<td><select name="mailtype">
<option value="0">sendmail</option>
<option selected value="1">SMTP</option>
</select></td>
</tr>
~;
} 

my $mailvar = $mailprogram || "/usr/sbin/sendmail -t";
my $mailserver = $smtp_server || qq~smtp.$smtpfun~;

print qq~<tr>
<td>Path to mail program</td>
<td><input type="text" name="mailprogram" value="$mailvar" size="80"></td>
</tr>
<tr>
<td>SMTP-Server</td>
<td><input type="text" name="smtp_server" value="$mailserver" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Paths</u></b></td>
</tr>
<tr>
<td>Path to website root directory</td>
<td><input type="text" name="basedir" value="$rootpath" size="80"></td>
</tr>
~;

my $baseurlvar = $baseurl || "http://$hosturl";

print qq~<tr>
<td>Main URL to website root</td>
<td><input type="text" name="baseurl" value="$baseurlvar" size="80"></td>
</tr>
<tr>
<td>Main script URL to WebAPP site (<b>Change the cgi-bin if you have a different directory</b>)</td>
<td><input type="text" name="scripturl" value="$webappurl" size="80"></td>
</tr>
<tr>
<td>Path to main script directory</td>
<td><input type="text" name="scriptdir" value="$scriptpath" size="80"></td>
</tr>
~;

my $sourcedirvar = $sourcedir || "$scriptpath/cgi-lib";

print qq~<tr>
<td>Path to script sources</td>
<td><input type="text" name="sourcedir" value="$sourcedirvar" size="80"></td>
</tr>
~;

my $datadirvar = $datadir || "$scriptpath/db";

print qq~<tr>
<td>Path to data directory</td>
<td><input type="text" name="datadir" value="$datadirvar" size="80"></td>
</tr>
~;

my $memberdirvar = $memberdir || "$scriptpath/db/members";

print qq~<tr>
<td>Path to members directory</td>
<td><input type="text" name="memberdir" value="$memberdirvar" size="80"></td>
</tr>
~;

my $imagedirvar = $imagesdir || "$rootpath/images";

print qq~<tr>
<td>Path to images directory</td>
<td><input type="text" name="imagesdir" value="$imagedirvar" size="80"></td>
</tr>
~;

my $themesdirvar = $themesdir || "$rootpath/themes";

print qq~<tr>
<td>Path to themes directory</td>
<td><input type="text" name="themesdir" value="$themesdirvar" size="80"></td>
</tr>
<tr>
<td>URL to images directory</td>
<td><input type="text" name="imagesurl" value="$imageurlvar" size="80"></td>
</tr>
<tr>
<td>URL to themes directory</td>
<td><input type="text" name="themesurl" value="$themesurlvar" size="80"></td>
</tr>
~;

my $uploaddirvar = $uploaddir || "$rootpath/images/uploads";

print qq~<tr>
<td>Path to Uploaded Images Directory</td>
<td><input type="text" name="uploaddir" value="$uploaddirvar" size="80"></td>
</tr>
~;

my $uploadurlvar = $uploadurl || "http://$hosturl/images/uploads";

print qq~<tr>
<td>URL to Uploaded Images Directory</td>
<td><input type="text" name="uploadurl" value="$uploadurlvar" size="80"></td>
</tr>
~;

my $maxupvar = $maxuploadsize || "150";

print qq~<tr>
<td>Max Uploaded Image Size (KB)</td>
<td><input type="text" name="maxuploadsize" value="$maxupvar" size="5"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Language Support</u></b></td>
</tr>
~;

my $langdirvar = $langdir || "$scriptpath/lang";
my $backlangvar = $lang || "$scriptpath/lang/english.lng";
my $deflangvar = $language || "english.lng";

print qq~<tr>
<td>Language Directory</td>
<td><input type="text" name="lang_dir" value="$langdirvar" size="80"><BR></td>
</tr>
<tr>
<td>Site Language</td>
<td><input type="text" name="backup_lang" value="$backlangvar" size="80"><BR></td>
</tr>
<tr>
<td>Default Language</td>
<td><input type="text" name="default_lang" value="$deflangvar" size="30"><BR></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Contact Info</u></b></td>
</tr>
~;

my $compnamevar = $compname || $hosturl;
my $compaddvar = $compadd || "5555 Lane";
my $compcityvar = $compcity || "Some Town";
my $compstatevar = $compstate || "State";
my $compzipvar = $compzip || "Zip";
my $compphonevar = $compphone || "Phone";
my $compfaxvar = $compfax || "Fax";
my $compemailvar = $compemail || "Company E-Mail";
my $wmemailvar = $webmaster_email || "Webmaster E-Mail";

print qq~<tr>
<td>Company Name</td>
<td><input type="text" name="compname" value="$compnamevar" size="80"></td>
</tr>
<tr>
<td>Company Address</td>
<td><input type="text" name="compadd" value="$compaddvar" size="80"></td>
</tr>
<tr>
<td>Company City</td>
<td><input type="text" name="compcity" value="$compcityvar" size="80"></td>
</tr>
<tr>
<td>Company State</td>
<td><input type="text" name="compstate" value="$compstatevar" size="80"></td>
</tr>
<tr>
<td>Company Zip</td>
<td><input type="text" name="compzip" value="$compzipvar" size="80"></td>
</tr>
<tr>
<td>Company Phone</td>
<td><input type="text" name="compphone" value="$compphonevar" size="80"></td>
</tr>
<tr>
<td>Company Fax</td>
<td><input type="text" name="compfax" value="$compfaxvar" size="80"></td>
</tr>
<tr>
<td>Company E-Mail</td>
<td><input type="text" name="compemail" value="$compemailvar" size="80"></td>
</tr>
<tr>
<td>Webmaster E-Mail</td>
<td><input type="text" name="webmaster_email" value="$wmemailvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Articles</u></b></td>
</tr>
~;

my $topicsdirvar = $topicsdir || "$scriptpath/db/topics";

print qq~<tr>
<td>Path to topics directory</td>
<td><input type="text" name="topicsdir" value="$topicsdirvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Forums</u></b></td>
</tr>
~;

my $boardsdirvar = $boardsdir || "$scriptpath/db/forum";

print qq~<tr>
<td>Path to forums directory</td>
<td><input type="text" name="boardsdir" value="$boardsdirvar" size="80"></td>
</tr>
~;

my $messagedirvar = $messagedir || "$scriptpath/db/forum/messages";

print qq~<tr>
<td>Path to messages directory</td>
<td><input type="text" name="messagedir" value="$messagedirvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Statistics</u></b></td>
</tr>
~;

my $logdirvar = $logdir || "$scriptpath/db/stats";

print qq~<tr>
<td>Path to stats directory</td>
<td><input type="text" name="logdir" value="$logdirvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Links</u></b></td>
</tr>
~;

my $linksdirvar = $linksdir || "$scriptpath/db/links";

print qq~<tr>
<td>Path to links directory</td>
<td><input type="text" name="linksdir" value="$linksdirvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Downloads</u></b></td>
</tr>
~;

my $dldirvar = $downloadsdir || "$scriptpath/db/downloads";

print qq~<tr>
<td>Path to downloads directory</td>
<td><input type="text" name="downloadsdir" value="$dldirvar" size="80"></td>
</tr>
<tr>
<td colspan="2"><hr><b><u>Other Settings</u></b></td>
</tr>
<tr>
<td>Time Difference</td>
<td><select name="timeoffset">~;

	my $offsetvar = $timeoffset || "0";

	open (ZONES,"./db/timezones.dat") || print "cannot open ./db/timezones.dat";
	while(<ZONES>){
		chomp;
		@zitem = split(/\|/);

		if (! $zitem[1] && $zitem[0] ne "0") { next; }

		if ($zitem[0] eq "$offsetvar") {
			$selected = "selected";
		} else {
			$selected = "";
		}
		print qq~<option value="$zitem[0]" $selected>$zitem[1]</option>~;
	}
	close (ZONES);

	print qq~</select>~;

	($sec, $min, $hour, $mday, $mon, $year) = (localtime(time))[0..5];
	if ($hour < 10) { $hour = "0" . $hour; }
	if ($min < 10) { $min = "0" . $min; }
	if ($sec < 10) { $sec = "0" . $sec; } 
	$year += 1900;
	if ($mday < 10) { $mday = "0" . $mday; }

	my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
	$currenttime = "$hour:$min:$sec on $mday $months[$mon] $year Server Time"; # get current server time

	print qq~ $currenttime</td>
</tr>
<tr>
<td>Time Zone</td>
<td><select name="timezone">
~;

	my $timezonevar = $timezone || "0";

	open (ZONES,"./db/timezones.dat") || print "cannot open ./db/timezones.dat";

	while(<ZONES>){
		chomp;
		@zitem = split(/\|/);

		if ($zitem[0] eq "$timezonevar") {
			$selected = "selected";
		} else {
			$selected = "";
		}
		print qq~<option value="$zitem[0]" $selected>$zitem[2] $zitem[3]: $zitem[5]</option>~;
	}

	close (ZONES);

	print qq~</select>
</td>
</tr>
~;

if ((!$check_date) || ($check_date eq "american")) {
	print qq~<tr>
<td>Date Format</td>
<td><select name="check_date">
<option selected value="american">American (mm/dd/yy)</option>
<option value="european">European (dd/mm/yy)</option>
</select>
</td>
</tr>
~;
} else {
	print qq~<tr>
<td>Date Format</td>
<td><select name="check_date">
<option value="american">American (mm/dd/yy)</option>
<option selected value="european">European (dd/mm/yy)</option>
</select>
</td>
</tr>~;
}

if (($use_flock) || (!defined $use_flock)) {
	print qq~<tr>
<td>File Locking</td>
<td><select name="use_flock">
<option selected value="1">On</option>
<option value="0">Off</option>
</select></td>
</tr>~;
} else {
	print qq~<tr>
<td>File Locking</td>
<td><select name="use_flock">
<option selected value="1">On</option>
<option value="0">Off</option>
</select></td>
</tr>
~;
}

print qq~<tr>
<td>LOCK_EX</td>
<td><input type="text" maxlength="2" name="LOCK_EX" value="2" size="1"></td>
</tr>
<tr>
<td>LOCK_UN</td>
<td><input type="text" maxlength="2" name="LOCK_UN" value="8" size="1"></td>
</tr>
<tr>
<td>IIS</td>
<td><select name="IIS">
<option value="0">Auto</option>
<option value="1">IIS</option>
<option selected value="2">Apache</option>
</select></td>
</tr>
<tr>
<td>Server OS</td>
<td><select name="server_os">
<option selected value="linux">Linux</option>
<option value="windows">Windows</option>
</select></td>
</tr>
<tr>
<td colspan="2"><hr></td>
</tr>
<tr>
<td align="center" colspan="2"><input type="submit" value="Save"></td>
</tr>
</table>
</form>
</body>
</html>
~;

	exit;
}

###################
sub setup_config2 {
###################

	if ($input{'timeoffset'} eq "") {$input{'timeoffset'} = "0";}
	if ($input{'timezone'} eq "") {$input{'timezone'} = "0";}

	%conf=();
	##################
	# General Settings
	##################
	$conf{'page_name'}=$input{'pagename'};
	$conf{'page_url'}=$input{'pageurl'};
	$conf{'page_title'}=$input{'pagetitle'};
	$conf{'cgi'}=$input{'cgi'};
	$conf{'cookieusername'}=$input{'cookieusername'};
	$conf{'cookiepassword'}=$input{'cookiepassword'};
	$conf{'cookieusertheme'}=$input{'cookieusertheme'};
	$conf{'cookieuserlang'}=$input{'cookieuserlang'};
	$conf{'mailtype'}=$input{'mailtype'};
	$conf{'mailprog'}=$input{'mailprogram'};
	$conf{'smtp_server'}=$input{'smtp_server'};
	$conf{'base_dir'}=$input{'basedir'};
	$conf{'base_url'}=$input{'baseurl'};
	$conf{'script_url'}=$input{'scripturl'};
	$conf{'script_dir'}=$input{'scriptdir'};
	$conf{'lib_dir'}=$input{'sourcedir'};
	$conf{'data_dir'}=$input{'datadir'};
	$conf{'member_dir'}=$input{'memberdir'};
	$conf{'images_dir'}=$input{'imagesdir'};
	$conf{'themes_dir'}=$input{'themesdir'};
	$conf{'images_url'}=$input{'imagesurl'};
	$conf{'themes_url'}=$input{'themesurl'};
	$conf{'lang_dir'}=$input{'lang_dir'};
	$conf{'default_lang'}=$input{'default_lang'};
	$conf{'backup_lang'}=$input{'backup_lang'};
	########################
	# Contact Settings
	########################
	$conf{'compname'}=$input{'compname'};
	$conf{'compadd'}=$input{'compadd'};
	$conf{'compcity'}=$input{'compcity'};
	$conf{'compstate'}=$input{'compstate'};
	$conf{'compzip'}=$input{'compzip'};
	$conf{'compphone'}=$input{'compphone'};
	$conf{'compfax'}=$input{'compfax'};
	$conf{'compemail'}=$input{'compemail'};
	$conf{'webmaster_email'}=$input{'webmaster_email'};
	########################
	# IM Settings
	########################
	$conf{'bmheadercolor'}="#000070";
	$conf{'bmbgcolor'}="#FFFFFF";
	$conf{'welcome_im'} = $welcome_im || "1";
	$conf{'newuser_im'} = $newuser_im || "1";
	$conf{'article_im'} = $article_im || "1";
	########################
	# Information Settings
	########################
	$conf{'image1'} = $image1 || "$input{'imagesurl'}/perl.gif";
	$conf{'link1'} = $link1 || "http://www.perlmonks.com/";
	$conf{'image2'} = $image2 || "$input{'imagesurl'}/gnugpl.png";
	$conf{'link2'} = $link2 || "http://www.gnu.org/copyleft/gpl.html";
	$conf{'image3'} = $image3 || "$input{'imagesurl'}/webapp993.gif";
	$conf{'link3'} = $link3 || "http://www.web-app.net/";
	########################
	# News Specific Settings
	########################
	$conf{'topic_dir'}=$input{'topicsdir'};
	$conf{'maxnews'} = $maxnews || "5";
	$conf{'maxtopics'} = $maxtopics || "25";
	$conf{'enable_userarticles'} = $enable_userarticles || "1";
	$conf{'allow_html'} = $allow_html || "1";
	$conf{'enable_topicguestposting'} = $enable_topicguestposting || "0";
	$conf{'enable_autopublish'} = $enable_autopublish || "1";
	$conf{'article_imrecip'} = $article_imrecip || "admin";
	$conf{'topicimgupld'} = $topicimgupld || "1";
	##########################
	# Forums Specific Settings
	##########################
	$conf{'forum_dir'}=$input{'boardsdir'};
	$conf{'message_dir'}=$input{'messagedir'};
	$conf{'enable_guestposting'} = $enable_guestposting || "0";
	$conf{'enable_notification'} = $enable_notification || "1";
	$conf{'maxdisplay'} = $maxdisplay || "25";
	$conf{'maxmessagedisplay'} = $maxmessagedisplay || "15";
	$conf{'insert_original'} = $insert_original || "1";
	$conf{'max_log_days_old'} = $max_log_days_old || "21";
	$conf{'forumimgupld'} = $forumimgupld || "1";
	#########################
	# Smilies/UBBC Settings
	#########################
	$conf{'enable_ubbc'} = $enable_ubbc || "1";
	$conf{'enable_smile'} = $enable_smile || "1";
	$conf{'imageicons'} = $imageicons || "0";
	#########################
	# Stats Specific Settings
	#########################
	$conf{'log_dir'}=$input{'logdir'};
	$conf{'ip_time'} = $ip_time || "0";
	$conf{'top_browsers'} = $top_browsers || "1";
	$conf{'top_os'} = $top_os || "1";
	#########################
	# Links Specific Settings
	#########################
	$conf{'links_dir'}=$input{'linksdir'};
	$conf{'maxlinks'} = $maxlinks || "30";
	$conf{'adminonlyl'} = $adminonlyl || "1";
	$conf{'showlatestlinks'} = $showlatestlinks || "1";
	#########################
	# Downloads Specific Settings
	#########################
	$conf{'download_dir'}=$input{'downloadsdir'};
	$conf{'maxdownloads'} = $maxdownloads || "30";
	$conf{'antileech'} = $antileech || "1";
	$conf{'adminonlyd'} = $adminonlyd || "1";
	$conf{'showlatestdownloads'} = $showlatestdownloads || "1";
	############################
	# Admin Assistant Settings
	############################
	$conf{'dispmost'} = $dispmost || "1";
	$conf{'dispstat'} = $dispstat || "0";
	$conf{'infoblockmod'} = $infoblockmod || "1";
	$conf{'dispfrad'} = $dispfrad || "1";
	$conf{'showcon'} = $showcon || "1";
	$conf{'showcon2'} = $showcon2 || "1";
	$conf{'hidemail'} = $hidemail || "1";
	$conf{'letmemdel'} = $letmemdel || "0";
	$conf{'letmemlng'} = $letmemlng || "1";
	$conf{'letmemthm'} = $letmemthm || "1";
	$conf{'searchmod'} = $searchmod || "1";
	$conf{'hidememlist'} = $hidememlist || "0";
	$conf{'maxmembersdisplay'} = $maxmembersdisplay || "30";
	$conf{'modulecal'} = $modulecal || "0";
	$conf{'modulenl'} = $modulenl || "1";
	$conf{'pollmod'} = $pollmod || "1";
	$conf{'multiplevoting'} = $multiplevoting || "0";
	$conf{'modulenlmem'} = $modulenlmem || "0";
	$conf{'botkiller'} = $botkiller || "0";
	$conf{'signupmethod'} = $signupmethod || "0";
	$conf{'timezone'}=$input{'timezone'};
	$conf{'defaulttheme'} = $defaulttheme || "standard";
	$conf{'check_date'}=$input{'check_date'};
	################
	# Admin Access
	################
	$conf{'editwelc'} = $editwelc || "0";
	$conf{'editabout'} = $editabout || "0";
	$conf{'editim'} = $editim || "0";
	$conf{'editbanner'} = $editbanner || "0";
	$conf{'editfaq'} = $editfaq || "0";
	$conf{'editdown'} = $editdown || "0";
	$conf{'editlink'} = $editlink || "0";
	$conf{'modadmin'} = $modadmin || "0";
	$conf{'editcats'} = $editcats || "1";
	$conf{'editboards'} = $editboards || "1";
	$conf{'editcensor'} = $editcensor || "1";
	$conf{'editpoll'} = $editpoll || "1";
	$conf{'pubnews'} = $pubnews || "1";
	$conf{'editnews'} = $editnews || "1";
	$conf{'edittops'} = $edittops || "0";
	$conf{'editlblk'} = $editlblk || "0";
	$conf{'editrblk'} = $editrblk || "0";
	$conf{'edittblk'} = $edittblk || "0";
	$conf{'editbtmblk'} = $editbtmblk || "0";
	$conf{'editcal'} = $editcal || "0";
	$conf{'editnl'} = $editnl || "0";
	$conf{'editip'} = $editip || "1";
	################
	# Other Settings
	################
	$conf{'timeoffset'}=$input{'timeoffset'};
	$conf{'memberpic_height'} = $memberpic_height || "0";
	$conf{'memberpic_width'} = $memberpic_width || "60";
	$conf{'maxuploadsize'}=$input{'maxuploadsize'};
	$conf{'upload_url'}=$input{'uploadurl'};
	$conf{'upload_dir'}=$input{'uploaddir'};
	$conf{'use_flock'}=$input{'use_flock'};
	$conf{'LOCK_EX'}=$input{'LOCK_EX'};
	$conf{'LOCK_UN'}=$input{'LOCK_UN'};
	$conf{'IIS'}=$input{'IIS'};
	$conf{'server_os'}=$input{'server_os'};
	################
	# Module Paths
	################
	$conf{'poll_dir'}="$input{'datadir'}/polls";
	$conf{'newsletter_dir'}="$input{'datadir'}/newsletter";
	################
	# Mods Paths
	################
	$conf{'mods_dir'}="$input{'scriptdir'}/mods";
	$conf{'mods_url'}="$input{'scripturl'}/mods";
	################
	# Misc Paths
	################
	$conf{'user_lib'}="$input{'scriptdir'}/user-lib";
	$conf{'upgrade_lib'}="$input{'scriptdir'}/upgrade-lib";
	################
	# WebAPP Settings
	################
	$conf{'scriptname'} = $scriptname || $installscriptname;
#	$conf{'scriptver'}=$installversion; # now using sub ver as of 0.9.9.2
	$conf{'updatever'} = $updatever || $installupdatename;
	$conf{'scriptbuildnumber'} = $scriptbuildnumber || $installbuildnumber;
	$conf{'web_dir'}=$input{'basedir'};

	# Define the Location of the config.dat File ###################################
	$filename="$input{'scriptdir'}/conf/config.dat";
	$config_dir = "$input{'scriptdir'}/conf";
	$config_script = "$input{'scriptdir'}/config.pl";

	# Write the config.dat File ####################################################
	open OTF,">$filename" or die ("Could not open $filename!");
	foreach $thing (keys %conf) {
		print OTF "$thing|$conf{$thing}\n";
	}
	close OTF;

	# Write config.pl ############################################################
 	open FILE,">$config_script" or die ("Could not open $config_script!");

	print FILE qq~###############################################################################
###############################################################################
# $installscriptname                                                          #
#-----------------------------------------------------------------------------#
# config.pl                                                                   #
# v$installversion                                                            #
#                                                                             #
# Security Patch by Big R                                                     #
# Patching System by Floyd                                                    #
#                                                                             #
# (WebAPP NE Copyright (c) WebAPP Network group - www.web-app.net)            # 
#                                                                             # 
# WebAPP NE is the continued development of WebAPP, beginning with            #
# upgrade from WebAPP v0.9.9.3.2 to WebAPP v0.9.9.3.3 NE in June 2006         #
# (WebAPP Copyright (c) WebAPP - www.web-app.org and                          #
# M. Carter Brown - www.mcarterbrown.com)                                     #
#                                                                             # 
# WebAPP was based on YaWPS in 2002 - yawps.sourceforge.net                   # 
# (YaWPS  Copyright (c) 2001 by d3m1g0d)                                      #
#                                                                             # 
# YaWPS was based on YaBB in 2001 by Zef Hemel - www.zefhemel.com             # 
# (YaBB Copyright (c) 2000 The YaBB Programming team)                         # 
#                                                                             #
# This file is part of WebAPP NE.                                             #
#                                                                             #
# WebAPP NE is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation; either version 2 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# WebAPP NE is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with WebAPP NE; if not, write to the Free Software Foundation, Inc.,  #
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.               #
#                                                                             #
# File: Modified: 2006                                                        #
###############################################################################
###############################################################################

\$config_dir='$config_dir';

&loadConfig("\$config_dir/config.dat");
&exportConfig(\\%waconf);

################
sub loadConfig {
################

	my \$conf_file="\$config_dir/config.dat";
	open INCFG,"<\$conf_file" or die ("Could not open \$conf_file\\n");
	%waconf=();
	my \$next='';
	my \$key='';
	my \$val='';
	while (\$next=<INCFG>) {
		chomp \$next;
		(\$key,\$val)=split(/\\|/,\$next);
		\$waconf{\$key}=\$val;
	}
	close INCFG;
}

##################
sub exportConfig {
##################

	\$cref=shift;
	##################
	# General Settings
	##################
	\$pagename = \$\$cref{'page_name'};
	\$pageurl = \$\$cref{'page_url'};
	\$pagetitle = \$\$cref{'page_title'};

	\$cgi=\$\$cref{'cgi'};

	\$cookieusername = \$\$cref{'cookieusername'};
	\$cookiepassword = \$\$cref{'cookiepassword'};
	\$cookieusertheme = \$\$cref{'cookieusertheme'};
	\$cookieuserlang = \$\$cref{'cookieuserlang'};

	\$mailtype = \$\$cref{'mailtype'};
	\$mailprogram = \$\$cref{'mailprog'};
	\$smtp_server =  \$\$cref{'smtp_server'};

	\$basedir   = \$\$cref{'base_dir'};
	\$baseurl   = \$\$cref{'base_url'};
	\$scriptdir = \$\$cref{'script_dir'};
	\$scripturl = \$\$cref{'script_url'};
	\$sourcedir = \$\$cref{'lib_dir'};
	\$datadir   = \$\$cref{'data_dir'};
	\$memberdir = \$\$cref{'member_dir'};

	\$imagesdir = \$\$cref{'images_dir'};
	\$themesdir = \$\$cref{'themes_dir'};
	\$imagesurl = \$\$cref{'images_url'};
	\$themesurl = \$\$cref{'themes_url'};

	\$language = \$\$cref{'default_lang'};
	\$langdir = \$\$cref{'lang_dir'};
	\$lang = \$\$cref{'backup_lang'};

	##################
	# Contact Settings
	##################
	\$compname = \$\$cref{'compname'};
	\$compadd = \$\$cref{'compadd'};
	\$compcity = \$\$cref{'compcity'};
	\$compstate = \$\$cref{'compstate'};
	\$compzip = \$\$cref{'compzip'};
	\$compphone = \$\$cref{'compphone'};
	\$compfax = \$\$cref{'compfax'};
	\$compemail = \$\$cref{'compemail'};
	\$webmaster_email = \$\$cref{'webmaster_email'};

	#############
	# IM Settings
	#############
	\$bmheadercolor = \$\$cref{'bmheadercolor'};
	\$bmbgcolor = \$\$cref{'bmbgcolor'};
	\$welcome_im = \$\$cref{'welcome_im'};
	\$newuser_im = \$\$cref{'newuser_im'};
	\$article_im = \$\$cref{'article_im'};

	######################
	# Information Settings
	######################
	\$image1 = \$\$cref{'image1'};
	\$link1 = \$\$cref{'link1'};
	\$image2 = \$\$cref{'image2'};
	\$link2 = \$\$cref{'link2'};
	\$image3 = \$\$cref{'image3'};
	\$link3 = \$\$cref{'link3'};

	########################
	# News Specific Settings
	########################
	\$topicsdir = \$\$cref{'topic_dir'};
	\$maxnews = \$\$cref{'maxnews'};
	\$maxtopics = \$\$cref{'maxtopics'};
	\$enable_userarticles = \$\$cref{'enable_userarticles'};
	\$allow_html = \$\$cref{'allow_html'};
	\$enable_topicguestposting = \$\$cref{'enable_topicguestposting'};
	\$enable_autopublish = \$\$cref{'enable_autopublish'};
	\$article_imrecip = \$\$cref{'article_imrecip'};
	\$topicimgupld = \$\$cref{'topicimgupld'};

	##########################
	# Forums Specific Settings
	##########################
	\$boardsdir = \$\$cref{'forum_dir'};
	\$messagedir = \$\$cref{'message_dir'};
	\$enable_guestposting = \$\$cref{'enable_guestposting'};
	\$enable_notification = \$\$cref{'enable_notification'};
	\$maxdisplay = \$\$cref{'maxdisplay'};
	\$maxmessagedisplay = \$\$cref{'maxmessagedisplay'};
	\$insert_original = \$\$cref{'insert_original'};
	\$max_log_days_old = \$\$cref{'max_log_days_old'};
	\$forumimgupld = \$\$cref{'forumimgupld'};

	#######################
	# Smilies/UBBC Settings
	#######################
	\$enable_ubbc = \$\$cref{'enable_ubbc'};
	\$enable_smile = \$\$cref{'enable_smile'};
	\$imageicons = \$\$cref{'imageicons'};

	#########################
	# Stats Specific Settings
	#########################
	\$logdir = \$\$cref{'log_dir'};
	\$ip_time = \$\$cref{'ip_time'};
	\$top_browsers = \$\$cref{'top_browsers'};
	\$top_os = \$\$cref{'top_os'};

	#########################
	# Links Specific Settings
	#########################
	\$linksdir = \$\$cref{'links_dir'};
	\$maxlinks = \$\$cref{'maxlinks'};
	\$adminonlyl = \$\$cref{'adminonlyl'};
	\$showlatestlinks = \$\$cref{'showlatestlinks'};

	#############################
	# Downloads Specific Settings
	#############################
	\$downloadsdir = \$\$cref{'download_dir'};
	\$maxdownloads = \$\$cref{'maxdownloads'};
	\$antileech = \$\$cref{'antileech'};
	\$adminonlyd = \$\$cref{'adminonlyd'};
	\$showlatestdownloads = \$\$cref{'showlatestdownloads'};

	##########################
	# Admin Assistant Settings
	##########################
	\$dispmost = \$\$cref{'dispmost'};
	\$dispstat = \$\$cref{'dispstat'};
	\$infoblockmod = \$\$cref{'infoblockmod'};
	\$dispfrad = \$\$cref{'dispfrad'};
	\$showcon = \$\$cref{'showcon'};
	\$showcon2 = \$\$cref{'showcon2'};
	\$hidemail = \$\$cref{'hidemail'};
	\$letmemdel = \$\$cref{'letmemdel'};
	\$letmemlng = \$\$cref{'letmemlng'};
	\$letmemthm = \$\$cref{'letmemthm'};
	\$searchmod = \$\$cref{'searchmod'};
	\$hidememlist = \$\$cref{'hidememlist'};
	\$maxmembersdisplay = \$\$cref{'maxmembersdisplay'};
	\$modulecal = \$\$cref{'modulecal'};
	\$modulenl = \$\$cref{'modulenl'};
	\$pollmod = \$\$cref{'pollmod'};
	\$multiplevoting = \$\$cref{'multiplevoting'};
	\$modulenlmem = \$\$cref{'modulenlmem'};
	\$botkiller = \$\$cref{'botkiller'};
	\$signupmethod = \$\$cref{'signupmethod'};
	\$timezone = \$\$cref{'timezone'};
	\$defaulttheme = \$\$cref{'defaulttheme'};
	\$check_date = \$\$cref{'check_date'};

	##############
	# Admin Access
	##############
	\$editwelc = \$\$cref{'editwelc'};
	\$editabout = \$\$cref{'editabout'};
	\$editim = \$\$cref{'editim'};
	\$editbanner = \$\$cref{'editbanner'};
	\$editfaq = \$\$cref{'editfaq'};
	\$editdown = \$\$cref{'editdown'};
	\$editlink = \$\$cref{'editlink'};
	\$modadmin = \$\$cref{'modadmin'};
	\$editcats = \$\$cref{'editcats'};
	\$editboards = \$\$cref{'editboards'};
	\$editcensor = \$\$cref{'editcensor'};
	\$editpoll = \$\$cref{'editpoll'};
	\$pubnews = \$\$cref{'pubnews'};
	\$editnews = \$\$cref{'editnews'};
	\$edittops = \$\$cref{'edittops'};
	\$editlblk = \$\$cref{'editlblk'};
	\$editrblk = \$\$cref{'editrblk'};
	\$edittblk = \$\$cref{'edittblk'};
	\$editbtmblk = \$\$cref{'editbtmblk'};
	\$editcal = \$\$cref{'editcal'};
	\$editnl = \$\$cref{'editnl'};
	\$editip = \$\$cref{'editip'};

	################
	# Other Settings
	################
	\$timeoffset = \$\$cref{'timeoffset'};
	\$memberpic_height = \$\$cref{'memberpic_height'};
	\$memberpic_width = \$\$cref{'memberpic_width'};
	\$maxuploadsize = \$\$cref{'maxuploadsize'};
	\$uploaddir = \$\$cref{'upload_dir'};
	\$uploadurl = \$\$cref{'upload_url'};
	\$use_flock = \$\$cref{'use_flock'};
	\$LOCK_EX = \$\$cref{'LOCK_EX'};
	\$LOCK_UN = \$\$cref{'LOCK_UN'};
	\$IIS =  \$\$cref{'IIS'};
	\$server_os =  \$\$cref{'server_os'};

	##############
	# Module Paths
	##############
	\$poll_dir = \$\$cref{'poll_dir'};
	\$newsletter_dir =  \$\$cref{'newsletter_dir'};

	############
	# Mods Paths
	############
	\$mods_dir = \$\$cref{'mods_dir'};
	\$mods_url =  \$\$cref{'mods_url'};

	############
	# Misc Paths
	############
	\$user_lib = \$\$cref{'user_lib'};
	\$upgrade_lib =  \$\$cref{'upgrade_lib'};

	#################
	# WebAPP Settings
	#################
	\$scriptname = \$\$cref{'scriptname'};
\#	\$scriptver =  \$\$cref{'scriptver'}; \# now using sub ver as of 0.9.9.2
	\$updatever = \$\$cref{'updatever'};
	\$scriptbuildnumber = \$\$cref{'scriptbuildnumber'};
	\$web_dir = \$\$cref{'web_dir'};

}

1; #return true
~;

	close(FILE);

	if ($newinstall) { # ONLY REWRITE THE FOLLOWING 3 FILES FOR A NEW INSTALL:

# Write calendar.cfg: ############################################################

		$input{'webmaster_email'} =~ s/\@/\\@/;

		open(DATA, ">./mods/calendar/data/calendar.cfg");

		print DATA qq~

	#---------------------------------
	# General Settings
	#---------------------------------
	\$cm_title                    = "Calendar";
	\$cm_requireAdminApproval     =  1;
	\$cm_emailAdminNewEventNotice =  1;
	\$cm_eventAdminEmailAddress   = "$input{'webmaster_email'}";

	#---------------------------------
	# Paths & Files
	#---------------------------------
	\$cm_scriptDir           = "$input{'scriptdir'}/mods/calendar";
	\$cm_dataDir             = "$input{'scriptdir'}/mods/calendar/data";
	\$cm_langDir             = "$input{'scriptdir'}/mods/calendar/lang";
	\$cm_scriptUrl           = "$input{'scripturl'}/mods/calendar/index.cgi";
	\$cm_adminScriptUrl      = "$input{'scripturl'}/mods/calendar/admin/admin.cgi";
	\$cm_eventsFileName      = "calendar.dat";
	\$cm_langFileName        = "english.lng";
	\$cm_detailIconUrl       = "$input{'imagesurl'}/calendar/calendar.gif";

	#---------------------------------
	# Database Settings
	#---------------------------------
	\$cm_delimiter           = "	";
	\$cm_useFileLocking      =  1;

	#---------------------------------
	# Style Elements
	#---------------------------------
	# Sidebar Calendar
	#---------------------------------
	\$cmsb_cellSize          = "16";
	\$cmsb_borderWidth       = "0";
	\$cmsb_borderStyle       = "padding: 2px";
	\$cmsb_headFontStyle     = "text-align: center";
	\$cmsb_dayHeadFontStyle  = "font-size: 11px";
	\$cmsb_dayHeadCellStyle  = "text-align: center";
	\$cmsb_selFontStyle      = "font-size: 10px";
	\$cmsb_selCellStyle      = "font-weight:bold; background-color:#94a5e7";
	\$cmsb_stdFontStyle      = "font-size: 10px";
	\$cmsb_stdCellStyle      = "";
	\$cmsb_emptyCellStyle    = "font-size: 10px";

	#---------------------------------
	# Large Calendar (show detail)
	#---------------------------------
	\$cml_cellSize           = "60";
	\$cml_borderWidth        = "1";
	\$cml_borderStyle        = "padding: 2px";

	#---------------------------------
	# Small Calendar (hide detail)
	#---------------------------------
	\$cms_cellSize           = "30";
	\$cms_borderWidth        = "1";
	\$cms_borderStyle        = "padding: 2px";

	#---------------------------------
	# Large & Small Calendars
	#---------------------------------
	\$cm_headFontStyle       = "";
	\$cm_dayHeadFontStyle    = "";
	\$cm_dayHeadCellStyle    = "";
	\$cm_selFontStyle        = "";
	\$cm_selCellStyle        = "background-color:#ffffcc";
	\$cm_stdFontStyle        = "";
	\$cm_stdCellStyle        = "";
	\$cm_todayFontStyle      = "color: red; font-weight: bold";
	\$cm_emptyCellStyle      = "";

	1; #return true
~;

		close(DATA);

		# Write banners/data.txt: ################################
		my $bannerdata = "$conf{'data_dir'}/banners/data.txt";
		my $bannerimgurl = "$conf{'images_url'}/banners";

		open(BANNERDAT, ">$bannerdata") or die ("Could not open $bannerdata!");

		print BANNERDAT qq~http://www.web-app.net|$bannerimgurl/banner1.gif|468|60|Web-App - Your World, Your Way|0
http://www.web-app.net|$bannerimgurl/banner2.gif|468|60|Web-App - Your World, Your Way|0
http://www.web-app.net|$bannerimgurl/banner3.gif|468|60|Web-App - Your World, Your Way|0
http://www.web-app.net|$bannerimgurl/banner4.gif|468|60|Web-App - Your World, Your Way|0~;

		close(BANNERDAT);

# Write forum/Welcome.txt and forum/messages/1.txt: ##

		$boarddata = "$conf{'data_dir'}/forum/Welcome.txt";
		$msgdata = "$conf{'data_dir'}/forum/messages/1.txt";

		($sec, $min, $hour, $mday, $mon, $year) = (localtime(time))[0..5];
		if ($hour < 10) { $hour = "0" . $hour; }
		if ($min < 10) { $min = "0" . $min; }
		if ($sec < 10) { $sec = "0" . $sec; } 
		$year += 1900;
		if ($mday < 10) { $mday = "0" . $mday; }
		$mon += 1;
		if ($mon < 10) { $mon = "0" . $mon; }
		$forumdate = qq~$mon/$mday/$year - $hour:$min:$sec~;

		open(BOARDDAT, ">$boarddata") or die ("Could not open $boarddata!");
		print BOARDDAT qq~1|Everything has installed correctly!|Admin|admin|$conf{'webmaster_email'}|$forumdate|0|1|Admin|thumbup|0~;
		close(BOARDDAT);

		open(MSGDAT, ">$msgdata") or die ("Could not open $msgdata!");
		print MSGDAT qq~Everything has installed correctly!|Admin|$conf{'webmaster_email'}|$forumdate|admin|thumbup|$ENV{REMOTE_ADDR}|Looks as if everything has installed correctly!<br><br>Drop any comments, questions, or bugs to<br><br>[url=http://www.web-app.net]web-app.net[/url]~;
		close(MSGDAT);
	} # END WRITING THREE FILES DONE ONLY FOR NEW INSTALLS

#####################################################

	$indexfile = "$input{'cgi'}";

	print qq~
<html>
<title>$installscriptname v$installversion - Automated Perl Portal Installer</title>
<body>
<form action="install-saveconfig.cgi">
<input type="hidden" name="action" value="config3">
<p><font color="green" size="4"><b>>>> Configuration Updated!!!</font></p>
~;

	chmod_file("$indexfile", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> $indexfile permissions set</b><br></font> ~;
	}

	chmod_file("captcha.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> captcha.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/banners.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/banners.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/blockleft.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/blockleft.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/blockright.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/blockright.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/blocktop.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/blocktop.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/blockbottom.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/blockbottom.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/downloadadmin.cgi", "0755");
	if ($chmodfailed ne "1") {
	print qq~<font color="green" size="4"><b>>>> /admin/downloadadmin.cgi permissions set</b><br></font> ~;}

	chmod_file("./admin/help.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/help.cgi permissions set</b><br></font>~;
	}

	chmod_file("./admin/language.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/language.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/linksadmin.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/linksadmin.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/logs.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/logs.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/showhtml.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/showhtml.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/prodata.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/prodata.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/themes.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/themes/*.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/menuman.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> menuman.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/upload.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /admin/upload.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./admin/galupload.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> galupload.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./mods/modmanager.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /mods/modmanager.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./mods/calendar/index.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /mods/calendar/index.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./mods/calendar/sidebar.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /mods/calendar/sidebar.cgi permissions set</b><br></font> ~;
	}

	chmod_file("./mods/calendar/admin/admin.cgi", "0755");
	if ($chmodfailed ne "1") {
		print qq~<font color="green" size="4"><b>>>> /mods/calendar/admin/admin.cgi permissions set</b><br></font> ~;
	}

	print qq~<hr>
<br>
First, was the installation successful?  <a href="./$indexfile" target="_blank">Click Here to See</a>.<br>
<br>
<b>If everything is correct:<br> <font color="red"> Remove the "install-saveconfig.cgi" file</font> from your /cgi-bin/ folder by clicking the submit button below!</b><br><br>
Make sure that the attributes (chmod) is set correctly:<br>
>>> $indexfile >>> chmod 755<br>
Also, make sure that you have the correct path information from your web hosting provider!<br><br>
<hr>
<br>
<b>click the button below to edit your "index.html" file </b>to reflect your new site.  Install-saveconfig.cgi will automatically be deleted after hitting "submit".<br><br>
<br><center>
<table>
<tr>
<td align="center" colspan="2">~;

	print qq~<input type="hidden" name="baseurl" value="$input{'baseurl'}">
<input type="hidden" name="basedir" value="$input{'basedir'}">
<input type="hidden" name="pagetitle" value="$input{'pagetitle'}">
<input type="hidden" name="pageurl" value="$input{'pageurl'}">
<input type="hidden" name="cgi" value="$indexfile">
<input type="submit" value="Submit"></td>
</tr>
</table>
</form></center>
</body>
</html>
~;

	exit;

}

###################
sub setup_config3 {
###################

	$indexfile = "$input{'cgi'}";

	open(FILE, ">$input{'basedir'}/index.html");

	print FILE
qq~<html><head><title>$input{'pagetitle'}</title>
<META NAME="revisit" CONTENT="12 days">
<meta NAME="Robot" CONTENT="allow">
</head>
<body>
<script language="javascript">window.location="$input{'pageurl'}/$indexfile";</script>
Click <a href="$input{'pageurl'}/$indexfile">here</a> to enter site<br>
</body>
</html>
~;

	close(FILE);

	print qq~<html>
<title>Finished $installscriptname Installation!
</title>
<body>
<br>
>>> index.html edited<br><br>
>>> Finished Installation!<br><br>
Follow the link <a href="./$indexfile">here</a> to go to your main page.<br>
</body>
</html>
~;

	if (-e "./install.cgi") {unlink("./install.cgi")}
	unlink("./install-saveconfig.cgi");

	exit;

}

#############
sub getinfo {
#############

	$scriptpath = $ENV{SCRIPT_FILENAME};
	$hosturl = $ENV{SERVER_NAME};
	$rootpath = $ENV{DOCUMENT_ROOT};
	$smtpfun = $ENV{SERVER_NAME};

	# enhancement by Abwyn and Jos to find subdirectory if necessary:
	$subdir = $ENV{SCRIPT_NAME};
	$subdir =~ s/^\/(.*)\/install-saveconfig\.cgi$/$1/ig; # cgi-bin/subfolder

	$cookiestring = "$hosturl"; # pagename
	$cookiestring =~ s/\W|_//ig;
	$cookiestring =~ s/^www//ig;
	$cookienameuid = $cookiestring . "uid";
	$cookienamepwd = $cookiestring . "pwd";
	$cookienamethm = $cookiestring . "thm";
	$cookienamelng = $cookiestring . "lng";
	$webappurl  = "http://$hosturl/$subdir"; # scripturl and pageurl
	$webappurl =~ s/\/$//; # if no subfolder
	$scriptpath=~ s/\/[^\/]*$//isg;

}

################
sub getoldinfo {
################

	my $readfile = "./conf/config.dat";

	if (-s $readfile) {
		require "config.pl";

		$scriptpath = $scriptdir;
		$rootpath = $basedir;

		$cookienameuid = $cookieusername;
		$cookienamepwd = $cookiepassword;
		$cookienamethm = $cookieusertheme;
		$cookienamelng = $cookieuserlang;
		$webappurl  = $pageurl;
	}

}

#################
sub getconfigpl {
#################

	my $readfile = "./conf/config.dat";

	if (-s $readfile) {
		require "config.pl";
	} else {
		$newinstall = 1;
	}

}

1;