#!/usr/bin/perl -w

###############################################################################
###############################################################################
# WebAPP NE (Network Edition) - Web Automated Perl Portal                     #
#-----------------------------------------------------------------------------#
# mods/calendar/index.cgi                                                     #
# Calendar Mod                                                                #
# Based on Mod for WebAPP created by Ted Loomos (tloomos@pbs-inc.net),        #
# based on the verysimple organizer suite:                                    #
# ########################################################################### #
# Copyright (c) 2001 Jason M. Hinkle. All rights reserved. This script is
# free software; you may redistribute it and/or modify it under the same
# terms as Perl itself.
# For more information see: http://www.verysimple.com/scripts/
# LEGAL DISCLAIMER:
# This software is provided as-is.  Use it at your own risk.  The
# author takes no responsibility for any damages or losses directly
# or indirectly caused by this software.
# ########################################################################### #
# Version History - Ted Loomos                                                #
# 0.0.1 - 06/09/02 - Initial script created                                   #
# 0.0.2 - 06/24/02 - Cleaned up code and fixed minor bugs                     #
# ******************************************************************          #
# Upgraded for 0.9.9.3 by Jos Brown (www.bantychick.com), including:          #
# Toggle Drop Down Entry Blocks                                               #
# Spider Discouragement                                                       #
# Thank You and Approval Pending Message for Guests                           #
# HTML W3C Validation                                                         #
# CSS Style Sheet Integration                                                 #
# Side by Side No Details                                                     #
# ******************************************************************          #
# Upgraded for WebAPP NE v0.9.9.3.4 by Jos Brown, including:                  #
# American or European Dates Format Options                                   #
# XSS Vulnerability Patch                                                     #
# WebAPP getcgi Integration                                                   #
# ******************************************************************          #
# and by sburg, including:                                                    #
# Modify to display approval message when approval needed not just for guest  #
# Added link to actual event text                                             #
# Added line to correct the display of the details with <cr><lf>.             #
# Added alignment and underline of event detail headings                      #
# ******************************************************************          #
#                                                                             #
# Modified: Dec 3 2005 by Jos ("bantychick") for WebAPP v0.9.9.3              #
# Modified: Apr 3, May 11, 25 June, 9 Aug 2006 by Jos                         #
# Modified: 16 June 2006 by my2cents                                          #
# Modified: 19 July 2006 by sburg                                             #
#                                                                             #
# To Do:                                                                      #
###############################################################################
###############################################################################

$| = 1;
use CGI::Carp qw(fatalsToBrowser);

BEGIN {
	##--------------------------------------------------------------
	## If you are not using standard folder locations, the following
	## line may need to be changed to match your installation
	##--------------------------------------------------------------

	require "../../config.pl";
	require "$mods_dir/calendar/data/calendar.cfg";
	require "$lang";
	require "$sourcedir/subs.pl";

	##--------------------------------------------------------------
	## Nothing below this point should require modification
	##--------------------------------------------------------------

	push(@INC,$cm_scriptDir);
}

eval {
	if ($IIS != 2) {
		if ($IIS == 0) {
			if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) { $IIS = 1; }
		}
		if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) { chdir($1); }
		if ($IIS == 1) { print "HTTP/1.0 200 OK\n"; }
	}
};

if ($@) {
	print "Content-type: text/html\n\n";
	print qq~<h1>Software Error:</h1>
		Execution of <b>$scriptname</b> has been aborted due a compilation error:<br>
		<pre>$@</pre>
		<p>If this problem persists, please contact the webmaster and inform him about date and time you've received this error.</p>
		~;
	exit;
}

$anonuser = "Guest";
@months = qw(January February March April May June July August September October November December);
@days = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);

getcgi();
getdate();
loadcookie(); # needs months days
loaduser();
logips();
&ban; # needs username realname anonuser months days first
logvisitors();
&getver;

if ($action) {
	if ($action eq "data_error") { &data_error; }
	if ($action eq "refernote") { error("$err{'049'}"); } 
}

use vars qw($delimiter);

if (-e "$cm_langDir/$userlang") {require "$cm_langDir/$userlang"} else {require "$cm_langDir/$cm_langFileName"}

use vsLock;
use vsDB;

# Set file paths
my ($dataFile)	  = "$cm_dataDir/$cm_eventsFileName";

# Default to view today unless a date is passed in
my ($month) = $info{'vsMonth'} || abs($mon_num); # from the global (has zero prepended)
my ($year) = $info{'vsYear'} || $year; # a global
my ($day) = $info{'vsDay'} || abs($mday); # from the global (has zero prepended)
my ($command) = $input{'vsCOM'} || $info{'vsCOM'} || "";
my ($id) = $input{'vsID'} || $info{'vsID'} || "";

# Set options based on whether details are showing (large/small calendar view)
my ($showDayDetails) = $info{'vsSD'} || 0;
if ($showDayDetails) {
	$calCellSize	= $cml_cellSize;
	$calBorderStyle = $cml_borderStyle;
	$calBorderWidth = $cml_borderWidth;
} else {
	$calCellSize	= $cms_cellSize;
	$calBorderStyle	= $cms_borderStyle;
	$calBorderWidth = $cms_borderWidth;
}

# Initialize the datafile
my ($objDB) = new vsDB(
	file => $dataFile,
	delimiter => $delimiter,
);

# lock the datafile
my ($objLock) = new vsLock(-warn => 1, -max => 5, delay => 1);
if ($cm_useFileLocking) {
   $objLock->lock($dataFile) || &die("Couldn't Lock Datafile\n");
}
if (!$objDB->Open) {print $objDB->LastError;$objLock->unlock($dataFile);CORE::die();};

## --------- Main Logic --------------
if ($command eq "UPDATE") {
	$objDB->Filter("ID","eq",$id);
	UpdateCurrentRecord($objDB,$objCGI);
	$objDB->RemoveFilter;
	$objDB->MoveFirst;
} elsif ($command eq "DELETE") {
	$objDB->Filter("ID","eq",$id);
	$objDB->Delete;
	$objDB->Commit;
	$objDB->RemoveFilter;
	$objDB->MoveFirst;
} elsif ($command eq "INSERT") {
	$objDB->AddNew;
	my ($newId) = $objDB->Max("ID") || 0;
	$newId = int($newId) + 1;
	$objDB->FieldValue("ID",$newId);
	UpdateCurrentRecord($objDB,$objCGI);
	$objDB->MoveFirst;
}

# unlock the datafile
if ($cm_useFileLocking) {
	$objLock->unlock($dataFile);
}
# display approval message when approval needed not just for guest - sburg
if ((($command eq "INSERT") && ($cm_requireAdminApproval eq "1") && ($userrank ne $root)) && (($username eq $anonuser) || ($input{'OWNER'} eq $cal_msg{'008'}))) {

	# print thank you message if guest submission (admin must approve)
	$navbar = "$btn{'014'} $msg{'166'}";
	&print_top;
	print qq~$msg{'166'}. Your addition will appear once it is approved.
	<a href="$pageurl/$cgi">$nav{'052'}</a>~;
	&print_bottom;
} else {
	# ----------- print everything to the browser ---
	$navbar = "&nbsp;$btn{'014'}&nbsp; $cm_title";
	print_top();

	&PrintDefault;

	print_bottom();

}

# release objs
undef($objDB);
undef($objLock);
undef($objCGI);

##################
sub PrintDefault {
##################

	# keep all the sections aligned:
	print qq~<table align="center" cellpadding="0" cellspacing="0" border="0">
<tr>
<td>~;

	# figure out which day to highlight on the calendar
	my ($highlightDate) = $year . "." . $month . "." . $day;

	# figure out following & previous month & year
	my ($nmonth) = $month;
	my ($nyear)  = $year;
	NextMonth(\$nmonth,\$nyear);
	my ($pmonth) = $month;
	my ($pyear)  = $year;
	PreviousMonth(\$pmonth,\$pyear);

	# display the calendar(s)
	if ($showDayDetails) {
		&PrintMonth($month,$year,$objDB,$highlightDate);
	} else { # no details show 2 cals side by side
		print qq~<table align="center" cellspacing="0" cellpadding="10" border="0">
<tr>
<td valign='top'>~;
		&PrintMonth($month,$year,$objDB,$highlightDate);

		print qq~</td>
<td>~;
		&PrintMonth($nmonth,$nyear,$objDB,$highlightDate);
		print qq~</td>
</tr>
</table>
~;
	}

	# show the event details for the day
	&PrintDay($year,$month,$day,$objDB);

	if ($command eq "EDIT") {
		$objDB->Filter("ID","eq",$id);
		PrintCurrentRecord($objDB);
	} else {
		PrintBlankRecord($objDB);
	}

	# display the navigation

	print qq~<form>
<div style="text-align: center">~;

	# stop excessive spidering into remote years by robots - Jos
	if ($username ne $anonuser) { 
		print qq~<a
 href="$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$month&vsYear=~ . ($year - 1) . qq~">&lt;&lt;</a>&nbsp;<a
 href="$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$pmonth&vsYear=$pyear">&lt;</a>&nbsp;~;
	}

	print qq~<select name="month" onchange="document.location='$cm_scriptUrl?vsSD=$showDayDetails&' + this.options[this.selectedIndex].value;return true;">
<option value="vsMonth=$pmonth&vsYear=$pyear">$pmonth / $pyear</option>
<option value="vsMonth=$month&vsYear=$year" selected>$month / $year</option>
~;

	my ($nM) = $month;
	my ($nY) = $year;
	for (my $count = 1;$count < 12;$count++) {
		NextMonth(\$nM,\$nY);
		print qq~<option value="vsMonth=$nM&vsYear=$nY">$nM / $nY</option>
~;
	}

	print "</select>";

	if ($username ne $anonuser) { # stops excessive spidering into remote years by robots
		print qq~&nbsp;<a
 href="$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$nmonth&vsYear=$nyear">&gt;</a>&nbsp;<a
 href="$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$month&vsYear=~ . ($year + 1) . qq~">&gt;&gt;</a>~;
	}

	print qq~</div>
</form><br>~;

	print qq~</td>
</tr>
</table>
<br>
~;

}

##############
sub PrintDay {
##############

	my $year = shift || return 0 ;
	my $month = shift || return 0 ;
	my $day = shift || return 0 ;
	my $objMyDb = shift || return 0;

	my $thisDate = "$year.$month.$day";

	# add a filter to get the event details for the day
	$objMyDb->RemoveFilter;
	$objMyDb->Filter("DATE","eq",$thisDate);

	if ($userrank ne $root) {
		if ($username eq $anonuser) {
			$objMyDb->Filter("APPROVED","eq","1");
			$objMyDb->Filter("OWNER","eq","$cal_msg{'008'}");
		} else {
			$objMyDb->Filter("APPROVED","eq","1");
			$objMyDb->Filter("OWNER","eq","$cal_msg{'008'}");
			$objMyDb->Filter("OWNER","eq","$username",1);
			$objMyDb->Filter("DATE","eq",$thisDate);
		}
	}

	print "<div><b>$cal_msg{'003'} $months[$month-1] $day, $year </b></div>";

	# check for no events found and display message if appropriate
	if ($objMyDb->EOF) {
		print "<div>$cal_msg{'006'}</div>";
	} else {
		print qq~<table>
<tr>
<td width="25">&nbsp;</td>
<td width="75"><b>$cal_msg{'004'}</b></td>
<td width="250"><b>$cal_msg{'005'}</b></td>
</tr>
~;
		# display each event record in table
		# link to actual event text - sburg
		while (!$objMyDb->EOF) {
			print qq~<tr>
<td><a href="$cm_scriptUrl?vsSD=$showDayDetails&vsCOM=EDIT&vsMonth=$month&vsYear=$year&vsDay=$day&vsID=~ . $objMyDb->FieldValue("ID") . qq~"><img
 src="$cm_detailIconUrl" alt="$cal_msg{'001'}" title="$cal_msg{'001'}" border="0"></a></td>
<td>~ . $objMyDb->FieldValue("TIME") . qq~&nbsp;</td>
<td><a href="$cm_scriptUrl?vsSD=$showDayDetails&vsCOM=EDIT&vsMonth=$month&vsYear=$year&vsDay=$day&vsID=~ . $objMyDb->FieldValue("ID") . qq~">~ . $objMyDb->FieldValue("EVENT") . qq~&nbsp;</a></td>
</tr>
~;
			$objMyDb->MoveNext;
		}
		print "</table>\n";
	}

}

################
sub PrintMonth {
################

   my $month = shift || 1;
	my $syear = shift || 2001;
	my $objMyDb = shift || return 0;
	# highlightDate is passed in below...

	my ($firstDay,$numDays,$numWeeks,@weekdays) = &GetMonthInfo($month,$syear);

	my $temp;
	my $dayCount = 0;
	my $weekDayCount = 0;
	my $thisDate;
	my $style;

	my $today = $year . "." . abs($mon_num) . "." . abs($mday);

	my $highlightDate = shift || $today;

	# print calendar heading
	print qq~<br>
<table align="center" cellspacing="0" border="$calBorderWidth" style="$calBorderStyle">
<tr>
<td colspan="7" class="menutable" style="$cm_headFontStyle"><b>$months[$month-1] $syear</b>~;

	print qq~</td>
</tr>
~;

	# print the days of the week
	print "<tr>\n";
	# use days of week sorted for European or American display - Jos:
	foreach $temp(@weekdays) {
		print "<td width=\"$calCellSize\" style=\"$cm_dayHeadCellStyle\"><b>$temp</b></td>";
	}
	print "</tr>\n";

	# print the detail section of the calendar
	for (my $cellCount = 1;$cellCount <= $numWeeks; $cellCount++) {
		print "<tr valign='top'>\n";
		foreach $temp (@daysAbbrev) {
			if (($dayCount > $firstDay-1) && ($weekDayCount < $numDays)) {
				$weekDayCount++;

				$thisDate = $syear . "." . $month . "." . $weekDayCount;

				# format cell appropriately based on whether we're processing the highlighted date
				if ($thisDate eq $highlightDate) {
					print "<td height=\"$calCellSize\" style=\"$cm_selCellStyle\">";
				} else {
					print "<td height=\"$calCellSize\" style=\"$cm_stdCellStyle\">";
				}

				# get the style to apply to text for this day
				if ($thisDate eq $today) {
					$style = $cm_todayFontStyle;
				} elsif ($thisDate eq $highlightDate) {
					$style = $cm_selFontStyle;
				} else {
					$style = $cm_stdFontStyle;
				}

				# determine if there are any events for this day visible to the current user
				$objMyDb->RemoveFilter;
				$objMyDb->Filter("DATE","eq",$thisDate);

				if ($userrank ne $root) {
					if ($username eq $anonuser) {
						$objMyDb->Filter("APPROVED","eq","1");
						$objMyDb->Filter("OWNER","eq","$cal_msg{'008'}");
					} else {
						$objMyDb->Filter("APPROVED","eq","1");
						$objMyDb->Filter("OWNER","eq","$cal_msg{'008'}");
						$objMyDb->Filter("OWNER","eq","$username",1);
						$objMyDb->Filter("DATE","eq",$thisDate);
					}
				}

				# if events exist that are visible to this user, format font appropriately
				if ($objMyDb->EOF) {
					print "<a style=\"$style\" href=\"$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$month&vsYear=$syear&vsDay=$weekDayCount\">$weekDayCount</a><br>";
				} else {
					print "<b><a style=\"$style\" href=\"$cm_scriptUrl?vsSD=$showDayDetails&vsMonth=$month&vsYear=$syear&vsDay=$weekDayCount\">$weekDayCount</a></b><br>";
				}

				# show the events for the day if in "Show Details" mode
				if ($showDayDetails) {
					print "<font size=\"1\">";
					while (!$objMyDb->EOF) {
						print "<a style=\"$style\" href=\"$cm_scriptUrl?vsSD=$showDayDetails&vsCOM=EDIT&vsMonth=$month&vsYear=$syear&vsDay=$weekDayCount&vsID=" . $objMyDb->FieldValue("ID") . "\">" .$objMyDb->FieldValue("EVENT") . "</a><br>";
						$objMyDb->MoveNext;
					}
					print "</font>";
				}
				print "</td>\n";
			} else {
				# empty cell
				print "<td style=\"$cm_emptyCellStyle\">&nbsp;</td>\n";
			}

			$dayCount++;
		}
		print "</tr>\n";
	}
	print "</table>\n";

	print "<div align=\"center\">\n";
	if ($showDayDetails) {
		print "<a href=\"$cm_scriptUrl?vsSD=0&vsMonth=$month&vsYear=$syear\">$cal_msg{'002'}</a>";
	} else {
		print "<small>[<a href=\"$cm_scriptUrl?vsSD=1&vsMonth=$month&vsYear=$syear\">$cal_msg{'001'}</a>]</small>";
	}
	print "</div><br>\n";

}


# _____________________________________________________________________________
sub GetMonthInfo {

	my $month = shift || 1;
	my $year = shift || 2001;

	my($firstDow,$numDays);

	require Time::Local;

	# convert user input into approp format for proc4essing
	--$month;
	$year -= 1900;

	# figure out following month & year
	my $nmonth = $month + 1;
	my $nyear  = $year;
	if ($nmonth > 11) {
	$nmonth = 0;
	$nyear++;
	}

	# ready to grab first day of the month (0 based array)
	$firstDow  = (localtime(Time::Local::timelocal(0,0,0,1,$month,$year)))[6];
	# numDays is one day prior to 1st of month after
	$numDays = (localtime(Time::Local::timelocal(0,0,0,1,$nmonth,$nyear) - 60*60*24))[3];

	# check for first day of week - Jos
	my @weekdays = @daysAbbrev;
	if ($user_check_date eq 'european') {
		$firstDow -= 1;
		$firstDow += 7 if ($firstDow < 0);
		my $lastday = shift(@weekdays);
		push(@weekdays, $lastday);
	}

	# figure out the number of weeks the month spans across
	my $numWeeks = ($numDays + $firstDow) / 7;
	$numWeeks = int($numWeeks) + 1 unless ($numWeeks == int($numWeeks));

	return ($firstDow,$numDays,$numWeeks,@weekdays);

}


########################
sub PrintCurrentRecord {
########################

	my ($objMyDB) = shift;
	my ($fieldName, $fieldValue);
	my ($recType)   = "New";
	my ($userType)  = "Guest";
	my ($recAccess) = "Read Only";

	if ($objMyDB->FieldValue("ID")) {
		$recType = "Existing";
	}

	if ($username ne $anonuser) {
		if ($userrank eq $root) {
			$userType = "Admin";
		} else {
			$userType = "Member";
		}
	}

	if ((($username ne $anonuser) && ($objMyDB->FieldValue("SOURCE") eq $username)) ||
		$userType eq "Admin" ||
		$recType eq "New") {
		$recAccess = "Read Write";
	}
	# show formatted record for selected event
	if ($recType eq "Existing") {
		print "<p>\n";
		print "<b>$cal_msg{'007'}</b><br>\n";
		print "$months[$month-1] $day, $year<br>";
		print "<table cellspacing=\"2\" cellpadding=\"2\" border=\"0\">\n";

		foreach $fieldName ($objMyDB->FieldNames) {
			$cleanFieldName = $fieldName;
			$cleanFieldName =~ s/[\n\r]//g;

			if ($cleanFieldName eq "TIME" ||
				$cleanFieldName eq "EVENT" ||
				$cleanFieldName eq "DETAILS") {

				# show record in read-only format (no form)
				print "<tr>\n";
				# alignment and underline of event detail headings - sburg
				print "<td valign=\"top\"><u>" . $cal_db{$cleanFieldName} . "</u></td>\n"; 
				$fieldValue = $objMyDB->FieldValue($fieldName);
				$fieldValue =~ s/\"/&quot;/g;
				# correct the display of the details with <cr><lf> - sburg
				$fieldValue =~ s/[\n]/\<BR\>/g;
				print "<td>" . $fieldValue . "</td>\n";
				print "</tr>\n";
			} elsif ($cleanFieldName eq "WEBSITE") {
				print "<tr>\n";
				print "<td>" . $cal_db{$cleanFieldName} . "</td>\n";
				print "<td>";
				$fieldValue = $objMyDB->FieldValue($fieldName);
				# hide links with default http:// and no URL - Jos
				if ($fieldValue !~ /^http:\/\/\W*$/) {
					$fieldValue =~ s/\"/&quot;/g;
					print "<a href=" . $fieldValue . " target='_blank'>" . $msg{'451'} . "</a>";
				}
				print "</td>\n";
				print "</tr>\n";
			}
		} # end foreach
		print qq~<tr>
<td>~ . $cal_db{'SOURCE'} . qq~</td>
	~;
		$fieldValue = $objMyDB->FieldValue('SOURCE');
		$fieldValue =~ s/\"/&quot;/g;
		print qq~<td>$fieldValue</td>
</tr>
</table>
~;
	}
	# for editable record:
	if ($recAccess eq "Read Write") {
		my $headertext = "";
		print qq~&nbsp;<a href="#" OnClick="return toggle('calendar')">~;
		if ($recType eq "New") {
			print "\*$cal_msg{'019'}\*";
			$headertext = qq~<b>$cal_msg{'007'}</b><br>
$months[$month-1] $day, $year<br>
~;
		} else {
			print "$btn{'015'}";
		}
		print qq~</a>
<div id="calendar" style="display:none">~;
		print "<form action='$cm_scriptUrl' method='post'>\n";
		print "$headertext";
		print "<table cellspacing=\"2\" cellpadding=\"2\" border=\"0\">\n";

		foreach $fieldName ($objMyDB->FieldNames) {
			$cleanFieldName = $fieldName;
			$cleanFieldName =~ s/[\n\r]//g;
			if ($cleanFieldName eq "ID") {
				print "<input type='hidden' name='vsID' value='" . $objMyDB->FieldValue("ID") . "'>\n";
			} elsif ($cleanFieldName eq "SOURCE") {
				if ($recType eq "Existing") {
					# retain original creator of event for existing events
					print "<input type='hidden' name='SOURCE' value='" . $objMyDB->FieldValue($fieldName) . "'>\n";
				} else {
					# save current user as creator of event for new events
					print "<input type='hidden' name='SOURCE' value='" . $username . "'>\n";
				}
			} elsif ($cleanFieldName eq "DATE") {
				if ($recType eq "Existing") {
					print "<input type='hidden' name='DATE' value='" . $objMyDB->FieldValue("DATE") . "'>\n";
				}
			} elsif ($cleanFieldName eq "APPROVED") {
				if ($recType eq "Existing") {
					if ($userType eq "Admin") {
						# allow admins to change approval on existing events
						print "<TD>$cal_db{$cleanFieldName}</TD>\n";
						print "<TD><select size='1' name='$cleanFieldName'>\n";
						if ($objMyDB->FieldValue("APPROVED") == 1) {
							print "<option value='1' selected>$cal_opt{'001'}</option>\n";
							print "<option value='0'>$cal_opt{'002'}</option>\n";
						} else {
							print "<option value='1'>$cal_opt{'001'}</option>\n";
							print "<option value='0' selected>$cal_opt{'002'}</option>\n";
						}
						print "</select>\n";
					} else {
						print "<input type='hidden' name='APPROVED' value='" . $objMyDB->FieldValue("APPROVED") . "'>\n";
					}
				} else {
					# auto-approve events entered by the admin
					if ($userType eq "Admin") {
						print "<input type='hidden' name='APPROVED' value='1'>\n";
					} else {
						print "<input type='hidden' name='APPROVED' value='0'>\n";
					}
				}
			} elsif ($cleanFieldName eq "OWNER") {
				if ($userType eq "Guest") {
					# make all guest events public
					print "<input type='hidden' name='OWNER' value=\"$cal_msg{'008'}\">\n";
				} else {
					# allow the user to select whether the event is public or private
					print "<tr valign='top'>\n";
					print "<td><font face='arial' size='2'>" . $cal_db{$cleanFieldName} . "</font></td>\n";
					$fieldValue = $objMyDB->FieldValue($fieldName);
 					if ($recType eq "Existing") {
	 					# display owner of existing events - do not allow modification
 						print "<td>$fieldValue</td>\n";
						print "<input type='hidden' name='OWNER' value='" . $objMyDB->FieldValue($fieldName) . "'>\n";
					} else {
						# allow new events to be public or private
						print "<td><input type='radio' value=\"$cal_msg{'008'}\" name='OWNER' CHECKED>$cal_msg{'008'}";
						print "	<input type='radio' value='$username' name='OWNER'>$cal_msg{'018'} $realname</TD>\n";
 					}
					print "</tr>\n";
				}
			} elsif ($cleanFieldName eq "DETAILS") {
				print "<tr valign='top'>\n";
				print "<td><font face='arial' size='2'>" . $cal_db{$cleanFieldName} . "</font></td>\n";
				print "<td><textarea name='DETAILS' cols='30' rows='3'>";
				$fieldValue = $objMyDB->FieldValue($fieldName);
				$fieldValue =~ s/\"/&quot;/g;
				print $fieldValue . "</textarea></td>\n";
				print "</tr>\n";
			} else {
				print "<tr valign='top'>\n";
				print "<td><font face='arial' size='2'>" . $cal_db{$cleanFieldName} . "</font></td>\n";
				print "<td><input type=\"text\" class=\"textinput\" size=\"40\" name=\"" . $fieldName . "\" value=\"";
				$fieldValue = $objMyDB->FieldValue($fieldName);
				$fieldValue =~ s/\"/&quot;/g;
				print $fieldValue . "\"></td>\n";
				print "</tr>\n";
			}
		} # end foreach
	} # end editable record
 	print "</table>\n";
 	print "<p>\n";
	if ($recAccess eq "Read Write") {
		print "<input type='hidden' name='vsSD' value='$showDayDetails'>\n";
		print "<input type='hidden' name='vsDay' value='$day'>\n";
		print "<input type='hidden' name='vsMonth' value='$month'>\n";
		print "<input type='hidden' name='vsYear' value='$year'>\n";
		if ($recType  eq "Existing") {
			print "<input type='hidden' name='vsCOM' value='UPDATE'>\n";
			print "<input type='submit' value=\"$cal_btn{'003'}\" class=\"button\">\n";
			print "<input type='submit' value=\"$cal_btn{'004'}\" class=\"button\" onclick=\"if (confirm('".$cal_msg{'009'}."')) {self.location='$cm_scriptUrl?vsSD=$showDayDetails&vsCOM=DELETE&vsMonth=$month&vsYear=$year&vsDay=$day&vsID=" . $objMyDB->FieldValue("ID") . "';return false;} else {return false;};\">\n";
			print "<input type='reset' value=\"$cal_btn{'001'}\" class=\"button\" onclick=\"window.history.go(-1);return false;\">\n";
		} else {
			print "<input type='hidden' name='DATE' value='$year.$month.$day'>\n";
			print "<input type='hidden' name='vsCOM' value='INSERT'>\n";
			print "<input type='submit' value=\"$cal_btn{'002'}\" class=\"button\">\n";
			print "<input type='reset' value=\"$btn{'009'}\" class=\"button\" onclick=\"window.history.go(-1);return false;\">\n";
		}
		print "</form>\n";
		print "</div>";
		# print direct link to day page to add new - Jos
		if ($recType  eq "Existing") {
			print qq~<br><a href="$cm_scriptUrl/?vsSD=$showDayDetails&vsMonth=$month&vsYear=$year&vsDay=$day">*$cal_msg{'019'}*</a>~;
		}
 	}

}

#_____________________________________________________________________________
sub PrintBlankRecord {
	my ($objMyDB) = shift;
	$objMyDB->AddNew;
	PrintCurrentRecord($objMyDB); # this won't be committed, so no big deal
	return 1;
}

#_____________________________________________________________________________
sub UpdateCurrentRecord {
	my ($objMyDB) = shift;
	my ($input) = shift;
	my ($fieldName,$fieldValue);
	foreach $fieldName ($objMyDB->FieldNames) {

		$fieldValue = $input{$fieldName};

		if ($fieldName eq 'APPROVED') {
			#If this is an approved public event, keep it approved
			if ($input{'OWNER'} ne $cal_msg{'008'} || $cm_requireAdminApproval == 0) {
				$fieldValue = '1';
			} else {
				$fieldValue = $input{$fieldName};
			}

			#Notify admin of new unapproved public event
			if ($command eq "INSERT" && $fieldValue eq '0' && $cm_emailAdminNewEventNotice == 1) {
				$subject = "New Event: ".$input{"EVENT"};
				$message  = "A new event has arrived - please review it.\n\n";
				$message .= "Event:			".$input{"EVENT"}."\n";
				$message .= "Date:			".$input{"DATE"}."\n";
				$message .= "Time:			".$input{"TIME"}."\n";
				$message .= "Website:		".$input{"WEBSITE"}."\n";
				$message .= "Created by:	".$input{"SOURCE"}."\n";
				$message .= "Details:		".$input{"DETAILS"}."\n";
				$from = "$webmaster_email (Event Manager)";

				sendemail($cm_eventAdminEmailAddress, $subject, $message, $from);
			}
		}

		if ($fieldName eq 'WEBSITE') {
			#website address must start with http:// - append it if it isn't there.
			if ($fieldValue !~ m/^http:\/\//i) {
				$fieldValue = "http://" . $fieldValue;
			}
		}

		$objMyDB->FieldValue($fieldName,$fieldValue);
	}
	$objMyDB->Commit;

}

#_____________________________________________________________________________
sub NextMonth {
	#	NextMonth(\$month,\$year);
	#  using slashed passed var by reference and values are modified by the sub
	my ($nMonth) = shift || return 0;
	my ($nYear) = shift || return 0;
	$$nMonth++;
	if ($$nMonth > 12) {
		$$nMonth = 1;
		$$nYear++;
	}
}

#_____________________________________________________________________________
sub PreviousMonth {
	# PreviousMonth(\$month,\$year);
	#  using slashed passed var by reference and values are modified by the sub
	my ($nMonth) = shift || return 0;
	my ($nYear) = shift || return 0;
	$$nMonth--;
	if ($$nMonth < 1) {
		$$nMonth = 12;
		$$nYear--;
	}
}

1;